import arcpy
import sys, subprocess, inspect
import os.path

def etFound():
     found = False
     etgwPath = ""
     try:
          import _winreg
          try:
               hKey = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE,r"SOFTWARE\ETSpatialTechniques\ETGeoWizards",0,_winreg.KEY_READ|_winreg.KEY_WOW64_64KEY)
               found = True
          except:
               try:
                    hKey = _winreg.OpenKey(_winreg.HKEY_CURRENT_USER,r"SOFTWARE\ETSpatialTechniques\ETGeoWizards",0,_winreg.KEY_READ|_winreg.KEY_WOW64_64KEY)
                    found = True
               except:
                    found = False
     except:
          import winreg
          try:
               hKey = winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE,r"SOFTWARE\ETSpatialTechniques\ETGeoWizards",0,winreg.KEY_READ|winreg.KEY_WOW64_64KEY)
               found = True
          except:
               try:
                    hKey = winreg.OpenKey(winreg.HKEY_CURRENT_USER,r"SOFTWARE\ETSpatialTechniques\ETGeoWizards",0,winreg.KEY_READ|winreg.KEY_WOW64_64KEY)
                    found = True
               except:
                    found = False
     if found:
          try:
               myPath = _winreg.QueryValueEx(hKey,"InstallPath")[0]
               etgwPath = myPath+r"ETGWRun.exe"
               _winreg.CloseKey(hKey)
          except:
               myPath = winreg.QueryValueEx(hKey,"InstallPath")[0]
               etgwPath = myPath+r"ETGWRun.exe"
               winreg.CloseKey(hKey)
          if os.path.exists(etgwPath):
               found = True
          else:
               found = False

     return [found,etgwPath]
etgwPath = etFound()[1]
inputVal = ""

class Toolbox(object):
    def __init__(self):
        self.label =  "ETGeoWizards12"
        self.alias  = "ETGeoWizards"
        # List of tool classes associated with this toolbox
        toolList = []
        basicTools = [ExplodeMultipart, MoveShapes,RotateShapes,ScaleShapes,SortShapes,Buffer,ProjectLayer,SelectAndExport]
        convertTools1 = [PolylinesToPoints,PolygonsToPoints,MultipointsToPoints,PolygonsToPolylines,PolylinesToMultipoints,ShapeToShapeZ,ShapeZMToShape]
        convertTools2 = [MultipointsToPolylines,PolylinesToPolygons,PointsToPointsZM,PointsToPolylines,PointsToPolygons,PointsToMultipoints]
        pointTools1 = [CleanPoints,StationPoints,ConnectPoints,DispersePoints,PointsToRectangles,PointsToRegularPolygons,PointsAngleAndPosition]
        pointTools2 = [SnapPoints,ReverseGeocoding,PerpendicularsToPolylines,PointIntersection,ThinPoints]
        polylineTools1 = [GeneralizePolylines,DensifyPolylines,SmoothBezier,SmoothBSpline,SmoothTSpline,PolylineZCharacteristics,PolylineCharacteristics,ExportNodes]
        polylineTools2 = [CleanContourGaps,FlipPolylinesZ,FlipPolylinesBasedOnPoint,RenodePolylines,SnapPolylines,BufferPolylines,CleanPseudoNodes,SplitPolylines]
        polylineTools3 = [SplitPolylinesWithLayer,CleanPolylines,CleanDangles,SelectAndFlip]
        polygonTools1 = [DissolvePolygons,FillPolygonHoles,CleanGaps,PolygonCharacteristics,CleanPolygons,BuildPolygons,CreateCenterlines,AggregatePolygons]
        polygonTools2 = [GeneralizePolygons,DensifyPolygons,SmoothPolygonsBSpline,SmoothPolygonsTSpline,SmoothPolygonsBezier,PolygonAdjacency]
        polygonTools3 = [PolygonsToPolylinesAdvanced,PartitionPolygonsWithPolylines,SnapPolygons,Eliminate,TriangulatePolygons]
        overlayTools1 = [Clip,Erase,SymmetricalDifference,MergeLayers,MergeMulti,RemoveDuplicates,TransferAttributes,IntersectPolygons]
        overlayTools2 = [BatchClip,BatchErase,SplitByLocation,SplitByAttributes,AdvancedMerge]
        samplingTools1 = [VectorGridExtent,PointGridExtent,CreateTilesExtent,CreateTilesOrigin,VectorGridOrigin,PointGridOrigin]        
        samplingTools2 = [UniformPointsInPolygons,RandomPointsInPolygons,RandomPointsOnPolylines,PointGridsInPolygons,SquareGridsInPolygons]
        miscTools1 = [PointsToPieSegments,LinesFromPointDirDist,FeaturesToEnvelopes,FeaturesToRectangles,FeaturesToCircles,FeaturesToConvexPolygons,CogoInverse]
        miscTools2 = [PolygonsToEqualAreaCircles,PolygonsToMaxInscribedCircles,PolygonsToDeepestPoints,CreateStationLines,PointsAlongPolylines,PointsToClusterPolygonsC]
        srelTools1 = [NearFeature,SpiderDiagram,SpiderDiagramAttributeLink,Allocate,BuildThiessen,CreateConcaveHull,ConvexHull,PointsToClusterPolygonsS]
        srelTools2 = [ClosestFeatureDistance,SpatialJoin,TransferPolylineAttributes,FindClosestPoint,ConnectToClosestPoint,ConnectUnstructuredPoints]
        fieldTools = [DeleteMultipleFields,OrderFields,CopyFields,RedefineFields,RenameFields]
        inOutTools = [ExportToGoogle,ImportFromGoogle,Generate,Ungenerate,ImportFromMapInfo,ImportFromDXF,ImportFromGeoJson,ImportFromOSM,ExportToGeoJson,ExportToGeoPackage,ImportFromGeoPackage]
        linRefTools = [CreateRoutes,CalibrateRoutes,LocateFeaturesAlongRoutes,FeaturesFromRouteEvents,DissolveRouteEvents,ConcatenateRouteEvents]
        netTools1 = [BuildBidirectionalNetwork,ShortestPath,TravelingSalesman,ODMatrix,ClosestFacilities,AllocateBasedOnNetwork,PartitionNetwork,ServiceArea,IdentifyUnreachableLinks]
        netTools2 = [BuildSingleDirectionalNetwork,SDNFindSinks,SDNFindSources,SDNCheckForLoops,SDNTraverseNetwork,SDNClassifyStreams,SDNDelineateCatchment]
        systemTools = [ReleaseLicense]
        toolList.extend(basicTools)
        toolList.extend(convertTools1)
        toolList.extend(convertTools2)
        toolList.extend(pointTools1)
        toolList.extend(pointTools2)
        toolList.extend(polylineTools1)
        toolList.extend(polylineTools2)
        toolList.extend(polylineTools3)
        toolList.extend(polygonTools1)
        toolList.extend(polygonTools2)
        toolList.extend(polygonTools3)
        toolList.extend(overlayTools1)
        toolList.extend(overlayTools2)
        toolList.extend(samplingTools1)
        toolList.extend(samplingTools2)
        toolList.extend(miscTools1)
        toolList.extend(miscTools2)
        toolList.extend(srelTools1)
        toolList.extend(srelTools2)
        toolList.extend(fieldTools)
        toolList.extend(inOutTools)
        toolList.extend(linRefTools)
        toolList.extend(systemTools)
        toolList.extend(netTools1)
        toolList.extend(netTools2)
        self.tools = toolList


class ExplodeMultipart(object):
    def __init__(self):
        self.label       = "Explode Multipart"
        self.description = "Converts all multi-part features of a layer to single part ones. "
        self.category = "Basic"

    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline", "Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        parameters = [in_dataset, out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        etFunction = "ExplodeMultipart"
        
        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class MoveShapes(object):
    def __init__(self):
        self.label       = "Move Shapes"
        self.description = "Moves the features of a feature class according to user specified translation vector (Delta X and Delta Y)."
        self.category = "Basic"

    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # DeltaX parameter
        delta_x = arcpy.Parameter(
            displayName="Delta X",
            name="Delta_X",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # DeltaY parameter
        delta_y = arcpy.Parameter(
            displayName="Delta Y",
            name="Delta_Y",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        parameters = [in_dataset, out_dataset, delta_x, delta_y]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        deltaX  = parameters[2].valueAsText
        deltaY  = parameters[3].valueAsText
        etFunction = "MoveShapes"
        
        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,deltaX,deltaY],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class RotateShapes(object):
    def __init__(self):
        self.label       = "Rotate Shapes"
        self.description = "Rotates the features of a feature layer according to user specified rotation point and angle"
        self.category = "Basic"

    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # rotation_angle parameter
        rotation_angle = arcpy.Parameter(
            displayName="Rotation_Angle",
            name="rotation_angle",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # origin_point_dataset parameter
        origin_point_dataset = arcpy.Parameter(
            displayName="Origin Point Dataset (first point used as origin)",
            name="origin_point_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        origin_point_dataset.filter.list = ["Point"]

        # OriginX parameter
        origin_x = arcpy.Parameter(
            displayName="Origin X",
            name="Origin_X",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # OriginY parameter
        origin_y = arcpy.Parameter(
            displayName="Origin Y",
            name="Origin_Y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        parameters = [in_dataset, out_dataset, rotation_angle, origin_point_dataset, origin_x, origin_y]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional

        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if not parameters[3].valueAsText:
             if not (parameters[4].valueAsText) or not (parameters[5].valueAsText):
                  parameters[3].setWarningMessage("Origin Point Dataset or Rotation Point coordinates needed!")
        if not (parameters[4].valueAsText) or not (parameters[5].valueAsText):
             if not parameters[3].valueAsText:
                  parameters[3].setWarningMessage("Origin Point Dataset or Rotation Point coordinates needed!")
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dAngle  = parameters[2].valueAsText
        originDataset = parameters[3].valueAsText
        if originDataset:
             originDataset  = arcpy.Describe(parameters[3].value).catalogPath
        else:
             originDataset = ""
        orX  = parameters[4].valueAsText
        if not orX:
             orX = ""
        orY  = parameters[5].valueAsText
        if not orY:
             orY = ""
        etFunction = "RotateShapes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dAngle,originDataset,orX,orY],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ScaleShapes(object):
    def __init__(self):
        self.label       = "Scale Shapes"
        self.description = "Scales the features of a feature layer according to user specified anchor point X and Y scale factors."
        self.category = "Basic"

    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # scale_x parameter
        scale_x = arcpy.Parameter(
            displayName="Scale X",
            name="scale_x",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

         # scale_y parameter
        scale_y = arcpy.Parameter(
            displayName="Scale Y",
            name="scale_y",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # origin_point_dataset parameter
        origin_point_dataset = arcpy.Parameter(
            displayName="Origin Point Dataset (first point used as origin)",
            name="origin_point_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        origin_point_dataset.filter.list = ["Point"]

        # OriginX parameter
        origin_x = arcpy.Parameter(
            displayName="Origin X",
            name="Origin_X",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # OriginY parameter
        origin_y = arcpy.Parameter(
            displayName="Origin Y",
            name="Origin_Y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        parameters = [in_dataset, out_dataset, scale_x, scale_y, origin_point_dataset, origin_x, origin_y]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional

        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if not parameters[4].valueAsText:
             if not (parameters[5].valueAsText) or not (parameters[6].valueAsText):
                  parameters[4].setWarningMessage("Origin Point Dataset or Rotation Point coordinates needed!")
        if not (parameters[5].valueAsText) or not (parameters[6].valueAsText):
             if not parameters[4].valueAsText:
                  parameters[4].setWarningMessage("Origin Point Dataset or Rotation Point coordinates needed!")
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        xScale  = parameters[2].valueAsText
        yScale  = parameters[3].valueAsText
        originDataset = parameters[4].valueAsText
        if originDataset:
             originDataset  = arcpy.Describe(parameters[4].value).catalogPath
        else:
             originDataset = ""
        orX  = parameters[5].valueAsText
        if not orX:
             orX = ""
        orY  = parameters[6].valueAsText
        if not orY:
             orY = ""
        etFunction = "ScaleShapes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,xScale,yScale,originDataset,orX,orY],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SortShapes(object):
    def __init__(self):
        self.label       = "Sort Shapes"
        self.description = "Sorts the features of a feature class according to user specified fields and order methods."
        self.category = "Basic"

    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        # Sort Fields parameter
        sort_fields = arcpy.Parameter(
            displayName="Sort Fields",
            name="sort_fields",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        sort_fields.parameterDependencies = [in_dataset.name]
        sort_fields.columns = [["Field","Field"],["GPString", "SortMethod"]]
        sort_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        sort_fields.filters[1].type = "ValueList"
        sort_fields.filters[1].list = ["Ascending", "Descending"]
                
        parameters = [in_dataset, out_dataset, sort_fields]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sortList = parameters[2].valueAsText
        etFunction = "SortShapes"
                
        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sortList],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolylinesToPoints(object):
    def __init__(self):
        self.label       = "Polylines To Points"
        self.description = "Converts a polyline dataset to a point dataset. Three options available - Vertices, Nodes, Middle Points."
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_X","ET_Y"]
        fieldTypes = ["LONG","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # convert_option parameter
        convert_option = arcpy.Parameter(
            displayName="Convert Option",
            name="convert_option",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        convert_option.filter.type = "ValueList"
        convert_option.filter.list = ["Vertex", "Middle","Node"]

        # remove_duplicates
        remove_duplicates = arcpy.Parameter(
            displayName="Remove Duplicates",
            name="remove_duplicates",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        remove_duplicates.value = "False"

        # calc_point_pos
        calc_point_pos = arcpy.Parameter(
            displayName="Calculate Point Position",
            name="calc_point_pos",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        calc_point_pos.value = "False"

        # point_angle
        point_angle = arcpy.Parameter(
            displayName="Assign angle attribute",
            name="point_angle",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        point_angle.value = "False"

        # keep_z
        keep_z = arcpy.Parameter(
            displayName="Keep Z",
            name="keep_z",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_z.value = "False"

        # keep_m
        keep_m = arcpy.Parameter(
            displayName="Keep M",
            name="keep_m",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_m.value = "False"
               
        parameters = [in_dataset, out_dataset, convert_option, remove_duplicates, calc_point_pos, point_angle, keep_z, keep_m]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if (parameters[2].valueAsText == "Vertex") or (parameters[2].valueAsText == "Node"):
             fieldNames = ["ET_ID","ET_X","ET_Y","ET_ORDER","ET_IDR","ET_IDP"]
             fieldTypes = ["LONG","DOUBLE","DOUBLE","DOUBLE","LONG","LONG"]
        else:
             fieldNames = ["ET_ID","ET_X","ET_Y"]
             fieldTypes = ["LONG","DOUBLE","DOUBLE"]
             
        if parameters[5].altered:
             if parameters[5].value:
                   if "ET_ANGLE" not in fieldNames:
                        fieldNames.append("ET_ANGLE")
                        fieldTypes.append("DOUBLE")
             else:
                   if "ET_ANGLE" in fieldNames:
                        fieldNames.remove("ET_ANGLE")
        addFields = []
        for fieldInd, fieldName in enumerate(fieldNames):
              fieldType = fieldTypes[fieldInd]
              newField = arcpy.Field()
              newField.name = fieldName
              newField.type = fieldType
              addFields.append(newField) 
        parameters[1].schema.additionalFields = addFields
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sOption  = parameters[2].valueAsText
        bDup  = parameters[3].valueAsText
        bPos  = parameters[4].valueAsText
        bAng  = parameters[5].valueAsText
        bZ  = parameters[6].valueAsText
        bM  = parameters[7].valueAsText
       
        etFunction = "PolylinesToPoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sOption,bAng,bDup,bPos,bZ,bM],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolygonsToPoints(object):
    def __init__(self):
        self.label       = "Polygons To Points"
        self.description = "Converts a polygon dataset to a point dataset. Options available - Vertices, Center Points, Label Points, Center In."
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_X","ET_Y"]
        fieldTypes = ["LONG","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # convert_option parameter
        convert_option = arcpy.Parameter(
            displayName="Convert Option",
            name="convert_option",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        convert_option.filter.type = "ValueList"
        convert_option.filter.list = ["Vertex", "Center","Label","CenterIn"]

        # remove_duplicates
        remove_duplicates = arcpy.Parameter(
            displayName="Remove Duplicates",
            name="remove_duplicates",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        remove_duplicates.value = "False"

        # calc_point_pos
        calc_point_pos = arcpy.Parameter(
            displayName="Calculate Point Position",
            name="calc_point_pos",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        calc_point_pos.value = "False"
        
        # keep_z
        keep_z = arcpy.Parameter(
            displayName="Keep Z",
            name="keep_z",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_z.value = "False"

        # keep_m
        keep_m = arcpy.Parameter(
            displayName="Keep M",
            name="keep_m",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_m.value = "False"
               
        parameters = [in_dataset, out_dataset, convert_option, remove_duplicates, calc_point_pos, keep_z, keep_m]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[2].valueAsText == "Vertex":
             fieldNames = ["ET_ID","ET_X","ET_Y","ET_ORDER","ET_IDR","ET_IDP"]
             fieldTypes = ["LONG","DOUBLE","DOUBLE","DOUBLE","LONG","LONG"]
        else:
             fieldNames = ["ET_ID","ET_X","ET_Y"]
             fieldTypes = ["LONG","DOUBLE","DOUBLE"]
                
        addFields = []
        for fieldInd, fieldName in enumerate(fieldNames):
              fieldType = fieldTypes[fieldInd]
              newField = arcpy.Field()
              newField.name = fieldName
              newField.type = fieldType
              addFields.append(newField) 
        parameters[1].schema.additionalFields = addFields
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sOption  = parameters[2].valueAsText
        bDup  = parameters[3].valueAsText
        bPos  = parameters[4].valueAsText
        bZ  = parameters[5].valueAsText
        bM  = parameters[6].valueAsText
       
        etFunction = "PolygonsToPoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sOption,bDup,bPos,bZ,bM],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class MultipointsToPoints(object):
    def __init__(self):
        self.label       = "Multipoints To Points"
        self.description = "Converts a multipoint dataset to a point dataset."
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Multipoint"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_X","ET_Y","ET_ORDER"]
        fieldTypes = ["LONG","DOUBLE","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # keep_z
        keep_z = arcpy.Parameter(
            displayName="Keep Z",
            name="keep_z",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_z.value = "False"

        # keep_m
        keep_m = arcpy.Parameter(
            displayName="Keep M",
            name="keep_m",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_m.value = "False"
               
        parameters = [in_dataset, out_dataset, keep_z, keep_m]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        bZ  = parameters[2].valueAsText
        bM  = parameters[3].valueAsText
       
        etFunction = "MultipointsToPoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,bZ,bM],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolygonsToPolylines(object):
    def __init__(self):
        self.label       = "Polygons To Polylines"
        self.description = "Converts a polygon dataset to a polyline dataset. Preserves the attributes.."
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # keep_z
        keep_z = arcpy.Parameter(
            displayName="Keep Z",
            name="keep_z",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_z.value = "False"

        # keep_m
        keep_m = arcpy.Parameter(
            displayName="Keep M",
            name="keep_m",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_m.value = "False"
               
        parameters = [in_dataset, out_dataset, keep_z, keep_m]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        bZ  = parameters[2].valueAsText
        bM  = parameters[3].valueAsText
       
        etFunction = "PolygonsToPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,bZ,bM],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolylinesToMultipoints(object):
    def __init__(self):
        self.label       = "Polylines To Multipoints"
        self.description = "Converts a polyline dataset to a multipoint dataset. Preserves the attributes.."
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Multipoint"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # keep_z
        keep_z = arcpy.Parameter(
            displayName="Keep Z",
            name="keep_z",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_z.value = "False"

        # keep_m
        keep_m = arcpy.Parameter(
            displayName="Keep M",
            name="keep_m",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_m.value = "False"
               
        parameters = [in_dataset, out_dataset, keep_z, keep_m]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        bZ  = parameters[2].valueAsText
        bM  = parameters[3].valueAsText
       
        etFunction = "PolylinesToMultipoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,bZ,bM],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class MultipointsToPolylines(object):
    def __init__(self):
        self.label       = "Multipoints To Polylines"
        self.description = "Converts a multipoint dataset to a polyline dataset. Preserves the attributes.."
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Multipoint"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # keep_z
        keep_z = arcpy.Parameter(
            displayName="Keep Z",
            name="keep_z",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_z.value = "False"

        # keep_m
        keep_m = arcpy.Parameter(
            displayName="Keep M",
            name="keep_m",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_m.value = "False"
               
        parameters = [in_dataset, out_dataset, keep_z, keep_m]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        bZ  = parameters[2].valueAsText
        bM  = parameters[3].valueAsText
       
        etFunction = "MultipointsToPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,bZ,bM],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolylinesToPolygons(object):
    def __init__(self):
        self.label       = "Polylines To Polygons"
        self.description = "Converts closed polylines (and polyline chains) from a polyline dataset to polygons."
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # use_chains
        use_chains = arcpy.Parameter(
            displayName="Use Polyline Chains",
            name="use_chains",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        use_chains.value = "False"

        # force_closure
        force_closure = arcpy.Parameter(
            displayName="Force Closure",
            name="force_closure",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        force_closure.value = "False"

        # Tolerance parameter
        tolerance = arcpy.Parameter(
            displayName="Close Gap Tolerance",
            name="tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
               
        parameters = [in_dataset, out_dataset, use_chains, force_closure, tolerance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        bChains  = parameters[2].valueAsText
        bForce  = parameters[3].valueAsText
        tol  = parameters[4].valueAsText
        if not tol:
             tol = "0"
       
        etFunction = "PolylinesToPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,bChains,bForce,tol],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsToPointsZM(object):
    def __init__(self):
        self.label       = "Points To Points ZM"
        self.description = "Converts a point dataset to a pointZ or pointM dataset.."
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # Z_value_field
        z_value_field = arcpy.Parameter(
            displayName="Z Value Field",
            name="z_value_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        z_value_field.parameterDependencies = [in_dataset.name]
        z_value_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]

        # M_value_field
        m_value_field = arcpy.Parameter(
            displayName="M Value Field",
            name="m_value_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        m_value_field.parameterDependencies = [in_dataset.name]
        m_value_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]
       
        parameters = [in_dataset, out_dataset, z_value_field, m_value_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        zField  = parameters[2].valueAsText
        mField  = parameters[3].valueAsText
        if not zField:
             zField = ""
        if not mField:
             mField = ""
        etFunction = "PointsToPointsZM"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,zField,mField],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsToPolylines(object):
    def __init__(self):
        self.label       = "Points To Polylines"
        self.description = "Converts a point dataset to a polyline dataset. The point dataset needs to have at least one field that identifies the points to be used for creation of each polyline"
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # ID_field
        polyline_id_field = arcpy.Parameter(
            displayName="Polyline ID field",
            name="polyline_id_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        polyline_id_field.parameterDependencies = [in_dataset.name]
        polyline_id_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]

        # order_field
        order_field = arcpy.Parameter(
            displayName="Order Field",
            name="order_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        order_field.parameterDependencies = [in_dataset.name]
        order_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # Z_value_field
        z_value_field = arcpy.Parameter(
            displayName="Z Value Field",
            name="z_value_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        z_value_field.parameterDependencies = [in_dataset.name]
        z_value_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]

        # M_value_field
        m_value_field = arcpy.Parameter(
            displayName="M Value Field",
            name="m_value_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        m_value_field.parameterDependencies = [in_dataset.name]
        m_value_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]

        # link_field
        link_field = arcpy.Parameter(
            displayName="Link Field",
            name="link_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        link_field.parameterDependencies = [in_dataset.name]
        link_field.filter.list = ["Double", "Float", "Short", "Long", "String","Text","Integer"]
       
        parameters = [in_dataset, out_dataset, polyline_id_field,order_field, z_value_field, m_value_field,link_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[6].valueAsText:
             fieldNames = ["ET_ID","ET_FromAtt","ET_ToAtt"]
             fieldTypes = ["LONG","String","String"]
        else:
             fieldNames = ["ET_ID"]
             fieldTypes = ["LONG"]
              
        addFields = []
        for fieldInd, fieldName in enumerate(fieldNames):
              fieldType = fieldTypes[fieldInd]
              newField = arcpy.Field()
              newField.name = fieldName
              newField.type = fieldType
              addFields.append(newField) 
        parameters[1].schema.additionalFields = addFields
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        idField  = parameters[2].valueAsText
        orderField  = parameters[3].valueAsText
        zField  = parameters[4].valueAsText
        mField  = parameters[5].valueAsText
        linkField  = parameters[6].valueAsText
        if not orderField:
             orderField = ""
        if not zField:
             zField = ""
        if not mField:
             mField = ""
        if not linkField:
             linkField = ""
        
        etFunction = "PointsToPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,idField,orderField,zField,mField,linkField],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsToPolygons(object):
    def __init__(self):
        self.label       = "Points To Polygons"
        self.description = "Converts a point dataset to a polygon dataset. The point dataset needs to have at least one field that identifies the points to be used for creation of each polygon"
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # ID_field
        polygon_id_field = arcpy.Parameter(
            displayName="Polygon ID field",
            name="polygon_id_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        polygon_id_field.parameterDependencies = [in_dataset.name]
        polygon_id_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]

        # order_field
        order_field = arcpy.Parameter(
            displayName="Order Field",
            name="order_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        order_field.parameterDependencies = [in_dataset.name]
        order_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # Z_value_field
        z_value_field = arcpy.Parameter(
            displayName="Z Value Field",
            name="z_value_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        z_value_field.parameterDependencies = [in_dataset.name]
        z_value_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]

        # M_value_field
        m_value_field = arcpy.Parameter(
            displayName="M Value Field",
            name="m_value_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        m_value_field.parameterDependencies = [in_dataset.name]
        m_value_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]

        # link_field
        link_field = arcpy.Parameter(
            displayName="Link Field",
            name="link_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        link_field.parameterDependencies = [in_dataset.name]
        link_field.filter.list = ["Double", "Float", "Short", "Long", "String","Text","Integer"]
       
        parameters = [in_dataset, out_dataset, polygon_id_field,order_field, z_value_field, m_value_field,link_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[6].valueAsText:
             fieldNames = ["ET_ID","ET_FromAtt","ET_ToAtt"]
             fieldTypes = ["LONG","String","String"]
        else:
             fieldNames = ["ET_ID"]
             fieldTypes = ["LONG"]
              
        addFields = []
        for fieldInd, fieldName in enumerate(fieldNames):
              fieldType = fieldTypes[fieldInd]
              newField = arcpy.Field()
              newField.name = fieldName
              newField.type = fieldType
              addFields.append(newField) 
        parameters[1].schema.additionalFields = addFields
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        idField  = parameters[2].valueAsText
        orderField  = parameters[3].valueAsText
        zField  = parameters[4].valueAsText
        mField  = parameters[5].valueAsText
        linkField  = parameters[6].valueAsText
        if not orderField:
             orderField = ""
        if not zField:
             zField = ""
        if not mField:
             mField = ""
        if not linkField:
             linkField = ""
        
        etFunction = "PointsToPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,idField,orderField,zField,mField,linkField],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsToMultipoints(object):
    def __init__(self):
        self.label       = "Points To Multipoints"
        self.description = "Converts a point dataset to a multipoint dataset. The point dataset needs to have at least one field that identifies the points to be used for creation of each multipoint"
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Multipoint"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # ID_field
        multipoint_id_field = arcpy.Parameter(
            displayName="Multipoint ID field",
            name="multipoint_id_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        multipoint_id_field.parameterDependencies = [in_dataset.name]
        multipoint_id_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]

        # order_field
        order_field = arcpy.Parameter(
            displayName="Order Field",
            name="order_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        order_field.parameterDependencies = [in_dataset.name]
        order_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # Z_value_field
        z_value_field = arcpy.Parameter(
            displayName="Z Value Field",
            name="z_value_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        z_value_field.parameterDependencies = [in_dataset.name]
        z_value_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]

        # M_value_field
        m_value_field = arcpy.Parameter(
            displayName="M Value Field",
            name="m_value_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        m_value_field.parameterDependencies = [in_dataset.name]
        m_value_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]

        # link_field
        link_field = arcpy.Parameter(
            displayName="Link Field",
            name="link_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        link_field.parameterDependencies = [in_dataset.name]
        link_field.filter.list = ["Double", "Float", "Short", "Long", "String","Text","Integer"]
       
        parameters = [in_dataset, out_dataset, multipoint_id_field,order_field, z_value_field, m_value_field,link_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[6].valueAsText:
             fieldNames = ["ET_ID","ET_FromAtt","ET_ToAtt"]
             fieldTypes = ["LONG","String","String"]
        else:
             fieldNames = ["ET_ID"]
             fieldTypes = ["LONG"]
              
        addFields = []
        for fieldInd, fieldName in enumerate(fieldNames):
              fieldType = fieldTypes[fieldInd]
              newField = arcpy.Field()
              newField.name = fieldName
              newField.type = fieldType
              addFields.append(newField) 
        parameters[1].schema.additionalFields = addFields
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        idField  = parameters[2].valueAsText
        orderField  = parameters[3].valueAsText
        zField  = parameters[4].valueAsText
        mField  = parameters[5].valueAsText
        linkField  = parameters[6].valueAsText
        if not orderField:
             orderField = ""
        if not zField:
             zField = ""
        if not mField:
             mField = ""
        if not linkField:
             linkField = ""
        
        etFunction = "PointsToMultipoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,idField,orderField,zField,mField,linkField],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ShapeToShapeZ(object):
    def __init__(self):
        self.label       = "Shape To ShapeZ"
        self.description = "Converts the features of a dataset to 3D features with constant Z value. The source dataset needs to have at least one numeric field that will be a source for the Z values."
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # Z_value_field
        z_value_field = arcpy.Parameter(
            displayName="Z Value Field",
            name="z_value_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        z_value_field.parameterDependencies = [in_dataset.name]
        z_value_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

       # add_m
        add_m = arcpy.Parameter(
            displayName="Add M",
            name="add_m",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        add_m.value = "False"
      
        parameters = [in_dataset, out_dataset, z_value_field,add_m]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        zField  = parameters[2].valueAsText
        bM  = parameters[3].valueAsText
        
        etFunction = "ShapeToShapeZ"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,zField,bM],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ShapeZMToShape(object):
    def __init__(self):
        self.label       = "ShapeZM To Shape"
        self.description = "Converts a Z (M) dataset to a plain (no Z or M) dataset."
        self.category = "Convert"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
            
        parameters = [in_dataset, out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
               
        etFunction = "ShapeZMToShape"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CleanPoints(object):
    def __init__(self):
        self.label       = "Clean Points"
        self.description = "Removes the duplicate points from a point feature data set. The duplicates are optionally exported to a new dataset."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # Duplicate Features parameter
        dup_dataset = arcpy.Parameter(
            displayName="Duplicates Dataset",
            name="dup_dataset",
            datatype="DEFeatureClass",
            parameterType="Optional",
            direction="Output")
        # Copy definition from source
        dup_dataset.parameterDependencies = [in_dataset.name]
        dup_dataset.schema.clone = True
        dup_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        dup_dataset.schema.additionalFields = addFields
            
        parameters = [in_dataset, out_dataset, dup_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dupDataset = parameters[2].valueAsText
        if not dupDataset:
             dupDataset = ""
                       
        etFunction = "CleanPoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dupDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class StationPoints(object):
    def __init__(self):
        self.label       = "Station Points"
        self.description = "Creates equally spaced points based on the source polyline layer and the user specified distance between the points."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_X","ET_Y","ET_STATION"]
        fieldTypes = ["LONG","DOUBLE","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # station_distance parameter
        station_distance = arcpy.Parameter(
            displayName="Station Distance",
            name="station_distance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit
        unit = arcpy.Parameter(
            displayName="Distance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
            
        parameters = [in_dataset, out_dataset, station_distance,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        statDist  = parameters[2].valueAsText
                               
        etFunction = "StationPoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,statDist],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ConnectPoints(object):
    def __init__(self):
        self.label       = "Connect Points"
        self.description = "Connects with lines each point from a point dataset to every other point from the same dataset that is closer to the point than the user defined cut off distance. Calculates the length and angle of the connector lines. Assigns the IDs of the From and To Points to each line."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_Dist3D","ET_Slope","ET_DeltaZ","ET_From","ET_To","ET_Angle","ET_Length"]
        fieldTypes = ["DOUBLE","DOUBLE","DOUBLE","LONG","LONG","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # cutoff_distance parameter
        cutoff_distance = arcpy.Parameter(
            displayName="Cutoff Distance",
            name="cutoff_distance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # max_points parameter
        max_points = arcpy.Parameter(
            displayName="Max number points to connect",
            name="max_points",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")
        max_points.value = 1
        
        # add_duplicate_links
        add_duplicate_links = arcpy.Parameter(
            displayName="Add duplicate links",
            name="add_duplicate_links",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        add_duplicate_links.value = "False"
        
            
        parameters = [in_dataset, out_dataset,cutoff_distance,unit,max_points,add_duplicate_links]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        cutDist  = parameters[2].valueAsText
        if not cutDist:
             cutDist = "0"
        max_points  = parameters[4].valueAsText
        if not max_points:
             max_points = "1"
        bAddDups  = parameters[5].valueAsText
                       
        etFunction = "ConnectPoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,max_points,cutDist,bAddDups],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class DispersePoints(object):
    def __init__(self):
        self.label       = "Disperse Points"
        self.description = "Disperses (separates) the coincident points. The first point in a location preserves its coordinates. Every next point found in the same location is moved randomly within user defined maximum offset distance from its original location."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Status","OriginalX","OriginalY","ET_Group"]
        fieldTypes = ["LONG","STRING","DOUBLE","DOUBLE","STRING"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # disperse_distance parameter
        disperse_distance = arcpy.Parameter(
            displayName="Disperse Distance",
            name="disperse_distance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # disperse_option parameter
        disperse_option = arcpy.Parameter(
            displayName="Disperse Option",
            name="disperse_option",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        disperse_option.filter.type = "ValueList"
        disperse_option.filter.list = ["Random", "Regular"]
        disperse_option.value = "Random"
                    
        parameters = [in_dataset, out_dataset,disperse_distance,unit,disperse_option]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dispDist  = parameters[2].valueAsText
        if not dispDist:
             dispDist = "0"
        dispMet = parameters[4].valueAsText
                       
        etFunction = "DispersePoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dispDist,dispMet],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsToRectangles(object):
    def __init__(self):
        self.label       = "Points To Rectangles"
        self.description = "Creates rectangles from points in a point dataset and user defined width, height and rotation angle. The angle should be in Decimal Degrees and have Polar orientation - East = 0, anti-clockwise."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter 0
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter 1
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

         # location parameter 2
        location = arcpy.Parameter(
            displayName="Location",
            name="location",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        location.filter.type = "ValueList"
        location.filter.list = ["LowerLeft", "UpperLeft","UpperRight","LowerRight","Center"]
        location.value = "Center"

        # width parameter 3
        width = arcpy.Parameter(
            displayName="Width",
            name="width",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # width_field 4
        width_field = arcpy.Parameter(
            displayName="Width Field",
            name="width_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        width_field.parameterDependencies = [in_dataset.name]
        width_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # height parameter 5
        height = arcpy.Parameter(
            displayName="Height",
            name="height",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # height_field 6
        height_field = arcpy.Parameter(
            displayName="Height Field",
            name="height_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        height_field.parameterDependencies = [in_dataset.name]
        height_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

         # angle parameter 7
        angle = arcpy.Parameter(
            displayName="Rotation Angle",
            name="angle",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # angle_field 8
        angle_field = arcpy.Parameter(
            displayName="Rotation Angle Field",
            name="angle_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        angle_field.parameterDependencies = [in_dataset.name]
        angle_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # unit
        unit = arcpy.Parameter(
            displayName="Linear Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,location,width,width_field,height,height_field,angle,angle_field,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[9].value =  inUnit   
            except:
                 parameters[9].value = ""        
        return

    def updateMessages(self, parameters): #optional

       if not etFound()[0]:
            parameters[0].setErrorMessage("ET GeoWizards not installed!")
       else:
            parameters[0].clearMessage
             
       if not (parameters[3].valueAsText) and not (parameters[4].valueAsText):
            parameters[3].setErrorMessage("Width or Width Field needed!")
       else:
            parameters[3].clearMessage
       if not (parameters[5].valueAsText) and not (parameters[6].valueAsText):
            parameters[5].setErrorMessage("Height or Height Field needed!")
       else:
            parameters[5].clearMessage
       return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sLoc  = parameters[2].valueAsText
        dW = parameters[3].valueAsText
        if not dW:
            dW = "0"
        sWF = parameters[4].valueAsText
        if not sWF:
            sWF = ""
        dH = parameters[5].valueAsText
        if not dH:
            dH = "0"
        sHF = parameters[6].valueAsText
        if not sHF:
            sHF = ""
        
        dA = parameters[7].valueAsText
        if not dA:
            dA = "0"
        sAF = parameters[8].valueAsText
        if not sAF:
            sAF = ""
                       
        etFunction = "PointsToRectangles"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sLoc,dW,sWF,dH,sHF,dA,sAF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsToRegularPolygons(object):
    def __init__(self):
        self.label       = "Points To Regular Polygons"
        self.description = "Creates regular polygons from points in a point dataset and user defined number of sides,size (radius of the inscribed/circumscribed circle or side length)."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # number_sides parameter
        number_sides = arcpy.Parameter(
            displayName="Number Sides",
            name="number_sides",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        number_sides.filter.type = 'Range'
        number_sides.filter.list = [3,100]

        # size_represents parameter
        size_represents = arcpy.Parameter(
            displayName="Size Represents",
            name="size_represents",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        size_represents.filter.type = "ValueList"
        size_represents.filter.list = ["RadiusIn", "RadiusOut","Side"]
        size_represents.value = "RadiusOut"

        # polygon_size parameter
        polygon_size = arcpy.Parameter(
            displayName="Polygon Size",
            name="polygon_size",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        # size_field
        size_field = arcpy.Parameter(
            displayName="Size Field",
            name="size_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        size_field.parameterDependencies = [in_dataset.name]
        size_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

         # angle parameter
        angle = arcpy.Parameter(
            displayName="Rotation Angle",
            name="angle",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # angle_field
        angle_field = arcpy.Parameter(
            displayName="Rotation Angle Field",
            name="angle_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        angle_field.parameterDependencies = [in_dataset.name]
        angle_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

         # unit
        unit = arcpy.Parameter(
            displayName="Linear Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,number_sides,size_represents,polygon_size,size_field,angle,angle_field,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[8].value =  inUnit   
            except:
                 parameters[8].value = ""        
        return

    def updateMessages(self, parameters): #optional
       if not etFound()[0]:
            parameters[0].setErrorMessage("ET GeoWizards not installed!")
       else:
            parameters[0].clearMessage
             
       if not (parameters[4].valueAsText) and not (parameters[5].valueAsText):
            parameters[4].setWarningMessage("Size or Size Field needed!")
       else:
            parameters[4].clearMessage
       return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        numSides  = parameters[2].valueAsText
        sSizeRep  = parameters[3].valueAsText
        dS = parameters[4].valueAsText
        if not dS:
            dW = "0"
        sSF = parameters[5].valueAsText
        if not sSF:
            sSF = ""
        dA = parameters[6].valueAsText
        if not dA:
            dA = "0"
        sAF = parameters[7].valueAsText
        if not sAF:
            sAF = ""
                       
        etFunction = "PointsToRegularPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,numSides,sSizeRep,dS,sSF,dA,sAF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsAngleAndPosition(object):
    def __init__(self):
        self.label       = "Points Angle And Position"
        self.description = "Identifies the closest polyline from the reference dataset to each point and calculates: the angle of the closest polyline segment, the position & stationing of the point along the polyline and the distance to the polyline."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]

        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Polyline Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        reference_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Closest","ET_Angle","ET_Pos","ET_Station","ET_Side","ET_Dist","ET_Z","ET_M"]
        fieldTypes = ["LONG","LONG","DOUBLE","DOUBLE","DOUBLE","STRING","DOUBLE","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # search_tolerance parameter
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        
        # spatial_ref_from_source
        spatial_ref_from_source = arcpy.Parameter(
            displayName="Output Spatial Ref From Source",
            name="spatial_ref_from_source",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        spatial_ref_from_source.value = "False"
                    
        parameters = [in_dataset,reference_dataset, out_dataset,search_tolerance, unit, spatial_ref_from_source]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 refSR  = arcpy.Describe(parameters[1].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if refSR.name == "Unknown":
                     refUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 if refSR.type == "Projected":
                     refUnit = refSR.linearUnitName
                 else:
                     refUnit = refSR.GCS.angularUnitName
                 if parameters[5].value:
                      parameters[4].value =  inUnit
                 else:     
                      parameters[4].value =  refUnit 
            except:
                 parameters[4].value = ""
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        refDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        bSRS = parameters[5].valueAsText
        
                       
        etFunction = "PointsAngleAndPosition"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,refDataset,outDataset,dTol,bSRS],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SnapPoints(object):
    def __init__(self):
        self.label       = "Snap Points"
        self.description = "Snaps the features of a point feature class to another feature class (Point, Polyline, Multipoint or Polygon)."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]

        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Polyline Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
                
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Status"]
        fieldTypes = ["LONG","STRING"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
    
        # snap_to_what parameter
        snap_to_what = arcpy.Parameter(
            displayName="Snap To What",
            name="snap_to_what",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        snap_to_what.filter.type = "ValueList"
        snap_to_what.filter.list = ["Vertex", "Nearest"]
        snap_to_what.value = "Nearest"

        # snap_to_z
        snap_to_z = arcpy.Parameter(
            displayName="Snap To Z",
            name="snap_to_z",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        snap_to_z.value = "False"
        
        # spatial_ref_from_source
        spatial_ref_from_source = arcpy.Parameter(
            displayName="Spatial Ref From Source",
            name="spatial_ref_from_source",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        spatial_ref_from_source.value = "False"
                   
        parameters = [in_dataset,reference_dataset, out_dataset,search_tolerance,unit,snap_to_what,snap_to_z,spatial_ref_from_source]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 refSR  = arcpy.Describe(parameters[1].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if refSR.name == "Unknown":
                     refUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 if refSR.type == "Projected":
                     refUnit = refSR.linearUnitName
                 else:
                     refUnit = refSR.GCS.angularUnitName
                 if parameters[7].value:
                      parameters[4].value =  inUnit
                 else:     
                      parameters[4].value =  refUnit 
            except:
                 parameters[4].value = ""
        return
        
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        refDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        sOption = parameters[5].valueAsText
        bZ = parameters[6].valueAsText
        bSRS = parameters[7].valueAsText
                       
        etFunction = "SnapPoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,refDataset,outDataset,dTol,sOption,bZ,bSRS],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ReverseGeocoding(object):
    def __init__(self):
        self.label       = "ReverseGeocoding"
        self.description = "Uses a reference polyline (street centerlines) layer to assign addresses to the points from a point layer. Allows transfer of any additional attributes."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]

        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Polyline Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        reference_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Address"]
        fieldTypes = ["LONG","LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
    
        # address_type parameter
        address_type = arcpy.Parameter(
            displayName="Address Type",
            name="address_type",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        address_type.filter.type = "ValueList"
        address_type.filter.list = ["Single", "Continuous","Address"]
        address_type.value = "Single"

        # left_from_field
        left_from_field = arcpy.Parameter(
            displayName="Left From (From) Field",
            name="left_from_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        left_from_field.parameterDependencies = [reference_dataset.name]
        left_from_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # left_to_field
        left_to_field = arcpy.Parameter(
            displayName="Left To (To) Field",
            name="left_to_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        left_to_field.parameterDependencies = [reference_dataset.name]
        left_to_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # right_from_field
        right_from_field = arcpy.Parameter(
            displayName="Right From Field",
            name="right_from_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        right_from_field.parameterDependencies = [reference_dataset.name]
        right_from_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # right_to_field
        right_to_field = arcpy.Parameter(
            displayName="Right To Field",
            name="right_to_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        right_to_field.parameterDependencies = [reference_dataset.name]
        right_to_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # additional_fields parameter
        additional_fields = arcpy.Parameter(
            displayName="Additional Fields",
            name="additional_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        additional_fields.parameterDependencies = [reference_dataset  .name]
        additional_fields.columns = [["Field","Field"]]
        additional_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
                
        # spatial_ref_from_source
        spatial_ref_from_source = arcpy.Parameter(
            displayName="Output Spatial Ref From Source",
            name="spatial_ref_from_source",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        spatial_ref_from_source.value = "True"
                          
        parameters = [in_dataset,reference_dataset, out_dataset,search_tolerance,unit,address_type]
        parameters1 = [left_from_field,left_to_field,right_from_field,right_to_field,additional_fields,spatial_ref_from_source]
        parameters.extend(parameters1)
        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 refSR  = arcpy.Describe(parameters[1].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if refSR.name == "Unknown":
                     refUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 if refSR.type == "Projected":
                     refUnit = refSR.linearUnitName
                 else:
                     refUnit = refSR.GCS.angularUnitName
                 if parameters[7].value:
                      parameters[4].value =  inUnit
                 else:     
                      parameters[4].value =  refUnit 
            except:
                 parameters[4].value = "" 
        if parameters[5].valueAsText == "Single":
             fieldNames = ["ET_ID"]
             fieldTypes = ["LONG"]
             parameters[6].enabled = False
             parameters[7].enabled = False
             parameters[8].enabled = False
             parameters[9].enabled = False
        elif parameters[5].valueAsText == "Continuous":
             fieldNames = ["ET_ID","ET_Address"]
             fieldTypes = ["LONG","LONG"]
             parameters[6].enabled = True
             parameters[7].enabled = True
             parameters[8].enabled = False
             parameters[9].enabled = False
        else:
             fieldNames = ["ET_ID","ET_Address"]
             fieldTypes = ["LONG","LONG"]
             parameters[6].enabled = True
             parameters[7].enabled = True
             parameters[8].enabled = True
             parameters[9].enabled = True
             
        if parameters[1].valueAsText:
             try:
                  fList  = arcpy.Describe(parameters[1].value).fields
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[10].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       fieldNames.append(fld)
                       for f in fList:
                            if f.name == fld:
                                 fieldTypes.append(f.type)
                  addFields = []
                  for fieldInd, fieldName in enumerate(fieldNames):
                       fieldType = fieldTypes[fieldInd]
                       newField = arcpy.Field()
                       newField.name = fieldName
                       newField.type = fieldType
                       addFields.append(newField) 
                  parameters[2].schema.additionalFields = addFields 
             except:
                  a=0
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return
    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        refDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        sOption = parameters[5].valueAsText
        lF = parameters[6].valueAsText
        if not lF:
            lF = ""
        lT = parameters[7].valueAsText
        if not lT:
            lT = ""
        rF = parameters[8].valueAsText
        if not rF:
            rF = ""
        rT = parameters[9].valueAsText
        if not rT:
            rT = ""
        addFields = parameters[10].valueAsText
        if not addFields:
            addFields = ""
        bSRS = parameters[11].valueAsText
                       
        etFunction = "ReverseGeocoding"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,refDataset,outDataset,dTol,sOption,lF,lT,rF,rT,addFields,bSRS],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PerpendicularsToPolylines(object):
    def __init__(self):
        self.label       = "Perpendiculars To Polylines"
        self.description = "Draws a perpendicular polyline from each point to the closest polyline from the reference layer and calculates the angle of the perpendicular, the position & stationing of the point along the polyline, the distance to the polyline."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]

        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Polyline Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        reference_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Closest","ET_Angle","ET_Pos","ET_Station","ET_Dist"]
        fieldTypes = ["LONG","LONG","DOUBLE","DOUBLE","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
                    
        # spatial_ref_from_source
        spatial_ref_from_source = arcpy.Parameter(
            displayName="Output Spatial Ref From Source",
            name="spatial_ref_from_source",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        spatial_ref_from_source.value = "True"
                          
        parameters = [in_dataset,reference_dataset, out_dataset,search_tolerance,unit,spatial_ref_from_source]
        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 refSR  = arcpy.Describe(parameters[1].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if refSR.name == "Unknown":
                     refUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 if refSR.type == "Projected":
                     refUnit = refSR.linearUnitName
                 else:
                     refUnit = refSR.GCS.angularUnitName
                 if parameters[5].value:
                      parameters[4].value =  inUnit
                 else:     
                      parameters[4].value =  refUnit 
            except:
                 parameters[4].value = ""
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return
    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        refDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        bSRS = parameters[5].valueAsText
                       
        etFunction = "PerpendicularsToPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,refDataset,outDataset,dTol,bSRS],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointIntersection(object):
    def __init__(self):
        self.label       = "Point Intersection"
        self.description = "Draws a perpendicular polyline from each point to the closest polyline from the reference layer and calculates the angle of the perpendicular, the position & stationing of the point along the polyline, the distance to the polyline."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]

        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        reference_dataset.filter.list = ["Polyline", "Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_IDRef"]
        fieldTypes = ["LONG","LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

                          
        # transfer_attributes
        transfer_attributes = arcpy.Parameter(
            displayName="Transfer Source Attributes",
            name="transfer_attributes",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        transfer_attributes.value = "True"
                          
        parameters = [in_dataset,reference_dataset, out_dataset,transfer_attributes]
        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[3].value:
             parameters[2].schema.clone = True
             parameters[2].schema.fieldsRule = "All"
        else:
             parameters[2].schema.clone = True
             parameters[2].schema.fieldsRule = "None"
                    
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return
    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        refDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        bTransfer = parameters[3].valueAsText
                       
        etFunction = "PointIntersection"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,refDataset,outDataset,bTransfer],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddMessage("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ThinPoints(object):
    def __init__(self):
        self.label       = "ThinPoints"
        self.description = "Reduces the number of points in a point dataset based on their spatial location. - Points that are closer to each other than the tolerance specified will be converted to a single point. - The values in the field specified will be summarized for each cluster and saved in the point representing this cluster."
        self.category = "Points"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "None"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Count","ET_Link"]
        fieldTypes = ["LONG","LONG","LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # distance_tolerance parameter
        distance_tolerance = arcpy.Parameter(
            displayName="Distance Tolerance",
            name="distance_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # link_dataset parameter
        link_dataset = arcpy.Parameter(
            displayName="Link Dataset",
            name="link_dataset",
            datatype="DEFeatureClass",
            parameterType="Optional",
            direction="Output")
        # Copy definition from source
        link_dataset.parameterDependencies = [in_dataset.name]
        link_dataset.schema.clone = True
        link_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Link"]
        fieldTypes = ["LONG","LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        link_dataset.schema.additionalFields = addFields
            
        parameters = [in_dataset, out_dataset,distance_tolerance,unit, link_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        linkDataset = parameters[4].valueAsText
        if not linkDataset:
             linkDataset = ""
                       
        etFunction = "ThinPoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,linkDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class GeneralizePolylines(object):
    def __init__(self):
        self.label       = "Generalize Polylines"
        self.description = "Generalizes ( reduces the number of vertices required to represent a polyline ) the features of a polyline dataset using the Douglas-Poiker algorithm."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # generalize_tolerance parameter
        generalize_tolerance = arcpy.Parameter(
            displayName="Generalize Tolerance",
            name="generalize_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,generalize_tolerance,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        
                       
        etFunction = "GeneralizePolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class DensifyPolylines(object):
    def __init__(self):
        self.label       = "Densify Polylines"
        self.description = "Generalizes ( reduces the number of vertices required to represent a polyline ) the features of a polyline dataset using the Douglas-Poiker algorithm."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # densify_tolerance parameter
        densify_tolerance = arcpy.Parameter(
            displayName="Densify Tolerance",
            name="densify_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,densify_tolerance,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit  
            except:
                 parameters[3].value = ""
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        
                       
        etFunction = "DensifyPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SmoothBezier(object):
    def __init__(self):
        self.label       = "Smooth Bezier"
        self.description = "Smoothes the features of a polyline layer using Bezier algorithm."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # smoothness parameter
        smoothness = arcpy.Parameter(
            displayName="Smoothness (2..20)",
            name="smoothness",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        smoothness.filter.type = 'Range'
        smoothness.filter.list = [2,20]
        smoothness.value = 3

       # densify_tolerance parameter
        densify_tolerance = arcpy.Parameter(
            displayName="Densify Before Smoothing Tolerance",
            name="densify_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

       # generalize_tolerance parameter
        generalize_tolerance = arcpy.Parameter(
            displayName="Generalize After Smoothing Tolerance",
            name="generalize_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,smoothness,densify_tolerance,generalize_tolerance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        iSm = parameters[2].valueAsText
        denT = parameters[3].valueAsText
        if not denT:
             denT = ""
        genT = parameters[4].valueAsText
        if not genT:
             genT = ""
                     
        etFunction = "SmoothBezier"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,iSm,denT,genT],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SmoothBSpline(object):
    def __init__(self):
        self.label       = "Smooth B Spline"
        self.description = "Smoothes the features of a polyline layer using B-Spline algorithm."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # smoothness parameter
        smoothness = arcpy.Parameter(
            displayName="Smoothness (2..20)",
            name="smoothness",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        smoothness.filter.type = 'Range'
        smoothness.filter.list = [2,20]
        smoothness.value = 3

      # freedom parameter
        freedom = arcpy.Parameter(
            displayName="Freedom (3..10)",
            name="freedom",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        freedom.filter.type = 'Range'
        freedom.filter.list = [3,10]
        freedom.value = 5

       # densify_tolerance parameter
        densify_tolerance = arcpy.Parameter(
            displayName="Densify Before Smoothing Tolerance",
            name="densify_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

       # generalize_tolerance parameter
        generalize_tolerance = arcpy.Parameter(
            displayName="Generalize After Smoothing Tolerance",
            name="generalize_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,smoothness,freedom,densify_tolerance,generalize_tolerance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        iSm = parameters[2].valueAsText
        iFr = parameters[3].valueAsText
        denT = parameters[4].valueAsText
        if not denT:
             denT = ""
        genT = parameters[5].valueAsText
        if not genT:
             genT = ""
                     
        etFunction = "SmoothBSpline"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,iSm,iFr,denT,genT],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SmoothTSpline(object):
    def __init__(self):
        self.label       = "Smooth T Spline"
        self.description = "Smoothes the features of a polyline layer using T-Spline algorithm."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # smoothness parameter
        smoothness = arcpy.Parameter(
            displayName="Smoothness (2..20)",
            name="smoothness",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        smoothness.filter.type = 'Range'
        smoothness.filter.list = [2,20]
        smoothness.value = 3

      # tension parameter
        tension = arcpy.Parameter(
            displayName="Tension (1..100)",
            name="tension",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        tension.filter.type = 'Range'
        tension.filter.list = [1,100]
        tension.value = 10

       # densify_tolerance parameter
        densify_tolerance = arcpy.Parameter(
            displayName="Densify Before Smoothing Tolerance",
            name="densify_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

       # generalize_tolerance parameter
        generalize_tolerance = arcpy.Parameter(
            displayName="Generalize After Smoothing Tolerance",
            name="generalize_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,smoothness,tension,densify_tolerance,generalize_tolerance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        iSm = parameters[2].valueAsText
        iTen = parameters[3].valueAsText
        denT = parameters[4].valueAsText
        if not denT:
             denT = ""
        genT = parameters[5].valueAsText
        if not genT:
             genT = ""
                     
        etFunction = "SmoothTSpline"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,iSm,iTen,denT,genT],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolylineZCharacteristics(object):
    def __init__(self):
        self.label       = "Polyline Z Characteristics"
        self.description = "Calculates several characteristics of PolylineZs. The results are stored in fields in the polyline attribute table. The linear and angular precision is the number of digits after the decimal point to be used. Note that this values are used only if the fields do not exist in the input dataset."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","Length_3D","Length_2D","Max_Z","Min_Z","Len_Up","Len_Down","H_Up","H_Down","Max_S_Up","Max_S_Down","Av_S_Up","Av_S_Down"]
        fieldTypes = ["LONG","DOUBLE","DOUBLE","DOUBLE","DOUBLE","DOUBLE","DOUBLE","DOUBLE","DOUBLE","DOUBLE","DOUBLE","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # linear_precision parameter
        linear_precision = arcpy.Parameter(
            displayName="Linear Precision (2..8)",
            name="linear_precision",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")
        linear_precision.filter.type = 'Range'
        linear_precision.filter.list = [2,8]
        linear_precision.value = 3

      # angular_precision parameter
        angular_precision = arcpy.Parameter(
            displayName="Angular Precision (2..8)",
            name="tension",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        angular_precision.filter.type = 'Range'
        angular_precision.filter.list = [2,8]
        angular_precision.value = 2

       # no_data parameter
        no_data = arcpy.Parameter(
            displayName="No Data Value",
            name="no_data",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                           
        parameters = [in_dataset, out_dataset,linear_precision,angular_precision,no_data]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
          
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if parameters[0].valueAsText:
            if not arcpy.Describe(parameters[0].value).hasZ:
                parameters[0].setErrorMessage("The input has no Z values!")
            else:
                parameters[0].clearMessage
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        iLP = parameters[2].valueAsText
        iAP = parameters[3].valueAsText
        dNoData = parameters[4].valueAsText
        if not dNoData:
             dNoData = ""
                             
        etFunction = "PolylineZCharacteristics"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,iLP,iAP,dNoData],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolylineCharacteristics(object):
    def __init__(self):
        self.label       = "Polyline Characteristics"
        self.description = "Calculates some characteristics of the polylines from a polyline dataset."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Length","ET_Dir","ET_Parts","ET_Vert","ET_Seg","ET_Sinous","ET_Fract"]
        fieldTypes = ["LONG","DOUBLE","DOUBLE","LONG","LONG","LONG","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # linear_precision parameter
        linear_precision = arcpy.Parameter(
            displayName="Precision (2..8)",
            name="linear_precision",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")
        linear_precision.filter.type = 'Range'
        linear_precision.filter.list = [2,8]
        linear_precision.value = 3

      # calc_fract
        calc_fract = arcpy.Parameter(
            displayName="Calculate Fractality",
            name="calc_fract",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        calc_fract.value = "False"
                           
        parameters = [in_dataset, out_dataset,linear_precision,calc_fract]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[3].value:
             fieldNames = ["ET_ID","ET_Length","ET_Dir","ET_Parts","ET_Vert","ET_Seg","ET_Sinous","ET_Fract"]
             fieldTypes = ["LONG","DOUBLE","DOUBLE","LONG","LONG","LONG","DOUBLE","DOUBLE"]
        else:
             fieldNames = ["ET_ID","ET_Length","ET_Dir","ET_Parts","ET_Vert","ET_Seg","ET_Sinous"]
             fieldTypes = ["LONG","DOUBLE","DOUBLE","LONG","LONG","LONG","DOUBLE"]
               
        addFields = []
        for fieldInd, fieldName in enumerate(fieldNames):
              fieldType = fieldTypes[fieldInd]
              newField = arcpy.Field()
              newField.name = fieldName
              newField.type = fieldType
              addFields.append(newField) 
        parameters[1].schema.additionalFields = addFields  
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        iLP = parameters[2].valueAsText
        bFract = parameters[3].valueAsText
        if not iLP:
             iLP = "0"                      
        etFunction = "PolylineCharacteristics"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,iLP,bFract],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CleanContourGaps(object):
    def __init__(self):
        self.label       = "Clean Contour Gaps"
        self.description = "Cleans the gaps in datasets representing conours.."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # gap_size parameter
        gap_size = arcpy.Parameter(
            displayName="Gap Size",
            name="gap_size",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

       # elevation_field
        elevation_field = arcpy.Parameter(
            displayName="Elevation Field",
            name="elevation_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        elevation_field.parameterDependencies = [in_dataset.name]
        elevation_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]
                           
        parameters = [in_dataset, out_dataset,gap_size,elevation_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return
    
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dGap = parameters[2].valueAsText
        sEl = parameters[3].valueAsText
                              
        etFunction = "CleanContourGaps"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dGap,sEl],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class FlipPolylinesZ(object):
    def __init__(self):
        self.label       = "Flip Polylines Z"
        self.description = "Changes the directions of the polylines from a PolylineZ feature class. In the resulting dataset all polylines will be oriented Up or Down slope."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # down_slope
        down_slope = arcpy.Parameter(
            displayName="Direction Down Slope",
            name="down_slope",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        down_slope.value = "True"
                           
        parameters = [in_dataset, out_dataset,down_slope]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
          
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if parameters[0].valueAsText:
            if not arcpy.Describe(parameters[0].value).hasZ:
                parameters[0].setErrorMessage("The input has no Z values!")
            else:
                parameters[0].clearMessage
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        bDown = parameters[2].valueAsText
        
                             
        etFunction = "FlipPolylinesZ"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,bDown],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class FlipPolylinesBasedOnPoint(object):
    def __init__(self):
        self.label       = "Flip Polylines Based On Point"
        self.description = "Changes the direction of the polylines from a polyline layer based on user defined start point."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # start_point parameter
        start_point = arcpy.Parameter(
            displayName="Start Point Location",
            name="start_point",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        start_point.filter.type = "ValueList"
        start_point.filter.list = ["South-West", "South-East","North-West","North-East","South","North","West","East"]
        start_point.value = "South-West"
                           
        parameters = [in_dataset, out_dataset,start_point]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
          
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sPoint = parameters[2].valueAsText
        
                             
        etFunction = "FlipPolylinesBasedOnPoint"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sPoint],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ExportNodes(object):
    def __init__(self):
        self.label       = "Export Nodes"
        self.description = "Analyzes the nodes of a polyline layer and exports them as a point dataset. The resulting points are classified according to the node type."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_Valency","ET_Type"]
        fieldTypes = ["LONG","String"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # dangles
        dangles = arcpy.Parameter(
            displayName="Export Dangling Nodes",
            name="dangles",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        dangles.value = "True"

        # pseudo
        pseudo = arcpy.Parameter(
            displayName="Export Pseudo Nodes",
            name="pseudo",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        pseudo.value = "True"

        # regular
        regular = arcpy.Parameter(
            displayName="Export Regular Nodes",
            name="regular",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        regular.value = "True"

        # link_field
        link_field = arcpy.Parameter(
            displayName="Link Field",
            name="link_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        link_field.parameterDependencies = [in_dataset.name]
        link_field.filter.list = ["Double", "Float", "Short", "Long", "String","Text","Integer"]
                           
        parameters = [in_dataset, out_dataset,dangles,pseudo,regular,link_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
          
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        bD = parameters[2].valueAsText
        bP = parameters[3].valueAsText
        bR = parameters[4].valueAsText
        sLink = parameters[5].valueAsText
        if not sLink:
            sLink = ""
                             
        etFunction = "ExportNodes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,bD,bP,bR,sLink],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class RenodePolylines(object):
    def __init__(self):
        self.label       = "Renode Polylines"
        self.description = "Analyzes the nodes of a polyline layer and exports them as a point feature class. Creates links between the nodes and corresponding polylines."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_Valency","ET_Type"]
        fieldTypes = ["LONG","String"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # Renoded Features parameter
        renoded_dataset = arcpy.Parameter(
            displayName="Renoded Dataset",
            name="renoded_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        renoded_dataset.parameterDependencies = [in_dataset.name]
        renoded_dataset.schema.clone = True
        renoded_dataset.schema.fieldsRule = "All"
        renoded_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_FNode","ET_TNode","ET_Part"]
        fieldTypes = ["LONG","LONG","LONG","LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        renoded_dataset.schema.additionalFields = addFields
                           
        parameters = [in_dataset, out_dataset,renoded_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
          
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        renodedDataset  = parameters[2].valueAsText
                             
        etFunction = "RenodePolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,renodedDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SnapPolylines(object):
    def __init__(self):
        self.label       = "Snap Polylines"
        self.description = "Snaps the features of a polyline feature class to another feature class (Point, Polyline, Multipoint or Polygon)."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]

        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        reference_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Status"]
        fieldTypes = ["LONG","STRING"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
    
        # snap_what parameter
        snap_what = arcpy.Parameter(
            displayName="Snap What",
            name="snap_what",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        snap_what.filter.type = "ValueList"
        snap_what.filter.list = ["Node","Vertex", "Edge","All"]
        snap_what.value = "All"

        # snap_to_what parameter
        snap_to_what = arcpy.Parameter(
            displayName="Snap To What",
            name="snap_to_what",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        snap_to_what.filter.type = "ValueList"
        snap_to_what.filter.list = ["Vertex", "All"]
        snap_to_what.value = "All"

        # snap_to_z
        snap_to_z = arcpy.Parameter(
            displayName="Snap To Z",
            name="snap_to_z",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        snap_to_z.value = "False"
        
        # spatial_ref_from_source
        spatial_ref_from_source = arcpy.Parameter(
            displayName="Spatial Ref From Source",
            name="spatial_ref_from_source",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        spatial_ref_from_source.value = "True"
                   
        parameters = [in_dataset,reference_dataset, out_dataset,search_tolerance,unit,snap_what,snap_to_what,snap_to_z,spatial_ref_from_source]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 refSR  = arcpy.Describe(parameters[1].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if refSR.name == "Unknown":
                     refUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 if refSR.type == "Projected":
                     refUnit = refSR.linearUnitName
                 else:
                     refUnit = refSR.GCS.angularUnitName
                 if parameters[8].value:
                      parameters[4].value =  inUnit
                 else:     
                      parameters[4].value =  refUnit 
            except:
                 parameters[4].value = ""
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        refDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        sWhat = parameters[5].valueAsText
        sToWhat = parameters[6].valueAsText
        bZ = parameters[7].valueAsText
        bSRS = parameters[8].valueAsText
                       
        etFunction = "SnapPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,refDataset,outDataset,dTol,sWhat,sToWhat,bZ,bSRS],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CleanPseudoNodes(object):
    def __init__(self):
        self.label       = "Clean Pseudo Nodes (Dissolve Polylines)"
        self.description = "Dissolves (unsplits) a polyline layer using user specified dissolve field. Preserves the topology of the polyline dataset."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
    
        # dissolve_fields parameter
        dissolve_fields = arcpy.Parameter(
            displayName="Dissolve Fields",
            name="dissolve_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        dissolve_fields.parameterDependencies = [in_dataset.name]
        dissolve_fields.columns = [["Field","Field"]]
        dissolve_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]

        # update_fields parameter
        update_fields = arcpy.Parameter(
            displayName="Field Update Rules",
            name="update_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        update_fields.parameterDependencies = [in_dataset.name]
        update_fields.columns = [["Field","Field"],["GPString", "UpdateRule"],["Field", "PairedField"]]
        update_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        update_fields.filters[1].type = "ValueList"
        update_fields.filters[1].list = ["First", "Last", "MaxLength", "Sum","Minimum","Maximum","RangeContinuous","RangeAddress"]
        update_fields.filters[2].list = ["Double", "Float", "Short", "Long"]
                  
        parameters = [in_dataset,out_dataset,dissolve_fields,update_fields]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                     
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        sUpF = parameters[3].valueAsText
        sMsg = ""
        if sUpF:
             value_table = arcpy.ValueTable(3)
             value_table.loadFromString(sUpF)
             for i in range(0, value_table.rowCount):
                  f1 = value_table.getValue(i,0)
                  r1 = value_table.getValue(i,1)
                  if (r1 == "RangeContinuous") or (r1 == "RangeAddress"):
                       f2 = value_table.getValue(i,2)
                       if f2 == "":
                            parameters[3].setErrorMessage("RangeContinuous and RangeAddress require a Paired Field")
                       else:
                            parameters[3].clearMessage     
                           
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sDisF = parameters[2].valueAsText
        if not sDisF:
             sDisF = ""
        sUpF = parameters[3].valueAsText
        sNewUpF = ""
        if sUpF:
             value_table = arcpy.ValueTable(3)
             value_table.loadFromString(sUpF)
             for i in range(0, value_table.rowCount):
                  f1 = value_table.getValue(i,0)
                  r1 = value_table.getValue(i,1)
                  if (r1 == "RangeContinuous") or (r1 == "RangeAddress"):
                       f2 = value_table.getValue(i,2)
                  else:
                       f2 = ""
                  sNewUpF = sNewUpF+f1+" "+r1+" "+f2+";"
                       
        etFunction = "CleanPseudoNodes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sDisF,sNewUpF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SplitPolylines(object):
    def __init__(self):
        self.label       = "Split Polylines"
        self.description = "Splits the polylines from a polyline dataset using user specified split option."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
    
       # split_option parameter
        split_option = arcpy.Parameter(
            displayName="Split Option",
            name="split_option",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        split_option.filter.type = "ValueList"
        split_option.filter.list = ["Vertex", "NumberVertices","NumberIntervals","EqualLength","Length"]
        split_option.value = "Vertex"

        #split_tolerance parameter
        split_tolerance = arcpy.Parameter(
            displayName="Split Tolerance",
            name="split_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # update_fields parameter
        update_fields = arcpy.Parameter(
            displayName="Field Update Rules",
            name="update_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        update_fields.parameterDependencies = [in_dataset.name]
        update_fields.columns = [["Field","Field"],["GPString", "UpdateRule"],["Field", "PairedField"]]
        update_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        update_fields.filters[1].type = "ValueList"
        update_fields.filters[1].list = ["Empty", "Copy", "Proportion","RangeContinuous","RangeAddress"]
        update_fields.filters[2].list = ["Double", "Float", "Short", "Long"]
                  
        parameters = [in_dataset,out_dataset,split_option,split_tolerance,update_fields]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                     
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        sUpF = parameters[4].valueAsText
        sMsg = ""
        if sUpF:
             value_table = arcpy.ValueTable(3)
             value_table.loadFromString(sUpF)
             for i in range(0, value_table.rowCount):
                  f1 = value_table.getValue(i,0)
                  r1 = value_table.getValue(i,1)
                  if (r1 == "RangeContinuous") or (r1 == "RangeAddress"):
                       f2 = value_table.getValue(i,2)
                       if f2 == "":
                            parameters[4].setErrorMessage("RangeContinuous and RangeAddress require a Paired Field")
                       else:
                            parameters[4].clearMessage     
        if not parameters[2].valueAsText == "Vertex":
             if not parameters[3].value:
                  parameters[3].setErrorMessage("Split Tolerance > 0 needed.")
             else:
                  parameters[3].clearMessage                    
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sOpt = parameters[2].valueAsText
        if not sOpt:
             sOpt = "Vertex"
        dTol = parameters[3].valueAsText
        if not dTol:
             dTol = ""
        sUpF = parameters[4].valueAsText
        sNewUpF = ""
        if sUpF:
             value_table = arcpy.ValueTable(3)
             value_table.loadFromString(sUpF)
             for i in range(0, value_table.rowCount):
                  f1 = value_table.getValue(i,0)
                  r1 = value_table.getValue(i,1)
                  if (r1 == "RangeContinuous") or (r1 == "RangeAddress"):
                       f2 = value_table.getValue(i,2)
                  else:
                       f2 = ""
                  sNewUpF = sNewUpF+f1+" "+r1+" "+f2+";"
                       
        etFunction = "SplitPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sOpt,dTol,sNewUpF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SplitPolylinesWithLayer(object):
    def __init__(self):
        self.label       = "Split Polylines With Layer"
        self.description = "Splits a polyline dataset with the features from another dataset (Point, Multipoint, Polyline or Polygon). If the split dataset is a Point or Multipoint dataset, a search tolerance is required."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]

         # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        reference_dataset.filter.list = []
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
    
        #split_tolerance parameter
        split_tolerance = arcpy.Parameter(
            displayName="Split Tolerance",
            name="split_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # update_fields parameter
        update_fields = arcpy.Parameter(
            displayName="Field Update Rules",
            name="update_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        update_fields.parameterDependencies = [in_dataset.name]
        update_fields.columns = [["Field","Field"],["GPString", "UpdateRule"],["Field", "PairedField"]]
        update_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        update_fields.filters[1].type = "ValueList"
        update_fields.filters[1].list = ["Empty", "Copy", "Proportion","RangeContinuous","RangeAddress"]
        update_fields.filters[2].list = ["Double", "Float", "Short", "Long"]
                  
        parameters = [in_dataset,reference_dataset,out_dataset,split_tolerance,update_fields]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                     
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        sUpF = parameters[4].valueAsText
        sMsg = ""
        if sUpF:
             value_table = arcpy.ValueTable(3)
             value_table.loadFromString(sUpF)
             for i in range(0, value_table.rowCount):
                  f1 = value_table.getValue(i,0)
                  r1 = value_table.getValue(i,1)
                  if (r1 == "RangeContinuous") or (r1 == "RangeAddress"):
                       f2 = value_table.getValue(i,2)
                       if f2 == "":
                            parameters[4].setErrorMessage("RangeContinuous and RangeAddress require a Paired Field")
                       else:
                            parameters[4].clearMessage
        if parameters[0].valueAsText and parameters[1].valueAsText:
             refDataset  = arcpy.Describe(parameters[1].value).catalogPath
             refGeom  = arcpy.Describe(refDataset).shapeType     
             if (refGeom == "Point") or (refGeom == "Multipoint"):
                  if not parameters[3].value:
                       parameters[3].setErrorMessage("Split Tolerance > 0 needed.")
                  else:
                       parameters[3].clearMessage                    
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        refDataset = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        
        dTol = parameters[3].valueAsText
        if not dTol:
             dTol = ""
        sUpF = parameters[4].valueAsText
        sNewUpF = ""
        if sUpF:
             value_table = arcpy.ValueTable(3)
             value_table.loadFromString(sUpF)
             for i in range(0, value_table.rowCount):
                  f1 = value_table.getValue(i,0)
                  r1 = value_table.getValue(i,1)
                  if (r1 == "RangeContinuous") or (r1 == "RangeAddress"):
                       f2 = value_table.getValue(i,2)
                  else:
                       f2 = ""
                  sNewUpF = sNewUpF+f1+" "+r1+" "+f2+";"
                       
        etFunction = "SplitPolylinesWithLayer"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,refDataset,outDataset,dTol,sNewUpF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class DissolvePolygons(object):
    def __init__(self):
        self.label       = "Dissolve Polygons"
        self.description = "Dissolves a polygon layer using user specified dissolve fields."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
    
        # dissolve_fields parameter
        dissolve_fields = arcpy.Parameter(
            displayName="Dissolve Fields",
            name="dissolve_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        dissolve_fields.parameterDependencies = [in_dataset.name]
        dissolve_fields.columns = [["Field","Field"]]
        dissolve_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]

         # statistics_fields parameter
        statistics_fields = arcpy.Parameter(
            displayName="Statistics Fields",
            name="statistics_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        statistics_fields.parameterDependencies = [in_dataset.name]
        statistics_fields.columns = [["Field","Field"],["GPString", "SortMethod"]]
        statistics_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        statistics_fields.filters[1].type = "ValueList"
        statistics_fields.filters[1].list = ["SUM", "MAX", "MIN", "FIRST"]

         # create_multipart
        create_multipart = arcpy.Parameter(
            displayName="Create Multipart",
            name="create_multipart",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        create_multipart.value = "False"
                  
        parameters = [in_dataset,out_dataset,dissolve_fields,statistics_fields,create_multipart]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
             if parameters[0].altered:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  fieldTypes = []
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[2].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       fieldNames.append(fld)
                       for f in fList:
                            if f.name == fld:
                                 fieldTypes.append(f.type)
                  addFields = []
                  for fieldInd, fieldName in enumerate(fieldNames):
                       fieldType = fieldTypes[fieldInd]
                       newField = arcpy.Field()
                       newField.name = fieldName
                       newField.type = fieldType
                       addFields.append(newField) 
                  parameters[2].schema.additionalFields = addFields     
        except:
             a=0                        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        if parameters[0].altered:
             try:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  for f in fList:
                       fieldNames.append(f.name)
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[2].valueAsText)
                  value_table2 = arcpy.ValueTable(2)
                  value_table2.loadFromString(parameters[3].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[2].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[2].clearMessage
                  for i in range(0, value_table2.rowCount):
                       fld = value_table2.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[3].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[3].clearMessage
             except:
                  a=0                                
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sDisF = parameters[2].valueAsText
        if not sDisF:
             sDisF = ""
        sStatF = parameters[3].valueAsText
        if not sStatF:
             sStatF = ""
        bMulti = parameters[4].valueAsText
               
        etFunction = "DissolvePolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sDisF,sStatF,bMulti],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class FillPolygonHoles(object):
    def __init__(self):
        self.label       = "Fill Polygon Holes"
        self.description = "Removes the holes with area smaller than user specified tolerance. If there are island polygons in the input dataset, the function will create overlaps."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
    
        # max_area parameter
        max_area = arcpy.Parameter(
            displayName="Max Area(holes with smaller area will be filled)",
            name="max_area",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                  
        parameters = [in_dataset,out_dataset,max_area]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                   
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dAr = parameters[2].valueAsText
        if not dAr:
             dAr = "0"
                       
        etFunction = "FillPolygonHoles"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dAr],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CleanGaps(object):
    def __init__(self):
        self.label       = "CleanGaps"
        self.description = "Finds the gaps between polygons and holes within polygons and fills them with new polygons."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Gaps"]
        fieldTypes = ["LONG","String"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # clean_polygons
        clean_polygons = arcpy.Parameter(
            displayName="Clean Polygons",
            name="clean_polygons",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        clean_polygons.value = "False"
    
        # fuzzy_tolerance parameter
        fuzzy_tolerance = arcpy.Parameter(
            displayName="Fuzzy Tolerance",
            name="fuzzy_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
                  
        parameters = [in_dataset,out_dataset,clean_polygons,fuzzy_tolerance,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[4].value =  inUnit   
            except:
                 parameters[4].value = ""
        global inputVal
        if parameters[0].altered:
            inDataset  = parameters[0].valueAsText
            if not inDataset == inputVal:
                 try:
                      inputVal = inDataset
                      ext = arcpy.Describe(parameters[0].value).extent
                      w = abs(ext.XMax - ext.XMin)
                      h = abs(ext.YMax - ext.YMin)
                      parameters[3].value =  "{0:.8f}".format((w + h) / 2000000)
                 except:
                      parameters[3].value = "0"
        else:
            inputVal = ""
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        bClean  = parameters[2].valueAsText
        dFuzzy = parameters[3].valueAsText
        if not dFuzzy:
             dFuzzy = "0"
                       
        etFunction = "CleanGaps"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,bClean,dFuzzy],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolygonCharacteristics(object):
    def __init__(self):
        self.label       = "Polygon Characteristics"
        self.description = "Calculates some characteristics of the polygons from a polygon dataset: - Length (Longest Axis) ; - Width (max width perpendicular to the longest axis) ; - Thicknes Ratio ; - Circularity Ratio"
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Length","ET_Width","ET_Thick","ET_Circ","ET_Parts","ET_Holes","ET_Vert","ET_Depth","ET_Fract"]
        fieldTypes = ["LONG","Double","Double","Double","Double","Long","Long","Long","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # calc_depth
        calc_depth = arcpy.Parameter(
            displayName="Calculate Polygon Depth",
            name="calc_depth",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        calc_depth.value = "False"
    
        # calc_fract
        calc_fract = arcpy.Parameter(
            displayName="Calculate Fractality",
            name="calc_fract",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        calc_fract.value = "False"

        # linear_precision parameter
        linear_precision = arcpy.Parameter(
            displayName="Precision (2..8)",
            name="linear_precision",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")
        linear_precision.filter.type = 'Range'
        linear_precision.filter.list = [2,8]
        linear_precision.value = 3
                  
        parameters = [in_dataset,out_dataset,calc_depth,calc_fract,linear_precision]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[2].value:
             if parameters[3].value:
                  fieldNames = ["ET_ID","ET_Length","ET_Width","ET_Thick","ET_Circ","ET_Parts","ET_Holes","ET_Vert","ET_Depth","ET_Fract"]
                  fieldTypes = ["LONG","Double","Double","Double","Double","Long","Long","Long","Double","Double"]
             else:
                  fieldNames = ["ET_ID","ET_Length","ET_Width","ET_Thick","ET_Circ","ET_Parts","ET_Holes","ET_Vert","ET_Depth"]
                  fieldTypes = ["LONG","Double","Double","Double","Double","Long","Long","Long","Double"]
        else:
             if parameters[3].value:
                  fieldNames = ["ET_ID","ET_Length","ET_Width","ET_Thick","ET_Circ","ET_Parts","ET_Holes","ET_Vert","ET_Fract"]
                  fieldTypes = ["LONG","Double","Double","Double","Double","Long","Long","Long","Double"]
             else:
                  fieldNames = ["ET_ID","ET_Length","ET_Width","ET_Thick","ET_Circ","ET_Parts","ET_Holes","ET_Vert"]
                  fieldTypes = ["LONG","Double","Double","Double","Double","Long","Long","Long"]
             
        addFields = []
        for fieldInd, fieldName in enumerate(fieldNames):
              fieldType = fieldTypes[fieldInd]
              newField = arcpy.Field()
              newField.name = fieldName
              newField.type = fieldType
              addFields.append(newField) 
        parameters[1].schema.additionalFields = addFields            
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        bDepth  = parameters[2].valueAsText
        bFract  = parameters[3].valueAsText
        iLP = parameters[4].valueAsText
        if not iLP:
             iLP = "0"
                       
        etFunction = "PolygonCharacteristics"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,bDepth,bFract,iLP],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class AdvancedMerge(object):
    def __init__(self):
        self.label       = "Polygon Advanced Merge"
        self.description = "Merges two polygon data sets using user defined priority for the polygons of the layer to be merged."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Merge Features parameter
        merge_dataset = arcpy.Parameter(
            displayName="Merge Dataset",
            name="merge_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        merge_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # merge_priority parameter
        merge_priority = arcpy.Parameter(
            displayName="Merge Priority",
            name="merge_priority",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        merge_priority.filter.type = "ValueList"
        merge_priority.filter.list = ["Erase", "Low","Standard","High"]
        merge_priority.value = "Low"
        
        # add_all_attributes
        add_all_attributes = arcpy.Parameter(
            displayName="Add all attributes",
            name="add_all_attributes",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        add_all_attributes.value = "False"
        
        # force_topology
        force_topology = arcpy.Parameter(
            displayName="Force Topology",
            name="force_topology",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        force_topology.value = "True"
                  
        parameters = [in_dataset,merge_dataset,out_dataset,merge_priority,add_all_attributes,force_topology]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                   
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        priority  = parameters[3].valueAsText
        bAdd  = parameters[4].valueAsText
        bForce  = parameters[5].valueAsText
                              
        etFunction = "AdvancedMerge"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,priority,bAdd,bForce],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class Clip(object):
    def __init__(self):
        self.label       = "Clip"
        self.description = "Clips a feature class with the features of a polygon feature class."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

        # clip_dataset parameter
        clip_dataset = arcpy.Parameter(
            displayName="Clip Dataset",
            name="clip_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        clip_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # force_topology
        force_topology = arcpy.Parameter(
            displayName="Force Topology",
            name="force_topology",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        force_topology.value = "True" 
                         
        parameters = [in_dataset,clip_dataset,out_dataset,force_topology]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                   
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        bForce  = parameters[3].valueAsText
                                      
        etFunction = "ClipSingle"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,bForce],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class Erase(object):
    def __init__(self):
        self.label       = "Erase"
        self.description = "Erases a feature layer with the features of a polygon layer."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

        # erase_dataset parameter
        erase_dataset = arcpy.Parameter(
            displayName="Erase Dataset",
            name="erase_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        erase_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # force_topology
        force_topology = arcpy.Parameter(
            displayName="Force Topology",
            name="force_topology",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        force_topology.value = "True"
                         
        parameters = [in_dataset,erase_dataset,out_dataset,force_topology]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                   
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        bForce  = parameters[3].valueAsText
                                       
        etFunction = "EraseSingle"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,bForce],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SymmetricalDifference(object):
    def __init__(self):
        self.label       = "Symmetrical Difference"
        self.description = "Calculates the geometric intersection of the input polygon feature classes. Creates a polygon feature class that contains the polygons of both input datasets that do not overlap."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # second_dataset parameter
        second_dataset = arcpy.Parameter(
            displayName="Second Dataset",
            name="second_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        second_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # add_all_attributes
        add_all_attributes = arcpy.Parameter(
            displayName="Add all attributes",
            name="add_all_attributes",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        add_all_attributes.value = "False"
        
        # force_topology
        force_topology = arcpy.Parameter(
            displayName="Force Topology",
            name="force_topology",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        force_topology.value = "True"
                         
        parameters = [in_dataset,second_dataset,out_dataset,add_all_attributes,force_topology]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                   
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        bAtt  = parameters[3].valueAsText
        bForce  = parameters[4].valueAsText                              
        etFunction = "SymmetricalDifference"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,bAdd,bForce],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class MergeLayers(object):
    def __init__(self):
        self.label       = "MergeLayers"
        self.description = "Merges two feature datasets from the same type together."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

        # merge_dataset parameter
        merge_dataset = arcpy.Parameter(
            displayName="Merge Dataset",
            name="merge_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        merge_dataset.filter.list = []
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
                         
        parameters = [in_dataset,merge_dataset,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
             try:
                  inGeom  = arcpy.Describe(parameters[0].value).shapeType
                  parameters[1].filter.list = [inGeom]    
             except:
                  a=0          
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
                                      
        etFunction = "MergeLayers"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class MergeMulti(object):
    def __init__(self):
        self.label       = "Merge Multiple Layers"
        self.description = "Merges feature layers from the same type together."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

        # merge_datasets parameter
        merge_datasets = arcpy.Parameter(
            displayName="Merge Datasets",
            name="merge_datasets",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        #merge_datasets.parameterDependencies = [in_dataset.name]
        merge_datasets.columns = [["GPFeatureLayer","Merge Dataset"]]
        merge_datasets.filters[0].list = []
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
                         
        parameters = [in_dataset,merge_datasets,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
             try:
                  inGeom  = arcpy.Describe(parameters[0].value).shapeType
                  parameters[1].filters[0].list = [inGeom]    
             except:
                  a=0          
        return
        
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        sMerge = parameters[1].valueAsText
        mergeL = ""
        if sMerge:
             value_table = arcpy.ValueTable(1)
             value_table.loadFromString(sMerge)
             for i in range(0, value_table.rowCount):
                  f1 = value_table.getValue(i,0)
                  mergeDataset  = arcpy.Describe(f1).catalogPath
                  mergeL = mergeL+mergeDataset+";"
        
        outDataset  = parameters[2].valueAsText
                                      
        etFunction = "MergeMulti"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeL,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class RemoveDuplicates(object):
    def __init__(self):
        self.label       = "Remove Duplicates"
        self.description = "Removes duplates with exactly the same shape from a Point,Polyline or Polygon dataset.  If a reference dataset is selected all the features from the input dataset that have exactly the same shapes with a feature from the reference dataset will be excluded from the output."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
     
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
               
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # reference_dataset parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        reference_dataset.filter.list = []
                         
        parameters = [in_dataset,out_dataset,reference_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
             try:
                  inGeom  = arcpy.Describe(parameters[0].value).shapeType
                  parameters[2].filter.list = [inGeom]    
             except:
                  a=0          
        return   
                        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        refDataset = parameters[2].valueAsText
        if refDataset:
             refDataset  = arcpy.Describe(parameters[2].value).catalogPath
        else:
             refDataset=""                              
        etFunction = "RemoveDuplicates"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,refDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class TransferAttributes(object):
    def __init__(self):
        self.label       = "Transfer Polygon Attributes"
        self.description = "Transfers attributes from one polygon layer(source) to another(target)based on their spatial location. Three method for transfering available :  -Count (sum proportion) - census data etc. -Value (weighted average)- rainfall etc. - Type (majority) - soil type etc."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # source_dataset parameter
        source_dataset = arcpy.Parameter(
            displayName="Source Dataset",
            name="source_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        source_dataset.filter.list = ["Polygon"]

        # target_dataset parameter
        target_dataset = arcpy.Parameter(
            displayName="Target Dataset",
            name="target_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        target_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [target_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # transfer_fields parameter
        transfer_fields = arcpy.Parameter(
            displayName="Transfer Fields",
            name="transfer_fields",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        transfer_fields.parameterDependencies = [source_dataset.name]
        transfer_fields.columns = [["Field","Field"],["GPString", "TransferMethod"]]
        transfer_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Text","Integer"]
        transfer_fields.filters[1].type = "ValueList"
        transfer_fields.filters[1].list = ["Count", "Value", "Type"]
                         
        parameters = [source_dataset,target_dataset,out_dataset,transfer_fields]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
             if parameters[0].altered:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  fieldTypes = []
                  value_table = arcpy.ValueTable(2)
                  value_table.loadFromString(parameters[3].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       fieldNames.append(fld)
                       for f in fList:
                            if f.name == fld:
                                 fieldTypes.append(f.type)
                  addFields = []
                  for fieldInd, fieldName in enumerate(fieldNames):
                       fieldType = fieldTypes[fieldInd]
                       newField = arcpy.Field()
                       newField.name = fieldName
                       newField.type = fieldType
                       addFields.append(newField) 
                  parameters[2].schema.additionalFields = addFields     
        except:
             a=0                        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        
        if parameters[0].altered:
             fList  = arcpy.Describe(parameters[0].value).fields
             fieldNames = []
             for f in fList:
                  fieldNames.append(f.name)
             value_table = arcpy.ValueTable(2)
             value_table.loadFromString(parameters[3].valueAsText)
             for i in range(0, value_table.rowCount):
                  fld = value_table.getValue(i,0)
                  if fld not in fieldNames :     
                       parameters[3].setErrorMessage("Field does not exist!") 
                  else:
                       parameters[3].clearMessage       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        transDic  = parameters[3].valueAsText
                                      
        etFunction = "TransferAttributes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,transDic],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class BatchClip(object):
    def __init__(self):
        self.label       = "Batch Clip"
        self.description = "Clips multiple feature classes with the features of a polygon feature class."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # clip_dataset parameter
        clip_dataset = arcpy.Parameter(
            displayName="Clip Dataset",
            name="clip_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        clip_dataset.filter.list = ["Polygon"]

        # in_datasets parameter
        in_datasets = arcpy.Parameter(
            displayName="Datasets to Clip",
            name="in_datasets",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        in_datasets.columns = [["GPFeatureLayer","Dataset to Clip"]]
        in_datasets.filters[0].list = []
      
        # out_workspace parameter
        out_workspace = arcpy.Parameter(
            displayName="Output Workspace",
            name="out_workspace",
            datatype="DEWorkspace",
            parameterType="Required",
            direction="Input")

        # suffix parameter
        suffix  = arcpy.Parameter(
            displayName="Suffix",
            name="suffix ",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        suffix.value = "_clip"        
        parameters = [clip_dataset,in_datasets,out_workspace,suffix]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                                
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        clipDataset  = arcpy.Describe(parameters[0].value).catalogPath
        sIn = parameters[1].valueAsText
        inL = ""
        if sIn:
             value_table = arcpy.ValueTable(1)
             value_table.loadFromString(sIn)
             for i in range(0, value_table.rowCount):
                  f1 = value_table.getValue(i,0)
                  inDataset  = arcpy.Describe(f1).catalogPath
                  inL = inL+inDataset+";"
        
        outWorkspace  = parameters[2].valueAsText
        suf  = parameters[3].valueAsText
        if not suf:
             suf = ""                              
        etFunction = "BatchClip"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inL,clipDataset,outWorkspace,suf],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class BatchErase(object):
    def __init__(self):
        self.label       = "Batch Erase"
        self.description = "Erases multiple feature classes with the features of a polygon feature class."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # clip_dataset parameter
        clip_dataset = arcpy.Parameter(
            displayName="Erase Dataset",
            name="clip_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        clip_dataset.filter.list = ["Polygon"]

        # in_datasets parameter
        in_datasets = arcpy.Parameter(
            displayName="Datasets to Erase",
            name="in_datasets",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        in_datasets.columns = [["GPFeatureLayer","Dataset to Erase"]]
        in_datasets.filters[0].list = []
      
        # out_workspace parameter
        out_workspace = arcpy.Parameter(
            displayName="Output Workspace",
            name="out_workspace",
            datatype="DEWorkspace",
            parameterType="Required",
            direction="Input")

        # suffix parameter
        suffix  = arcpy.Parameter(
            displayName="Suffix",
            name="suffix ",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        suffix.value = "_erase"        
        parameters = [clip_dataset,in_datasets,out_workspace,suffix]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                                
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                       
        return

    def execute(self, parameters, messages):
        clipDataset  = arcpy.Describe(parameters[0].value).catalogPath
        sIn = parameters[1].valueAsText
        inL = ""
        if sIn:
             value_table = arcpy.ValueTable(1)
             value_table.loadFromString(sIn)
             for i in range(0, value_table.rowCount):
                  f1 = value_table.getValue(i,0)
                  inDataset  = arcpy.Describe(f1).catalogPath
                  inL = inL+inDataset+";"
        
        outWorkspace  = parameters[2].valueAsText
        suf  = parameters[3].valueAsText
        if not suf:
             suf = ""                              
        etFunction = "BatchErase"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inL,clipDataset,outWorkspace,suf],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SplitByLocation(object):
    def __init__(self):
        self.label       = "Split By Location"
        self.description = "Splits the features of the input dataset with the polygons of the split layer. Creates a new dataset for each polygon from the clip dataset."
        self.category = "Overlay"
        
    def getParameterInfo(self):
         # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

        # clip_dataset parameter
        clip_dataset = arcpy.Parameter(
            displayName="Clip Dataset",
            name="clip_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        clip_dataset.filter.list = ["Polygon"]
    
        # out_workspace parameter
        out_workspace = arcpy.Parameter(
            displayName="Output Workspace",
            name="out_workspace",
            datatype="DEWorkspace",
            parameterType="Required",
            direction="Input")
 
        # name_field
        name_field = arcpy.Parameter(
            displayName="Name Field",
            name="name_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        name_field.parameterDependencies = [clip_dataset.name]
        name_field.filter.list = ["Double", "Float", "Short", "Long","Integer","String","Text"]

        # prefix parameter
        prefix  = arcpy.Parameter(
            displayName="Prefix",
            name="prefix",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        prefix.value = "split_"
        
        parameters = [in_dataset,clip_dataset,out_workspace,name_field,prefix]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                                
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        clipDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outWorkspace  = parameters[2].valueAsText
        f  = parameters[3].valueAsText
        pre  = parameters[4].valueAsText
        if not pre:
             pre = ""                              
        etFunction = "SplitByLocation"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,clipDataset,outWorkspace,f,pre],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SplitByAttributes(object):
    def __init__(self):
        self.label       = "Split By Attributes"
        self.description = "Splits a dataset into separate datasets based on the attribute values in the selected field."
        self.category = "Overlay"
        
    def getParameterInfo(self):
         # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

        # out_workspace parameter
        out_workspace = arcpy.Parameter(
            displayName="Output Workspace",
            name="out_workspace",
            datatype="DEWorkspace",
            parameterType="Required",
            direction="Input")
 
        # split_field
        split_field = arcpy.Parameter(
            displayName="Split Field",
            name="split_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        split_field.parameterDependencies = [in_dataset.name]
        split_field.filter.list = ["Double", "Float", "Short", "Long","Integer","String","Text"]

        # prefix parameter
        prefix  = arcpy.Parameter(
            displayName="Prefix",
            name="prefix",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        prefix.value = "split_"
        
        parameters = [in_dataset,out_workspace,split_field,prefix]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                                
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outWorkspace  = parameters[1].valueAsText
        f  = parameters[2].valueAsText
        pre  = parameters[3].valueAsText
        if not pre:
             pre = ""                              
        etFunction = "SplitByAttributes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outWorkspace,f,pre],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class VectorGridExtent(object):
    def __init__(self):
        self.label       = "Vector Grid Extent"
        self.description = "Creates a polygon or polyline grid using grid extents X and Y cell size."
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Index"]
        fieldTypes = ["LONG","String"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
         # grid_type parameter
        grid_type = arcpy.Parameter(
            displayName="Grid Type",
            name="grid_type",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        grid_type.filter.type = "ValueList"
        grid_type.filter.list = ["Polygon", "Polyline"]
        grid_type.value = "Polygon"
 
        # cell_size_x parameter
        cell_size_x = arcpy.Parameter(
            displayName="Cell Size X",
            name="cell_size_x",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # cell_size_y parameter
        cell_size_y = arcpy.Parameter(
            displayName="Cell Size Y",
            name="cell_size_y",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # extents_from_ref
        extents_from_ref = arcpy.Parameter(
            displayName="Extents from Reference Layer",
            name="extents_from_ref",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        extents_from_ref.value = "True"
        
        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        reference_dataset.filter.list = []

       # min_x parameter
        min_x = arcpy.Parameter(
            displayName="Min X",
            name="min_x",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # min_y parameter
        min_y = arcpy.Parameter(
            displayName="Min Y",
            name="min_y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        # max_x parameter
        max_x = arcpy.Parameter(
            displayName="Max X",
            name="max_x",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # max_y parameter
        max_y = arcpy.Parameter(
            displayName="Max Y",
            name="max_y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        parameters = [out_dataset,grid_type,cell_size_x,cell_size_y,extents_from_ref,reference_dataset,min_x,min_y,max_x,max_y]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
            if parameters[4].value and parameters[5].valueAsText:
                ext = arcpy.Describe(parameters[5].value).extent  
                parameters[6].value = ext.XMin  
                parameters[7].value = ext.YMin
                parameters[8].value = ext.XMax
                parameters[9].value = ext.YMax
        except:
            a=0
        if parameters[1].valueAsText == "Polyline":
            parameters[0].schema.geometryType = "Polyline"
        else:
            parameters[0].schema.geometryType = "Polygon" 
                    
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        outDataset  = parameters[0].valueAsText
        gType  = parameters[1].valueAsText
        dCellX = parameters[2].valueAsText
        dCellY = parameters[3].valueAsText
        bFrom = parameters[4].valueAsText
        refD = parameters[5].valueAsText
        if refD:
             refDataset  = arcpy.Describe(parameters[5].value).catalogPath
        else:
             refDataset = ""
        xMin  = parameters[6].valueAsText
        if not xMin:
             xMin = ""  
        yMin  = parameters[7].valueAsText
        if not yMin:
             yMin = ""
        xMax  = parameters[8].valueAsText
        if not xMax:
             xMax = ""
        yMax  = parameters[9].valueAsText
        if not yMax:
             yMax = ""                            
        etFunction = "VectorGridExtent"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,outDataset,gType,dCellX,dCellY,bFrom,refDataset,xMin,yMin,xMax,yMax],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointGridExtent(object):
    def __init__(self):
        self.label       = "Point Grid Extent"
        self.description = "Creates a grid of points using grid extents and distance between the points."
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
         # grid_type parameter
        grid_type = arcpy.Parameter(
            displayName="Grid Type",
            name="grid_type",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        grid_type.filter.type = "ValueList"
        grid_type.filter.list = ["Rectangle", "Square","Triangle"]
        grid_type.value = "Rectangle"
 
        # cell_size_x parameter
        cell_size_x = arcpy.Parameter(
            displayName="Cell Size X",
            name="cell_size_x",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # cell_size_y parameter
        cell_size_y = arcpy.Parameter(
            displayName="Cell Size Y",
            name="cell_size_y",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # extents_from_ref
        extents_from_ref = arcpy.Parameter(
            displayName="Extents from Reference Layer",
            name="extents_from_ref",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        extents_from_ref.value = "True"
        
        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        reference_dataset.filter.list = []

       # min_x parameter
        min_x = arcpy.Parameter(
            displayName="Min X",
            name="min_x",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # min_y parameter
        min_y = arcpy.Parameter(
            displayName="Min Y",
            name="min_y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        # max_x parameter
        max_x = arcpy.Parameter(
            displayName="Max X",
            name="max_x",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # max_y parameter
        max_y = arcpy.Parameter(
            displayName="Max Y",
            name="max_y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        parameters = [out_dataset,grid_type,cell_size_x,cell_size_y,extents_from_ref,reference_dataset,min_x,min_y,max_x,max_y]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
            if parameters[4].value and parameters[5].valueAsText:
                ext = arcpy.Describe(parameters[5].value).extent  
                parameters[6].value = ext.XMin  
                parameters[7].value = ext.YMin
                parameters[8].value = ext.XMax
                parameters[9].value = ext.YMax
        except:
            a=0
        if (parameters[1].valueAsText == "Square") or (parameters[1].valueAsText == "Triangle"):
            parameters[3].value = parameters[2].value
                            
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                   
        return

    def execute(self, parameters, messages):
        outDataset  = parameters[0].valueAsText
        gType  = parameters[1].valueAsText
        dCellX = parameters[2].valueAsText
        dCellY = parameters[3].valueAsText
        bFrom = parameters[4].valueAsText
        refD = parameters[5].valueAsText
        if refD:
             refDataset  = arcpy.Describe(parameters[5].value).catalogPath
        else:
             refDataset = ""
        xMin  = parameters[6].valueAsText
        if not xMin:
             xMin = ""  
        yMin  = parameters[7].valueAsText
        if not yMin:
             yMin = ""
        xMax  = parameters[8].valueAsText
        if not xMax:
             xMax = ""
        yMax  = parameters[9].valueAsText
        if not yMax:
             yMax = ""                            
        etFunction = "PointGridExtent"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,outDataset,gType,dCellX,dCellY,bFrom,refDataset,xMin,yMin,xMax,yMax],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CreateTilesExtent(object):
    def __init__(self):
        self.label       = "Create Tiles Extent"
        self.description = "Creates a regular polygon grid with user defined extents,tile size and shape."
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # tiles_shape parameter
        tiles_shape = arcpy.Parameter(
            displayName="Tiles Shape",
            name="tiles_shape",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        tiles_shape.filter.type = "ValueList"
        tiles_shape.filter.list = ["Hexagon", "Square","Triangle"]
        tiles_shape.value = "Hexagon"

        # size_represents parameter
        size_represents = arcpy.Parameter(
            displayName="Size Represents",
            name="size_represents",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        size_represents.filter.type = "ValueList"
        size_represents.filter.list = ["Side", "RadiusIn","RadiusOut"]
        size_represents.value = "Side"
 
        # tile_size parameter
        tile_size = arcpy.Parameter(
            displayName="Tile Size",
            name="tile_size",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # tile_orientation parameter
        tile_orientation = arcpy.Parameter(
            displayName="Tile Orientation",
            name="tile_orientation",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        tile_orientation.filter.type = "ValueList"
        tile_orientation.filter.list = ["Flat", "Pointy"]
        tile_orientation.value = "Flat"

        # extents_from_ref
        extents_from_ref = arcpy.Parameter(
            displayName="Extents from Reference Layer",
            name="extents_from_ref",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        extents_from_ref.value = "True"
        
        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        reference_dataset.filter.list = []

       # min_x parameter
        min_x = arcpy.Parameter(
            displayName="Min X",
            name="min_x",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # min_y parameter
        min_y = arcpy.Parameter(
            displayName="Min Y",
            name="min_y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        # max_x parameter
        max_x = arcpy.Parameter(
            displayName="Max X",
            name="max_x",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # max_y parameter
        max_y = arcpy.Parameter(
            displayName="Max Y",
            name="max_y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        parameters = [out_dataset,tiles_shape,size_represents,tile_size,tile_orientation,extents_from_ref,reference_dataset,min_x,min_y,max_x,max_y]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
            if parameters[5].value and parameters[6].valueAsText:
                ext = arcpy.Describe(parameters[6].value).extent  
                parameters[7].value = ext.XMin  
                parameters[8].value = ext.YMin
                parameters[9].value = ext.XMax
                parameters[10].value = ext.YMax
        except:
            a=0
                                    
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        outDataset  = parameters[0].valueAsText
        gType  = parameters[1].valueAsText
        sizeRepre = parameters[2].valueAsText
        size = parameters[3].valueAsText
        orient = parameters[4].valueAsText
        bFrom = parameters[5].valueAsText
        refD = parameters[6].valueAsText
        if refD:
             refDataset  = arcpy.Describe(parameters[6].value).catalogPath
        else:
             refDataset = ""
        xMin  = parameters[7].valueAsText
        if not xMin:
             xMin = ""  
        yMin  = parameters[8].valueAsText
        if not yMin:
             yMin = ""
        xMax  = parameters[9].valueAsText
        if not xMax:
             xMax = ""
        yMax  = parameters[10].valueAsText
        if not yMax:
             yMax = ""                            
        etFunction = "CreateTilesExtent"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,outDataset,gType,sizeRepre,size,orient,bFrom,refDataset,xMin,yMin,xMax,yMax],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CreateTilesOrigin(object):
    def __init__(self):
        self.label       = "Create Tiles Origin"
        self.description = "Creates a regular polygon grid with user defined origin, number of columns and rows."
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # tiles_shape parameter
        tiles_shape = arcpy.Parameter(
            displayName="Tiles Shape",
            name="tiles_shape",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        tiles_shape.filter.type = "ValueList"
        tiles_shape.filter.list = ["Hexagon", "Square","Triangle"]
        tiles_shape.value = "Hexagon"

        # number_columns parameter
        number_columns = arcpy.Parameter(
            displayName="Number Columns",
            name="number_columns",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # number_rows parameter
        number_rows = arcpy.Parameter(
            displayName="Number Rows",
            name="number_rows",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # size_represents parameter
        size_represents = arcpy.Parameter(
            displayName="Size Represents",
            name="size_represents",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        size_represents.filter.type = "ValueList"
        size_represents.filter.list = ["Side", "RadiusIn","RadiusOut"]
        size_represents.value = "Side"
 
        # tile_size parameter
        tile_size = arcpy.Parameter(
            displayName="Tile Size",
            name="tile_size",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # tile_orientation parameter
        tile_orientation = arcpy.Parameter(
            displayName="Tile Orientation",
            name="tile_orientation",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        tile_orientation.filter.type = "ValueList"
        tile_orientation.filter.list = ["Flat", "Pointy"]
        tile_orientation.value = "Flat"

        # extents_from_ref
        extents_from_ref = arcpy.Parameter(
            displayName="Origin from Reference Layer",
            name="extents_from_ref",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        extents_from_ref.value = "True"
        
        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        reference_dataset.filter.list = []

       # min_x parameter
        min_x = arcpy.Parameter(
            displayName="Min X",
            name="min_x",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # min_y parameter
        min_y = arcpy.Parameter(
            displayName="Min Y",
            name="min_y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        parameters = [out_dataset,tiles_shape,number_columns,number_rows,size_represents,tile_size,tile_orientation,extents_from_ref,reference_dataset,min_x,min_y]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
            if parameters[7].value and parameters[8].valueAsText:
                ext = arcpy.Describe(parameters[8].value).extent  
                parameters[9].value = ext.XMin  
                parameters[10].value = ext.YMin
        except:
            a=0
                                                
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        outDataset  = parameters[0].valueAsText
        gType  = parameters[1].valueAsText
        cols = parameters[2].valueAsText
        rows = parameters[3].valueAsText
        sizeRepre = parameters[4].valueAsText
        size = parameters[5].valueAsText
        orient = parameters[6].valueAsText
        bFrom = parameters[7].valueAsText
        refD = parameters[8].valueAsText
        if refD:
             refDataset  = arcpy.Describe(parameters[8 ].value).catalogPath
        else:
             refDataset = ""
        xMin  = parameters[9].valueAsText
        if not xMin:
             xMin = ""  
        yMin  = parameters[10].valueAsText
        if not yMin:
             yMin = ""
                                    
        etFunction = "CreateTilesOrigin"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,outDataset,gType,cols,rows,sizeRepre,size,orient,bFrom,refDataset,xMin,yMin],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class VectorGridOrigin(object):
    def __init__(self):
        self.label       = "Vector Grid Origin"
        self.description = "Creates a polygon or polyline grid using origin point, number of columns and rows, X and Y cell size."
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Index"]
        fieldTypes = ["LONG","String"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
         # grid_type parameter
        grid_type = arcpy.Parameter(
            displayName="Grid Type",
            name="grid_type",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        grid_type.filter.type = "ValueList"
        grid_type.filter.list = ["Polygon", "Polyline"]
        grid_type.value = "Polygon"
 
        # cell_size_x parameter
        cell_size_x = arcpy.Parameter(
            displayName="Cell Size X",
            name="cell_size_x",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # cell_size_y parameter
        cell_size_y = arcpy.Parameter(
            displayName="Cell Size Y",
            name="cell_size_y",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # number_columns parameter
        number_columns = arcpy.Parameter(
            displayName="Number Columns",
            name="number_columns",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # number_rows parameter
        number_rows = arcpy.Parameter(
            displayName="Number Rows",
            name="number_rows",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # extents_from_ref
        extents_from_ref = arcpy.Parameter(
            displayName="Origin from Reference Layer",
            name="extents_from_ref",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        extents_from_ref.value = "True"
        
        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        reference_dataset.filter.list = []

       # min_x parameter
        min_x = arcpy.Parameter(
            displayName="Min X",
            name="min_x",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # min_y parameter
        min_y = arcpy.Parameter(
            displayName="Min Y",
            name="min_y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
               
        parameters = [out_dataset,grid_type,cell_size_x,cell_size_y,number_columns,number_rows,extents_from_ref,reference_dataset,min_x,min_y]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
            if parameters[6].value and parameters[7].valueAsText:
                ext = arcpy.Describe(parameters[7].value).extent  
                parameters[8].value = ext.XMin  
                parameters[9].value = ext.YMin
        except:
            a=0
        if parameters[1].valueAsText == "Polyline":
            parameters[0].schema.geometryType = "Polyline"
        else:
            parameters[0].schema.geometryType = "Polygon" 
                    
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        outDataset  = parameters[0].valueAsText
        gType  = parameters[1].valueAsText
        dCellX = parameters[2].valueAsText
        dCellY = parameters[3].valueAsText
        columns = parameters[4].valueAsText
        rows = parameters[5].valueAsText
        bFrom = parameters[6].valueAsText
        refD = parameters[7].valueAsText
        if refD:
             refDataset  = arcpy.Describe(parameters[7].value).catalogPath
        else:
             refDataset = ""
        xMin  = parameters[8].valueAsText
        if not xMin:
             xMin = ""  
        yMin  = parameters[9].valueAsText
        if not yMin:
             yMin = ""
                            
        etFunction = "VectorGridOrigin"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,outDataset,gType,dCellX,dCellY,columns,rows,bFrom,refDataset,xMin,yMin],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointGridOrigin(object):
    def __init__(self):
        self.label       = "Point Grid Origin"
        self.description = "Creates a rectangular, square or triangular point grid using origin point, number of columns and rows, X and Y cell size."
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Index"]
        fieldTypes = ["LONG","String"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # grid_type parameter
        grid_type = arcpy.Parameter(
            displayName="Grid Type",
            name="grid_type",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        grid_type.filter.type = "ValueList"
        grid_type.filter.list = ["Rectangle", "Square","Triangle"]
        grid_type.value = "Rectangle"
 
        # cell_size_x parameter
        cell_size_x = arcpy.Parameter(
            displayName="Cell Size X",
            name="cell_size_x",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # cell_size_y parameter
        cell_size_y = arcpy.Parameter(
            displayName="Cell Size Y",
            name="cell_size_y",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # number_columns parameter
        number_columns = arcpy.Parameter(
            displayName="Number Columns",
            name="number_columns",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # number_rows parameter
        number_rows = arcpy.Parameter(
            displayName="Number Rows",
            name="number_rows",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # extents_from_ref
        extents_from_ref = arcpy.Parameter(
            displayName="Origin from Reference Layer",
            name="extents_from_ref",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        extents_from_ref.value = "True"
        
        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        reference_dataset.filter.list = []

       # min_x parameter
        min_x = arcpy.Parameter(
            displayName="Min X",
            name="min_x",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # min_y parameter
        min_y = arcpy.Parameter(
            displayName="Min Y",
            name="min_y",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
               
        parameters = [out_dataset,grid_type,cell_size_x,cell_size_y,number_columns,number_rows,extents_from_ref,reference_dataset,min_x,min_y]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
            if parameters[6].value and parameters[7].valueAsText:
                ext = arcpy.Describe(parameters[7].value).extent  
                parameters[8].value = ext.XMin  
                parameters[9].value = ext.YMin
        except:
            a=0
        if (parameters[1].valueAsText == "Square") or (parameters[1].valueAsText == "Triangle"):
            parameters[3].value = parameters[2].value 
                    
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        outDataset  = parameters[0].valueAsText
        gType  = parameters[1].valueAsText
        dCellX = parameters[2].valueAsText
        dCellY = parameters[3].valueAsText
        columns = parameters[4].valueAsText
        rows = parameters[5].valueAsText
        bFrom = parameters[6].valueAsText
        refD = parameters[7].valueAsText
        if refD:
             refDataset  = arcpy.Describe(parameters[7].value).catalogPath
        else:
             refDataset = ""
        xMin  = parameters[8].valueAsText
        if not xMin:
             xMin = ""  
        yMin  = parameters[9].valueAsText
        if not yMin:
             yMin = ""
                            
        etFunction = "PointGridOrigin"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,outDataset,gType,dCellX,dCellY,columns,rows,bFrom,refDataset,xMin,yMin],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class UniformPointsInPolygons(object):
    def __init__(self):
        self.label       = "Uniform Points In Polygons"
        self.description = "Creates regularly spaced points inside polygons based on user defined number of points per polygon. The distance between the points is interpolated for each polygon)."
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_X","ET_Y","ET_Dist"]
        fieldTypes = ["LONG","Double","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

         # angle_from parameter
        angle_from = arcpy.Parameter(
            displayName="Angle From",
            name="angle_from",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        angle_from.filter.type = "ValueList"
        angle_from.filter.list = ["Constant","FromField","LongestAxis","LongestSide"]
        angle_from.value = "LongestAxis"

        # number_points parameter
        number_points = arcpy.Parameter(
            displayName="Number Points",
            name="number_points",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")

        # number_points_field
        number_points_field = arcpy.Parameter(
            displayName="Number Points Field",
            name="number_points_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        number_points_field.parameterDependencies = [in_dataset.name]
        number_points_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

         # angle parameter
        angle = arcpy.Parameter(
            displayName="Rotation Angle",
            name="angle",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # angle_field
        angle_field = arcpy.Parameter(
            displayName="Rotation Angle Field",
            name="angle_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        angle_field.parameterDependencies = [in_dataset.name]
        angle_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # min_dist parameter
        min_dist = arcpy.Parameter(
            displayName="Min Distance to Boundary",
            name="min_dist",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,angle_from,number_points,number_points_field,angle,angle_field,min_dist]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if (parameters[2].valueAsText == "LongestAxis") or (parameters[2].valueAsText == "LongestSide"):
             parameters[5].enabled = False
             parameters[6].enabled = False
        else:
             parameters[5].enabled = True
             parameters[6].enabled = True
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if (parameters[0].valueAsText) and (parameters[1].valueAsText):
            if not (parameters[3].valueAsText) and not (parameters[4].valueAsText):
                 parameters[3].setErrorMessage("Number Points or Number Points Field needed!")
            else:
                 parameters[3].clearMessage
        return      

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sAngFrom  = parameters[2].valueAsText
        iNum = parameters[3].valueAsText
        if not iNum:
            iNum = "0"
        sNF = parameters[4].valueAsText
        if not sNF:
            sNF = ""
        dA = parameters[5].valueAsText
        if not dA:
            dA = "0"
        sAF = parameters[6].valueAsText
        if not sAF:
            sAF = ""
        sDist = parameters[7].valueAsText
        if not sDist:
            sDist = ""
                       
        etFunction = "UniformPointsInPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sAngFrom,iNum,sNF,dA,sAF,sDist],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class RandomPointsInPolygons(object):
    def __init__(self):
        self.label       = "Random Points In Polygons"
        self.description = "Generates random points located in the polygons of the input polygon dataset. The number of points per polygon can be constant or different for each polygon - based on the values in a numeric field of the input layer."
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_X","ET_Y"]
        fieldTypes = ["LONG","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # number_points parameter
        number_points = arcpy.Parameter(
            displayName="Number Points",
            name="number_points",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")

        # number_points_field
        number_points_field = arcpy.Parameter(
            displayName="Number Points Field",
            name="number_points_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        number_points_field.parameterDependencies = [in_dataset.name]
        number_points_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

         # min_dist_between parameter
        min_dist_between = arcpy.Parameter(
            displayName="Min Distance Between Points",
            name="min_dist_between",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # min_dist_bound parameter
        min_dist_bound = arcpy.Parameter(
            displayName="Min Distance to Boundary",
            name="min_dist_bound",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
            
        # distance_between_field
        distance_between_field = arcpy.Parameter(
            displayName="Minimum destance between points field",
            name="distance_between_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        distance_between_field.parameterDependencies = [in_dataset.name]
        distance_between_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]
        
         # distance_boundary_field
        distance_boundary_field = arcpy.Parameter(
            displayName="Minimum distance to boundary field",
            name="distance_boundary_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        distance_boundary_field.parameterDependencies = [in_dataset.name]
        distance_boundary_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]
                    
        parameters = [in_dataset, out_dataset,number_points,number_points_field,min_dist_between,min_dist_bound,distance_between_field,distance_boundary_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if (parameters[0].valueAsText) and (parameters[1].valueAsText):
            if not (parameters[2].valueAsText) and not (parameters[3].valueAsText):
                 parameters[2].setErrorMessage("Number Points or Number Points Field needed!")
            else:
                 parameters[2].clearMessage
        return      

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        iNum = parameters[2].valueAsText
        if not iNum:
            iNum = "0"
        sNF = parameters[3].valueAsText
        if not sNF:
            sNF = ""
        dBet = parameters[4].valueAsText
        if not dBet:
            dBet = "0"
        dBound = parameters[5].valueAsText
        if not dBound:
            dBound = ""
        sBetweenF = parameters[6].valueAsText
        if not sBetweenF:
            sBetweenF = ""
        sBoundaryF = parameters[7].valueAsText
        if not sBoundaryF:
            sBoundaryF = ""
                       
        etFunction = "RandomPointsInPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,iNum,sNF,dBet,dBound,sBetweenF,sBoundaryF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class RandomPointsOnPolylines(object):
    def __init__(self):
        self.label       = "Random Points On Polylines"
        self.description = "Generates random points located on the polylines of the input polyline dataset. The number of points per polyline can be constant or different for each polyline - based on the values in a numeric field of the input polyline layer."
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_X","ET_Y","ET_STATION"]
        fieldTypes = ["LONG","Double","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # number_points parameter
        number_points = arcpy.Parameter(
            displayName="Number Points",
            name="number_points",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")

        # number_points_field
        number_points_field = arcpy.Parameter(
            displayName="Number Points Field",
            name="number_points_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        number_points_field.parameterDependencies = [in_dataset.name]
        number_points_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # min_dist_bound parameter
        min_dist_bound = arcpy.Parameter(
            displayName="Min Distance to Ends",
            name="min_dist_bound",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
            
        # distance_end_field
        distance_end_field = arcpy.Parameter(
            displayName="Minimum distance to ends field",
            name="distance_end_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        distance_end_field.parameterDependencies = [in_dataset.name]
        distance_end_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]
                    
        parameters = [in_dataset, out_dataset,number_points,number_points_field,min_dist_bound,distance_end_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if (parameters[0].valueAsText) and (parameters[1].valueAsText):
            if not (parameters[2].valueAsText) and not (parameters[3].valueAsText):
                 parameters[2].setErrorMessage("Number Points or Number Points Field needed!")
            else:
                 parameters[2].clearMessage
        return      

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        iNum = parameters[2].valueAsText
        if not iNum:
            iNum = "0"
        sNF = parameters[3].valueAsText
        if not sNF:
            sNF = ""
        dEnd = parameters[4].valueAsText
        if not dEnd:
            dEnd = "0"
        
        sEndF = parameters[5].valueAsText
        if not sEndF:
            sEndF = ""
                               
        etFunction = "RandomPointsOnPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,iNum,sNF,dEnd,sEndF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointGridsInPolygons(object):
    def __init__(self):
        self.label       = "Point Grids In Polygons"
        self.description = "Creates point grids within the polygons of the input datasets. The distance between the points can be constant number or different for each polygon based on a field in the polygon attribute table)."
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_X","ET_Y"]
        fieldTypes = ["LONG","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

         # angle_from parameter
        angle_from = arcpy.Parameter(
            displayName="Angle From",
            name="angle_from",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        angle_from.filter.type = "ValueList"
        angle_from.filter.list = ["Constant","FromField","LongestAxis","LongestSide"]
        angle_from.value = "LongestAxis"

        # distance parameter
        distance = arcpy.Parameter(
            displayName="Distance Between Points",
            name="distance",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")

        # distance_field
        distance_field = arcpy.Parameter(
            displayName="Distance Between Points Field",
            name="distance_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        distance_field.parameterDependencies = [in_dataset.name]
        distance_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

         # angle parameter
        angle = arcpy.Parameter(
            displayName="Rotation Angle",
            name="angle",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # angle_field
        angle_field = arcpy.Parameter(
            displayName="Rotation Angle Field",
            name="angle_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        angle_field.parameterDependencies = [in_dataset.name]
        angle_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]
                          
        parameters = [in_dataset, out_dataset,angle_from,distance,distance_field,angle,angle_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if (parameters[2].valueAsText == "LongestAxis") or (parameters[2].valueAsText == "LongestSide"):
             parameters[5].enabled = False
             parameters[6].enabled = False
        else:
             parameters[5].enabled = True
             parameters[6].enabled = True
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if (parameters[0].valueAsText) and (parameters[1].valueAsText):
            if not (parameters[3].valueAsText) and not (parameters[4].valueAsText):
                 parameters[3].setErrorMessage("Distance or Distance Field needed!")
            else:
                 parameters[3].clearMessage
        return      

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sAngFrom  = parameters[2].valueAsText
        dDist = parameters[3].valueAsText
        if not dDist:
            dDist = "0"
        sDF = parameters[4].valueAsText
        if not sDF:
            sDF = ""
        dA = parameters[5].valueAsText
        if not dA:
            dA = "0"
        sAF = parameters[6].valueAsText
        if not sAF:
            sAF = ""
        
                       
        etFunction = "PointGridsInPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sAngFrom,dDist,sDF,dA,sAF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SquareGridsInPolygons(object):
    def __init__(self):
        self.label       = "Square Grids In Polygons"
        self.description = "Creates square grids within the polygons of the input datasets. The side of the squares can be constant number or different for each polygon based on a field in the polygon attribute table)"
        self.category = "Sampling"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

         # angle_from parameter
        angle_from = arcpy.Parameter(
            displayName="Angle From",
            name="angle_from",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        angle_from.filter.type = "ValueList"
        angle_from.filter.list = ["Constant","FromField","LongestAxis","LongestSide"]
        angle_from.value = "LongestAxis"

        # cell_size parameter
        cell_size = arcpy.Parameter(
            displayName="Cell Size",
            name="cell_size",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")

        # cell_size_field
        cell_size_field = arcpy.Parameter(
            displayName="Cell Size Field",
            name="cell_size_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        cell_size_field.parameterDependencies = [in_dataset.name]
        cell_size_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

         # angle parameter
        angle = arcpy.Parameter(
            displayName="Rotation Angle",
            name="angle",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # angle_field
        angle_field = arcpy.Parameter(
            displayName="Rotation Angle Field",
            name="angle_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        angle_field.parameterDependencies = [in_dataset.name]
        angle_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # inside_only
        inside_only = arcpy.Parameter(
            displayName="Squares inside Polygons Only",
            name="inside_only",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        inside_only.value = "False"
                          
        parameters = [in_dataset, out_dataset,angle_from,cell_size,cell_size_field,angle,angle_field,inside_only]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if (parameters[2].valueAsText == "LongestAxis") or (parameters[2].valueAsText == "LongestSide"):
             parameters[5].enabled = False
             parameters[6].enabled = False
        else:
             parameters[5].enabled = True
             parameters[6].enabled = True
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if (parameters[0].valueAsText) and (parameters[1].valueAsText):
            if not (parameters[3].valueAsText) and not (parameters[4].valueAsText):
                 parameters[3].setErrorMessage("Distance or Distance Field needed!")
            else:
                 parameters[3].clearMessage
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sAngFrom  = parameters[2].valueAsText
        dDist = parameters[3].valueAsText
        if not dDist:
            dDist = "0"
        sDF = parameters[4].valueAsText
        if not sDF:
            sDF = ""
        dA = parameters[5].valueAsText
        if not dA:
            dA = "0"
        sAF = parameters[6].valueAsText
        if not sAF:
            sAF = ""
        bIn = parameters[7].valueAsText
                       
        etFunction = "SquareGridsInPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sAngFrom,dDist,sDF,dA,sAF,bIn],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsToPieSegments(object):
    def __init__(self):
        self.label       = "Points To Pie Segments"
        self.description = "Creates Pie segment polygons from points, pie direction, radius and central angle."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # direction_field
        direction_field = arcpy.Parameter(
            displayName="Direction Field",
            name="direction_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        direction_field.parameterDependencies = [in_dataset.name]
        direction_field.filter.list = ["Double", "Float", "Short", "Long","Integer","String","Text"]

        # distance_field
        distance_field = arcpy.Parameter(
            displayName="Distance Field",
            name="distance_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        distance_field.parameterDependencies = [in_dataset.name]
        distance_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # angle_field
        angle_field = arcpy.Parameter(
            displayName="Central Angle Field",
            name="angle_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        angle_field.parameterDependencies = [in_dataset.name]
        angle_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

         # direction_type parameter
        direction_type = arcpy.Parameter(
            displayName="Direction Type",
            name="direction_type",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        direction_type.filter.type = "ValueList"
        direction_type.filter.list = ["NorthAzimuth","SouthAzimuth","Polar","QuadrantBearing"]
        direction_type.value = "Polar"

         # direction_units parameter
        direction_units = arcpy.Parameter(
            displayName="Direction Units",
            name="direction_units",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        direction_units.filter.type = "ValueList"
        direction_units.filter.list = ["DecimalDegrees","DegreesMinutesSeconds","Radians","Gradians","Gons"]
        direction_units.value = "DecimalDegrees"
                                  
        parameters = [in_dataset,out_dataset,direction_field,distance_field,angle_field,direction_type,direction_units]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        dirF  = parameters[2].valueAsText
        distF  = parameters[3].valueAsText
        angF = parameters[4].valueAsText
        dirType = parameters[5].valueAsText
        dirUnits = parameters[6].valueAsText

        etFunction = "PointsToPieSegments"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dirF,distF,angF,dirType,dirUnits],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class LinesFromPointDirDist(object):
    def __init__(self):
        self.label       = "Lines From Points Dirirections and Distance"
        self.description = "Creates single segmented polylines from a point dataset that has in the attribute table fields which values represent direction and distance from each point to the target point."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # direction_field
        direction_field = arcpy.Parameter(
            displayName="Direction Field",
            name="direction_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        direction_field.parameterDependencies = [in_dataset.name]
        direction_field.filter.list = ["Double", "Float", "Short", "Long","Integer","String","Text"]

        # distance_field
        distance_field = arcpy.Parameter(
            displayName="Distance Field",
            name="distance_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        distance_field.parameterDependencies = [in_dataset.name]
        distance_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # direction_type parameter
        direction_type = arcpy.Parameter(
            displayName="Direction Type",
            name="direction_type",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        direction_type.filter.type = "ValueList"
        direction_type.filter.list = ["NorthAzimuth","SouthAzimuth","Polar","QuadrantBearing"]
        direction_type.value = "Polar"

        # direction_units parameter
        direction_units = arcpy.Parameter(
            displayName="Direction Units",
            name="direction_units",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        direction_units.filter.type = "ValueList"
        direction_units.filter.list = ["DecimalDegrees","DegreesMinutesSeconds","Radians","Gradians","Gons"]
        direction_units.value = "DecimalDegrees"
                                  
        parameters = [in_dataset,out_dataset,direction_field,distance_field,direction_type,direction_units]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        dirF  = parameters[2].valueAsText
        distF  = parameters[3].valueAsText
        dirType = parameters[4].valueAsText
        dirUnits = parameters[5].valueAsText

        etFunction = "LinesFromPointDirDist"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dirF,distF,dirType,dirUnits],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class FeaturesToEnvelopes(object):
    def __init__(self):
        self.label       = "Features To Envelopes"
        self.description = "Creates single segmented polylines from a point dataset that has in the attribute table fields which values represent direction and distance from each point to the target point."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Multipoint","Polyline","Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Length","ET_Width"]
        fieldTypes = ["LONG","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # expand_distance
        expand_distance = arcpy.Parameter(
            displayName="Expand Distance",
            name="expand_distance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                                  
        parameters = [in_dataset,out_dataset,expand_distance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        dExp  = parameters[2].valueAsText
        if not dExp:
             dExp = "0"

        etFunction = "FeaturesToEnvelopes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dExp],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class FeaturesToRectangles(object):
    def __init__(self):
        self.label       = "Features To Bounding Rectangles"
        self.description = "Creates a bounding rectangle from each feature in the input feature class. The rectangles are aligned with the longest side of the original geometry. Attributes of the original features are transfered to the convex polygons."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline","Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Length","ET_Width"]
        fieldTypes = ["LONG","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

         # alignment parameter
        alignment = arcpy.Parameter(
            displayName="Rectangles Alignment",
            name="alignment",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        alignment.filter.type = "ValueList"
        alignment.filter.list = ["MinArea","LongestAxis","LongestSegment"]
        alignment.value = "LongestAxis"
                                  
        parameters = [in_dataset,out_dataset,alignment]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        sAlign  = parameters[2].valueAsText
        if not sAlign:
             sAlign = ""

        etFunction = "FeaturesToRectangles"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sAlign],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class FeaturesToCircles(object):
    def __init__(self):
        self.label       = "Features To Bounding Circles"
        self.description = "Creates a circular bounding polygon from each feature in the input feature class. Attributes of the original features are transfered to the convex polygons."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline","Polygon","Multipoint"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Radius"]
        fieldTypes = ["LONG","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
                                 
        parameters = [in_dataset,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        
        etFunction = "FeaturesToCircles"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolygonsToEqualAreaCircles(object):
    def __init__(self):
        self.label       = "Polygons To Equal Area Circles"
        self.description = "Creates a circular polygon with the same area as the corresponding polygon from the input feature class. The center of the circle is located in the centroid of the original polygon."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Radius"]
        fieldTypes = ["LONG","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
                                 
        parameters = [in_dataset,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        
        etFunction = "PolygonsToEqualAreaCircles"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolygonsToMaxInscribedCircles(object):
    def __init__(self):
        self.label       = "Polygons To Maximum Inscribed Circles"
        self.description = "Creates a circular polygon that represents the largest circle that can fit in the corresponding polygon from the input feature class. Attributes of the original features are transferred to the resulting polygons."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Radius"]
        fieldTypes = ["LONG","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
                                 
        parameters = [in_dataset,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        
        etFunction = "PolygonsToMaxInscribedCircles"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolygonsToDeepestPoints(object):
    def __init__(self):
        self.label       = "Polygons To Deepest Points"
        self.description = "Converts each polygon to a single point - the inside point farthest from the polygon boundary."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Depth"]
        fieldTypes = ["LONG","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
                                 
        parameters = [in_dataset,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        
        etFunction = "PolygonsToDeepestPoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CreateStationLines(object):
    def __init__(self):
        self.label       = "Create Station Lines"
        self.description = "Creates station lines along the polylines of the input dataset. The station lines are perpendicular to the original polylines with user specified station distance and length. The lingth can be constant or calculated from Z or M values (if the input dataset has Z or M values."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_LENGTH","ET_ANGLE","ET_STATION"]
        fieldTypes = ["LONG","Double","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # station_distance parameter
        station_distance = arcpy.Parameter(
            displayName="Station Distance",
            name="station_distance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # line_side parameter
        line_side = arcpy.Parameter(
            displayName="Station lines side",
            name="line_side",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        line_side.filter.type = "ValueList"
        line_side.filter.list = ["Both","Left", "Right"]
        line_side.value = "Both"

        # length_from parameter
        length_from = arcpy.Parameter(
            displayName="Length From",
            name="length_from",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        length_from.filter.type = "ValueList"
        length_from.filter.list = ["Constant","ZValues", "MValues"]
        length_from.value = "Constant"

        #line_length parameter
        line_length = arcpy.Parameter(
            displayName="Station Lines Length",
            name="line_length",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                                 
        parameters = [in_dataset,out_dataset,station_distance,line_side,length_from,line_length]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
             if parameters[0].altered:
                  if not arcpy.Describe(parameters[0].value).hasZ:
                       if not arcpy.Describe(parameters[0].value).hasM:
                            parameters[4].filter.list = ["Constant"]
                            parameters[4].value = "Constant"
                       else:
                            parameters[4].filter.list = ["Constant","MValues"]
                  else:
                       if not arcpy.Describe(parameters[0].value).hasM:
                            parameters[4].filter.list = ["Constant","ZValues"]
                       else:
                            parameters[4].filter.list = ["Constant","ZValues", "MValues"]
        except:
             a=0
        if (parameters[4].valueAsText == "Constant"):
             parameters[5].enabled = True
        else:
             parameters[5].enabled = False
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        dDist = parameters[2].valueAsText
        sSide = parameters[3].valueAsText
        sFrom = parameters[4].valueAsText
        dLen = parameters[5].valueAsText
        if not dLen:
             dLen = ""
        etFunction = "CreateStationLines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dDist,sSide,sFrom,dLen],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsAlongPolylines(object):
    def __init__(self):
        self.label       = "Points Along Polylines"
        self.description = "Creates points along the polylines of the input dataset (one or two per polyline). The points are located on user specified relative distance from the start point of the polylines. The user can specify an offset distance and on which side of the polylines the offset points will be created."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_ALONG","ET_OFFSET"]
        fieldTypes = ["LONG","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # relative_distance parameter
        relative_distance = arcpy.Parameter(
            displayName="Relative Distance",
            name="relative_distance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        relative_distance.filter.type = 'Range'
        relative_distance.filter.list = [0,1]
        relative_distance.value = 0.5

        # line_side parameter
        line_side = arcpy.Parameter(
            displayName="Station lines side",
            name="line_side",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        line_side.filter.type = "ValueList"
        line_side.filter.list = ["Both","Left", "Right"]
        line_side.value = "Both"

        #offset parameter
        offset = arcpy.Parameter(
            displayName="Offset",
            name="offset",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                                 
        parameters = [in_dataset,out_dataset,relative_distance,line_side,offset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        dDist = parameters[2].valueAsText
        sSide = parameters[3].valueAsText
        dLen = parameters[4].valueAsText
        if not dLen:
             dLen = ""
        etFunction = "PointsAlongPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dDist,sSide,dLen],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class NearFeature(object):
    def __init__(self):
        self.label       = "Near Feature"
        self.description = "Calculates the distance for each feature of the Input dataset to the closest feature from the Distance dataset. In the attribute table of the output the distance is recorded together with the ID of the closest feature."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

        # near_dataset parameter
        near_dataset = arcpy.Parameter(
            displayName="Near Dataset",
            name="near_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        near_dataset.filter.list = []
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_Closest","ET_Dist"]
        fieldTypes = ["LONG","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

         # search_tolerance parameter
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units:",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        
        # spatial_ref_from_source
        spatial_ref_from_source = arcpy.Parameter(
            displayName="Output Spatial Ref From Source",
            name="spatial_ref_from_source",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        spatial_ref_from_source.value = "True"
                         
        parameters = [in_dataset,near_dataset,out_dataset,search_tolerance, unit, spatial_ref_from_source]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 refSR  = arcpy.Describe(parameters[1].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if refSR.name == "Unknown":
                     refUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 if refSR.type == "Projected":
                     refUnit = refSR.linearUnitName
                 else:
                     refUnit = refSR.GCS.angularUnitName
                 if parameters[5].value:
                      parameters[4].value =  inUnit
                 else:     
                      parameters[4].value =  refUnit 
            except:
                 parameters[4].value = ""
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        bSRS = parameters[5].valueAsText
                                      
        etFunction = "NearFeature"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,dTol,bSRS],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SpiderDiagram(object):
    def __init__(self):
        self.label       = "Spider Diagram"
        self.description = "Creates a Spider Diagram between the points of a Center Points layer and the features in the destination layer (points,multipoints, polygons, or polylines)."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # centers_dataset parameter
        centers_dataset = arcpy.Parameter(
            displayName="Centers Dataset",
            name="centers_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        centers_dataset.filter.list = []

        # destinations_dataset parameter
        destinations_dataset = arcpy.Parameter(
            displayName="Destinations Dataset",
            name="destinations_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        destinations_dataset.filter.list = ["Point"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [centers_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
                
        # Add fields
        addFields = []
        fieldNames = ["Center_ID","Dest_ID","ET_Dist"]
        fieldTypes = ["LONG","LONG","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

         # search_tolerance parameter
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units:",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        
        # spatial_ref_from_source
        spatial_ref_from_source = arcpy.Parameter(
            displayName="Output Spatial Ref From Source",
            name="spatial_ref_from_source",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        spatial_ref_from_source.value = "True"
                         
        parameters = [centers_dataset,destinations_dataset,out_dataset,search_tolerance, unit, spatial_ref_from_source]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 refSR  = arcpy.Describe(parameters[1].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if refSR.name == "Unknown":
                     refUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 if refSR.type == "Projected":
                     refUnit = refSR.linearUnitName
                 else:
                     refUnit = refSR.GCS.angularUnitName
                 if parameters[5].value:
                      parameters[4].value =  inUnit
                 else:     
                      parameters[4].value =  refUnit 
            except:
                 parameters[4].value = ""
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        bSRS = parameters[5].valueAsText
                                      
        etFunction = "SpiderDiagram"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,dTol,bSRS],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SpiderDiagramAttributeLink(object):
    def __init__(self):
        self.label       = "Spider Diagram Attribute Link"
        self.description = "Creates a Spider Diagram between the points of a Center Points layer and the features in the destination layer (points,multipoints, polygons, or polylines)."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # centers_dataset parameter
        centers_dataset = arcpy.Parameter(
            displayName="Centers Dataset",
            name="centers_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        centers_dataset.filter.list = []

        # destinations_dataset parameter
        destinations_dataset = arcpy.Parameter(
            displayName="Destinations Dataset",
            name="destinations_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        destinations_dataset.filter.list = ["Point"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [centers_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
                
        # Add fields
        addFields = []
        fieldNames = ["Center_ID","Dest_ID","ET_Dist"]
        fieldTypes = ["LONG","LONG","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # centers_link_field
        centers_link_field = arcpy.Parameter(
            displayName="Centers Link Field",
            name="centers_link_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        centers_link_field.parameterDependencies = [centers_dataset.name]
        centers_link_field.filter.list = ["Double", "Float", "Short", "Long","Integer","String","Text"]

        # destinations_link_field
        destinations_link_field = arcpy.Parameter(
            displayName="Destinations Link Field",
            name="destinations_link_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        destinations_link_field.parameterDependencies = [destinations_dataset.name]
        destinations_link_field.filter.list = ["Double", "Float", "Short", "Long","Integer","String","Text"]

         # search_tolerance parameter
        search_tolerance = arcpy.Parameter(
            displayName="Cutoff Distance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units:",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        
        # spatial_ref_from_source
        spatial_ref_from_source = arcpy.Parameter(
            displayName="Output Spatial Ref From Source",
            name="spatial_ref_from_source",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        spatial_ref_from_source.value = "True"
                         
        parameters = [centers_dataset,destinations_dataset,out_dataset,centers_link_field,destinations_link_field,search_tolerance, unit, spatial_ref_from_source]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 refSR  = arcpy.Describe(parameters[1].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if refSR.name == "Unknown":
                     refUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 if refSR.type == "Projected":
                     refUnit = refSR.linearUnitName
                 else:
                     refUnit = refSR.GCS.angularUnitName
                 if parameters[7].value:
                      parameters[6].value =  inUnit
                 else:     
                      parameters[6].value =  refUnit 
            except:
                 parameters[6].value = ""
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        cLink = parameters[3].valueAsText
        dLink = parameters[4].valueAsText
        dTol = parameters[5].valueAsText
        bSRS = parameters[7].valueAsText
                                      
        etFunction = "SpiderDiagramAttributeLink"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,cLink,dLink,dTol,bSRS],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class Allocate(object):
    def __init__(self):
        self.label       = "Allocate"
        self.description = "Allocates customers to facilities based on euclidean distance.."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # facilities_dataset parameter
        facilities_dataset = arcpy.Parameter(
            displayName="Facilities Dataset",
            name="facilities_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        facilities_dataset.filter.list = ["Point"]

        # customers_dataset parameter
        customers_dataset = arcpy.Parameter(
            displayName="Customers Dataset",
            name="customers_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        customers_dataset.filter.list = ["Point"]
      
        # out_link_dataset parameter
        out_link_dataset = arcpy.Parameter(
            displayName="Output Link Dataset",
            name="out_link_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_link_dataset.parameterDependencies = [customers_dataset.name]
        out_link_dataset.schema.clone = True
        out_link_dataset.schema.fieldsRule = "None"
        out_link_dataset.schema.geometryTypeRule = "AsSpecified"
        out_link_dataset.schema.geometryType = "Polyline"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_Dist","Facility","Customer","FacilityID","CustomerID"]
        fieldTypes = ["Double","String","String","LONG","LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_link_dataset.schema.additionalFields = addFields

        # out_facilities_dataset parameter
        out_facilities_dataset = arcpy.Parameter(
            displayName="Output Facilities Dataset",
            name="out_facilities_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_facilities_dataset.parameterDependencies = [customers_dataset.name]
        out_facilities_dataset.schema.clone = True
        out_facilities_dataset.schema.fieldsRule = "None"
        out_facilities_dataset.schema.geometryTypeRule = "AsSpecified"
        out_facilities_dataset.schema.geometryType = "Point"
                
        # Add fields
        addFields = []
        fieldNames = ["Facility","FacilityID","Type","Num_Alloc","Max_Dist","Total_Dist"]
        fieldTypes = ["String","Long","String","LONG","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_facilities_dataset.schema.additionalFields = addFields

         # number_facilities parameter
        number_facilities = arcpy.Parameter(
            displayName="Number Facilities to Select",
            name="number_facilities",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")

        # facilities_name_field
        facilities_name_field = arcpy.Parameter(
            displayName="Facilities Name Field",
            name="facilities_name_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        facilities_name_field.parameterDependencies = [facilities_dataset.name]
        facilities_name_field.filter.list = ["Short", "Long","Integer","String","Text"]

        # facilities_type_field
        facilities_type_field = arcpy.Parameter(
            displayName="Facilities Type Field",
            name="facilities_type_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        facilities_type_field.parameterDependencies = [facilities_dataset.name]
        facilities_type_field.filter.list = ["Short", "Long","Integer","String","Text"]

        # customers_name_field
        customers_name_field = arcpy.Parameter(
            displayName="Customers Name Field",
            name="customers_name_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        customers_name_field.parameterDependencies = [customers_dataset.name]
        customers_name_field.filter.list = ["Short", "Long","Integer","String","Text"]

         # cutoff_distanance parameter
        search_tolerance = arcpy.Parameter(
            displayName="Cutoff Distance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units:",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        
        # spatial_ref_from_source
        spatial_ref_from_source = arcpy.Parameter(
            displayName="Output Spatial Ref From Source",
            name="spatial_ref_from_source",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        spatial_ref_from_source.value = "True"
                         
        parameters = [facilities_dataset,customers_dataset,out_link_dataset,out_facilities_dataset,number_facilities,facilities_name_field,facilities_type_field,customers_name_field,search_tolerance, unit, spatial_ref_from_source]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 refSR  = arcpy.Describe(parameters[1].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if refSR.name == "Unknown":
                     refUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 if refSR.type == "Projected":
                     refUnit = refSR.linearUnitName
                 else:
                     refUnit = refSR.GCS.angularUnitName
                 if parameters[10].value:
                      parameters[9].value =  inUnit
                 else:     
                      parameters[9].value =  refUnit 
            except:
                 parameters[9].value = ""
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outLinkDataset  = parameters[2].valueAsText
        outFacDataset  = parameters[3].valueAsText
        iNum  = parameters[4].valueAsText
        facN = parameters[5].valueAsText
        if not facN:
             facN = ""
        facT = parameters[6].valueAsText
        if not facT:
             facT = ""
        custN = parameters[7].valueAsText
        if not custN:
             custN = ""
        dTol = parameters[8].valueAsText
        if not dTol:
             dTol = "0"
        bSRS = parameters[10].valueAsText
                                      
        etFunction = "Allocate"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outLinkDataset,outFacDataset,iNum,facN,facT,custN,dTol,bSRS],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class DeleteMultipleFields(object):
    def __init__(self):
        self.label       = "Delete Multiple Fields"
        self.description = "Deletes multiple fields from a dataset. The result is stored in a new dataset."
        self.category = "Fields"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "None"
   
        # delete_fields parameter
        delete_fields = arcpy.Parameter(
            displayName="Fields To Delete",
            name="delete_fields",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        delete_fields.parameterDependencies = [in_dataset.name]
        delete_fields.columns = [["Field","Field"]]
        delete_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
                  
        parameters = [in_dataset,out_dataset,delete_fields]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
             if parameters[0].altered:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  fieldTypes = []
                  value_table = arcpy.ValueTable(2)
                  value_table.loadFromString(parameters[2].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       fieldNames.append(fld)
                       for f in fList:
                            if f.name == fld:
                                 fieldTypes.append(f.type)
                  addFields = []
                  for fieldInd, fieldName in enumerate(fieldNames):
                       fieldType = fieldTypes[fieldInd]
                       newField = arcpy.Field()
                       newField.name = fieldName
                       newField.type = fieldType
                       addFields.append(newField) 
                  parameters[1].schema.additionalFields = addFields     
        except:
             a=0                        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        try:
             if parameters[0].altered:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  for f in fList:
                       fieldNames.append(f.name)
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[2].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[2].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[2].clearMessage
        except:
             a=0       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sDisF = parameters[2].valueAsText
        if not sDisF:
             sDisF = ""
                       
        etFunction = "DeleteMultipleFields"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sDisF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class OrderFields(object):
    def __init__(self):
        self.label       = "Order Fields"
        self.description = "Exports a feature class  to a new feature class. The user selects the fields to be exported and the order in which they will appear in the attribute table."
        self.category = "Fields"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "None"
   
        # ordered_fields parameter
        ordered_fields = arcpy.Parameter(
            displayName="Ordered Fields",
            name="ordered_fields",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        ordered_fields.parameterDependencies = [in_dataset.name]
        ordered_fields.columns = [["Field","Field"]]
        ordered_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
                  
        parameters = [in_dataset,out_dataset,ordered_fields]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
             if parameters[0].altered:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  fieldTypes = []
                  value_table = arcpy.ValueTable(2)
                  value_table.loadFromString(parameters[2].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       fieldNames.append(fld)
                       for f in fList:
                            if f.name == fld:
                                 fieldTypes.append(f.type)
                  addFields = []
                  for fieldInd, fieldName in enumerate(fieldNames):
                       fieldType = fieldTypes[fieldInd]
                       newField = arcpy.Field()
                       newField.name = fieldName
                       newField.type = fieldType
                       addFields.append(newField) 
                  parameters[1].schema.additionalFields = addFields     
        except:
             a=0                        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        try:
             if parameters[0].altered:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  for f in fList:
                       fieldNames.append(f.name)
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[2].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[2].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[2].clearMessage
        except:
             a=0       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sDisF = parameters[2].valueAsText
        if not sDisF:
             sDisF = ""
                       
        etFunction = "OrderFields"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sDisF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CopyFields(object):
    def __init__(self):
        self.label       = "Copy Fields From Layer"
        self.description = "Copies the user selected fields from the reference layer to the input one. The results are stored as a new dataset."
        self.category = "Fields"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

         # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        reference_dataset.filter.list = []
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
   
        # fields_to_copy parameter
        fields_to_copy = arcpy.Parameter(
            displayName="Fields To Copy",
            name="fields_to_copy",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        fields_to_copy.parameterDependencies = [reference_dataset.name]
        fields_to_copy.columns = [["Field","Field"]]
        fields_to_copy.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
                  
        parameters = [in_dataset,reference_dataset,out_dataset,fields_to_copy]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
             if parameters[1].altered:
                  fList  = arcpy.Describe(parameters[1].value).fields
                  fieldNames = []
                  fieldTypes = []
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[3].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       fieldNames.append(fld)
                       for f in fList:
                            if f.name == fld:
                                 fieldTypes.append(f.type)
                  addFields = []
                  for fieldInd, fieldName in enumerate(fieldNames):
                       fieldType = fieldTypes[fieldInd]
                       newField = arcpy.Field()
                       newField.name = fieldName
                       newField.type = fieldType
                       addFields.append(newField) 
                  parameters[2].schema.additionalFields = addFields     
        except:
             a=0                        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        try:
             if parameters[1].altered:
                  fList  = arcpy.Describe(parameters[1].value).fields
                  fieldNames = []
                  for f in fList:
                       fieldNames.append(f.name)
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[3].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[3].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[3].clearMessage
        except:
             a=0       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        refDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        sDisF = parameters[3].valueAsText
        if not sDisF:
             sDisF = ""
                       
        etFunction = "CopyFields"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,refDataset,outDataset,sDisF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class RedefineFields(object):
    def __init__(self):
        self.label       = "Redefine Fields"
        self.description = "Change field names and definitions."
        self.category = "Fields"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

             
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "None"
   
        # redefine_fields parameter
        redefine_fields = arcpy.Parameter(
            displayName="Redefine Fields",
            name="redefine_fields",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        redefine_fields.parameterDependencies = [in_dataset.name]
        redefine_fields.columns = [["Field","Field"],["GPString", "New Name"],["GPString", "Type"],["GPLong", "Width"],["GPLong", "Precision"]]
        redefine_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        redefine_fields.filters[1].type = "GPString"
        redefine_fields.filters[2].type = "ValueList"
        redefine_fields.filters[2].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        redefine_fields.filters[3].type = "GPLong"
        redefine_fields.filters[4].type = "GPLong"
                  
        parameters = [in_dataset,out_dataset,redefine_fields]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
             if parameters[0].altered:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  newFieldNames = []
                  fieldTypes = []
                  value_table = arcpy.ValueTable(5)
                  value_table.loadFromString(parameters[2].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       fieldNames.append(fld)
                       newFld = value_table.getValue(i,1)
                       newFldType = value_table.getValue(i,2)
                       newFieldNames.append(newFld)
                       fieldTypes.append(newFldType)
                  addFields = []
                  for f in fList:
                       if f.name not in fieldNames:
                            newField = arcpy.Field()
                            newField.name = f.name
                            newField.type = f.type
                            addFields.append(newField)
                  for fieldInd, fieldName in enumerate(newFieldNames):
                       fieldType = fieldTypes[fieldInd]
                       newField = arcpy.Field()
                       newField.name = fieldName
                       newField.type = fieldType
                       addFields.append(newField) 
                  parameters[1].schema.additionalFields = addFields
        except:
             a=0              
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        try:
             if parameters[0].altered:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  for f in fList:
                       fieldNames.append(f.name)
                  value_table = arcpy.ValueTable(5)
                  value_table.loadFromString(parameters[2].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[2].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[2].clearMessage
        except:
             a=0       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sDisF = parameters[2].valueAsText
        if not sDisF:
             sDisF = ""
                       
        etFunction = "RedefineFields"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sDisF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class RenameFields(object):
    def __init__(self):
        self.label       = "Rename Fields"
        self.description = "Change field names. The result is stored in a new dataset."
        self.category = "Fields"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

             
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "None"
   
        # redefine_fields parameter
        redefine_fields = arcpy.Parameter(
            displayName="Rename Fields",
            name="redefine_fields",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        redefine_fields.parameterDependencies = [in_dataset.name]
        redefine_fields.columns = [["Field","Field"],["GPString", "New Name"]]
        redefine_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        redefine_fields.filters[1].type = "GPString"
                  
        parameters = [in_dataset,out_dataset,redefine_fields]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        try:
             if parameters[0].altered:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  newFieldNames = []
                  fieldTypes = []
                  value_table = arcpy.ValueTable(2)
                  value_table.loadFromString(parameters[2].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       fieldNames.append(fld)
                       newFld = value_table.getValue(i,1)
                       newFldType = value_table.getValue(i,2)
                       newFieldNames.append(newFld)
                       fieldTypes.append(newFldType)
                  addFields = []
                  for f in fList:
                       if f.name not in fieldNames:
                            newField = arcpy.Field()
                            newField.name = f.name
                            newField.type = f.type
                            addFields.append(newField)
                  for fieldInd, fieldName in enumerate(newFieldNames):
                       fieldType = fieldTypes[fieldInd]
                       newField = arcpy.Field()
                       newField.name = fieldName
                       newField.type = fieldType
                       addFields.append(newField) 
                  parameters[1].schema.additionalFields = addFields
        except:
             a=0              
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        try:
             if parameters[0].altered:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  for f in fList:
                       fieldNames.append(f.name)
                  value_table = arcpy.ValueTable(2)
                  value_table.loadFromString(parameters[2].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[2].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[2].clearMessage
        except:
             a=0       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sDisF = parameters[2].valueAsText
        if not sDisF:
             sDisF = ""
                       
        etFunction = "RenameFields"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sDisF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class Buffer(object):
    def __init__(self):
        self.label       = "Buffer"
        self.description = "Creates buffer polygons from the features of the input dataset. The buffer distance (in the units of the spatial reference of the input dataset) can be entered as a number (equal for all input features)or a numeric field. Negative buffer distance is accepted only for polygon input."
        self.category = "Basic"
        
    def getParameterInfo(self):
        # Input Features parameter 0
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
      
        # Output Features parameter 1
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # buffer_distance parameter 2
        buffer_distance = arcpy.Parameter(
            displayName="Buffer Distance",
            name="buffer_distance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # buffer_distance_field 3
        buffer_distance_field = arcpy.Parameter(
            displayName="Buffer Distance Field",
            name="buffer_distance_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        buffer_distance_field.parameterDependencies = [in_dataset.name]
        buffer_distance_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # unit 4
        unit = arcpy.Parameter(
            displayName="Buffer Distance Units:",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

         # dissolve_buffers 5
        dissolve_buffers = arcpy.Parameter(
            displayName="Dissolve Buffers",
            name="dissolve_buffers",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        dissolve_buffers.value = "False"

        # dissolve_fields parameter 6
        dissolve_fields = arcpy.Parameter(
            displayName="Dissolve Fields",
            name="dissolve_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        dissolve_fields.parameterDependencies = [in_dataset.name]
        dissolve_fields.columns = [["Field","Field"]]
        dissolve_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]

        # statistics_fields parameter 7
        statistics_fields = arcpy.Parameter(
            displayName="Statistics Fields",
            name="statistics_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        statistics_fields.parameterDependencies = [in_dataset.name]
        statistics_fields.columns = [["Field","Field"],["GPString", "Statistic Type"]]
        statistics_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        statistics_fields.filters[1].type = "ValueList"
        statistics_fields.filters[1].list = ["SUM", "MAX", "MIN", "FIRST"]

         # create_multipart 8
        create_multipart = arcpy.Parameter(
            displayName="Create Multipart",
            name="create_multipart",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        create_multipart.value = "False"
                   
        parameters = [in_dataset,out_dataset,buffer_distance,buffer_distance_field,unit,dissolve_buffers,dissolve_fields,statistics_fields,create_multipart]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[4].value =  inUnit    
            except:
                 parameters[4].value = ""

        if not parameters[5].value:
             parameters[6].enabled = False
             parameters[7].enabled = False
             parameters[8].enabled = False
             parameters[1].schema.fieldsRule = "All"
             addFields = []
             fieldNames = ["ET_ID"]
             fieldTypes = ["LONG"]
             for fieldInd, fieldName in enumerate(fieldNames):
                  fieldType = fieldTypes[fieldInd]
                  newField = arcpy.Field()
                  newField.name = fieldName
                  newField.type = fieldType
                  addFields.append(newField)
             parameters[1].schema.additionalFields = addFields
        else:
             parameters[6].enabled = True
             parameters[7].enabled = True
             parameters[8].enabled = True
             parameters[1].schema.fieldsRule = "None"
             fieldNames = []
             try:
                  if parameters[0].valueAsText:
                       fList  = arcpy.Describe(parameters[0].value).fields
                       fieldNames = []
                       fieldTypes = []
                       value_table = arcpy.ValueTable(1)
                       value_table.loadFromString(parameters[6].valueAsText)
                       for i in range(0, value_table.rowCount):
                            fld = value_table.getValue(i,0)
                            fieldNames.append(fld)
                            for f in fList:
                                 if f.name == fld:
                                      fieldTypes.append(f.type)
                       addFields = []
                       for fieldInd, fieldName in enumerate(fieldNames):
                            fieldType = fieldTypes[fieldInd]
                            newField = arcpy.Field()
                            newField.name = fieldName
                            newField.type = fieldType
                            addFields.append(newField) 
                       parameters[1].schema.additionalFields = addFields 
             except:
                  a=0 
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        if parameters[0].altered:
             try:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  for f in fList:
                       fieldNames.append(f.name)
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[6].valueAsText)
                  value_table2 = arcpy.ValueTable(2)
                  value_table2.loadFromString(parameters[7].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[6].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[6].clearMessage
                  for i in range(0, value_table2.rowCount):
                       fld = value_table2.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[7].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[7].clearMessage
             except:
                  a=0      
        if parameters[0].valueAsText:
             if not (parameters[2].valueAsText) and not (parameters[3].valueAsText):
                  parameters[2].setErrorMessage("Buffer Distance or Buffer Distance Field needed!")
             else:
                  parameters[2].clearMessage
             return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dBuf = parameters[2].valueAsText
        if not dBuf:
             dBuf = ""
        sBufF = parameters[3].valueAsText
        if not sBufF:
             sBufF = ""
        bDis = parameters[5].valueAsText
        sDisF = parameters[6].valueAsText
        if not sDisF:
             sDisF = ""
        sStatF = parameters[7].valueAsText
        if not sStatF:
             sStatF = ""
        bMulti = parameters[8].valueAsText
                       
        etFunction = "Buffer"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dBuf,sBufF,bDis,sDisF,sStatF,bMulti],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class BufferPolylines(object):
    def __init__(self):
        self.label       = "Buffer Polylines"
        self.description = "Creates buffer polygons from the polylines of the input dataset. The user can specify the side of the polyline (Left, Right or Both) on which the buffer to be created as well as the shape of the buffer at the end of the polylines - Round or Flat. The buffer distance (in the units of the spatial reference of the input dataset) can be entered as a number (equal for all input polylines)or a numeric field. No negative buffer distance is accepted."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
    
        # buffer_side parameter
        buffer_side = arcpy.Parameter(
            displayName="Buffer Side",
            name="buffer_side",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        buffer_side.filter.type = "ValueList"
        buffer_side.filter.list = ["Both","Left", "Right"]
        buffer_side.value = "Both"

        # shape_end parameter
        shape_end = arcpy.Parameter(
            displayName="Shape End",
            name="shape_end",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        shape_end.filter.type = "ValueList"
        shape_end.filter.list = ["Flat", "Round"]
        shape_end.value = "Round"

         # buffer_distance parameter
        buffer_distance = arcpy.Parameter(
            displayName="Buffer Distance",
            name="buffer_distance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # buffer_distance_field
        buffer_distance_field = arcpy.Parameter(
            displayName="Buffer Distance Field",
            name="buffer_distance_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        buffer_distance_field.parameterDependencies = [in_dataset.name]
        buffer_distance_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # unit
        unit = arcpy.Parameter(
            displayName="Buffer Distance Units:",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

         # dissolve_buffers
        dissolve_buffers = arcpy.Parameter(
            displayName="Dissolve Buffers",
            name="dissolve_buffers",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        dissolve_buffers.value = "False"

        # dissolve_fields parameter
        dissolve_fields = arcpy.Parameter(
            displayName="Dissolve Fields",
            name="dissolve_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        dissolve_fields.parameterDependencies = [in_dataset.name]
        dissolve_fields.columns = [["Field","Field"]]
        dissolve_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]

        # statistics_fields parameter
        statistics_fields = arcpy.Parameter(
            displayName="Statistics Fields",
            name="statistics_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        statistics_fields.parameterDependencies = [in_dataset.name]
        statistics_fields.columns = [["Field","Field"],["GPString", "Statistic Type"]]
        statistics_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        statistics_fields.filters[1].type = "ValueList"
        statistics_fields.filters[1].list = ["SUM", "MAX", "MIN", "FIRST"]

         # create_multipart
        create_multipart = arcpy.Parameter(
            displayName="Create Multipart",
            name="create_multipart",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        create_multipart.value = "False"
                   
        parameters = [in_dataset,out_dataset,buffer_side,shape_end,buffer_distance,buffer_distance_field,unit,dissolve_buffers,dissolve_fields,statistics_fields,create_multipart]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[6].value =  inUnit    
            except:
                 parameters[6].value = ""

        if not parameters[7].value:
             parameters[8].enabled = False
             parameters[9].enabled = False
             parameters[10].enabled = False
             parameters[1].schema.fieldsRule = "All"
             addFields = []
             fieldNames = ["ET_ID"]
             fieldTypes = ["LONG"]
             for fieldInd, fieldName in enumerate(fieldNames):
                  fieldType = fieldTypes[fieldInd]
                  newField = arcpy.Field()
                  newField.name = fieldName
                  newField.type = fieldType
                  addFields.append(newField)
             parameters[1].schema.additionalFields = addFields
        else:
             parameters[8].enabled = True
             parameters[9].enabled = True
             parameters[10].enabled = True
             parameters[1].schema.fieldsRule = "None"
             fieldNames = []
             try:
                  if parameters[0].valueAsText:
                       fList  = arcpy.Describe(parameters[0].value).fields
                       fieldNames = []
                       fieldTypes = []
                       value_table = arcpy.ValueTable(1)
                       value_table.loadFromString(parameters[8].valueAsText)
                       for i in range(0, value_table.rowCount):
                            fld = value_table.getValue(i,0)
                            fieldNames.append(fld)
                            for f in fList:
                                 if f.name == fld:
                                      fieldTypes.append(f.type)
                       addFields = []
                       for fieldInd, fieldName in enumerate(fieldNames):
                            fieldType = fieldTypes[fieldInd]
                            newField = arcpy.Field()
                            newField.name = fieldName
                            newField.type = fieldType
                            addFields.append(newField) 
                       parameters[1].schema.additionalFields = addFields 
             except:
                  a=0  
             
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        if parameters[0].altered:
             try:
                  fList  = arcpy.Describe(parameters[0].value).fields
                  fieldNames = []
                  for f in fList:
                       fieldNames.append(f.name)
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[8].valueAsText)
                  value_table2 = arcpy.ValueTable(2)
                  value_table2.loadFromString(parameters[9].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[8].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[8].clearMessage
                  for i in range(0, value_table2.rowCount):
                       fld = value_table2.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[9].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[9].clearMessage
             except:
                  a=0        
        if parameters[0].valueAsText:
             if not (parameters[4].valueAsText) and not (parameters[5].valueAsText):
                  parameters[4].setErrorMessage("Buffer Distance or Buffer Distance Field needed!")
             else:
                  parameters[4].clearMessage
             return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sSide = parameters[2].valueAsText
        sEnd = parameters[3].valueAsText
        dBuf = parameters[4].valueAsText
        if not dBuf:
             dBuf = ""
        sBufF = parameters[5].valueAsText
        if not sBufF:
             sBufF = ""
        bDis = parameters[7].valueAsText
        sDisF = parameters[8].valueAsText
        if not sDisF:
             sDisF = ""
        sStatF = parameters[9].valueAsText
        if not sStatF:
             sStatF = ""
        bMulti = parameters[10].valueAsText
                       
        etFunction = "BufferPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sSide,sEnd,dBuf,sBufF,bDis,sDisF,sStatF,bMulti],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ClosestFeatureDistance(object):
    def __init__(self):
        self.label       = "Closest Feature Distance"
        self.description = "Calculates the distance for each feature of the Input dataset to the closest feature from the same dataset. In the attribute table of the output the distance is recorded together with the ID of the closest feature."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_Closest","ET_Dist"]
        fieldTypes = ["LONG","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

         # search_tolerance parameter
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units:",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
                        
        parameters = [in_dataset,out_dataset,search_tolerance, unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit    
            except:
                 parameters[3].value = ""
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
                                              
        etFunction = "ClosestFeatureDistance"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ProjectLayer(object):
    def __init__(self):
        self.label       = "Project Layer"
        self.description = "Projects the input dataset to the spatial reference of the reference dataset."
        self.category = "Basic"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []

        # ref_dataset parameter
        ref_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="ref_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        ref_dataset.filter.list = []
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
                         
        parameters = [in_dataset,ref_dataset,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                   
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        refDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
                                      
        etFunction = "ProjectLayer"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,refDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ExportToGoogle(object):
    def __init__(self):
        self.label       = "Export To Google"
        self.description = "Exports a feature class to to a Google Earth KML or KMZ file. Please read the User Guide for a detailed description."
        self.category = "Import-Export"
        
    def getParameterInfo(self):
        # Input Features parameter 0
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
            
        # Output Features parameter 1
        out_file = arcpy.Parameter(
            displayName="Output KML (KMZ) file",
            name="out_file",
            datatype="DEFile",
            parameterType="Required",
            direction="Output")
        # Copy definition from source

        # kml_description parameter 2
        kml_description = arcpy.Parameter(
            displayName="KML Description",
            name="kml_description",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # label_field 3
        label_field = arcpy.Parameter(
            displayName="Label Field",
            name="link_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        label_field.parameterDependencies = [in_dataset.name]
        label_field.filter.list = ["Double", "Float", "Short", "Long", "String","Text","Integer"]

        # transparency parameter 4
        transparency = arcpy.Parameter(
            displayName="Transparency",
            name="transparency",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")
        transparency.filter.type = 'Range'
        transparency.filter.list = [0,100]

        # z_source parameter 5
        z_source = arcpy.Parameter(
            displayName="Source for Z values",
            name="z_source",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        z_source.filter.type = "ValueList"
        z_source.filter.list = ["Z", "Field","Constant","None"]
        z_source.value = "None"

        # z_field 6
        z_field = arcpy.Parameter(
            displayName="Z Field",
            name="z_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        z_field.parameterDependencies = [in_dataset.name]
        z_field.filter.list = ["Double", "Float", "Short", "Long"]
        
        #z_constant parameter 7
        z_constant = arcpy.Parameter(
            displayName="Z Constant",
            name="z_constant",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")

        # z_units parameter 8
        z_units = arcpy.Parameter(
            displayName="Z Units",
            name="z_units",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        z_units.filter.type = "ValueList"
        z_units.filter.list = ["Meters", "Feet"]
        z_units.value = "Meters"

        # z_type parameter 9
        z_type = arcpy.Parameter(
            displayName="Z Type",
            name="z_type",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        z_type.filter.type = "ValueList"
        z_type.filter.list = ["Absolute", "Relative"]
        z_type.value = "Absolute"

        # extrude_geometries 10
        extrude_geometries = arcpy.Parameter(
            displayName="Extrude Geometries",
            name="extrude_geometries",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        extrude_geometries.value = "False"

        # fill_color parameter 11
        fill_color = arcpy.Parameter(
            displayName="Fill Color",
            name="fill_color",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        fill_color.filter.type = "ValueList"
        fill_color.filter.list = ["White", "Green","Blue","Red","Cyan","Magenta","Yellow","Grey","Black"]
        fill_color.value = "Grey"

        # line_color parameter 12
        line_color = arcpy.Parameter(
            displayName="Line Color",
            name="line_color",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        line_color.filter.type = "ValueList"
        line_color.filter.list = ["White", "Green","Blue","Red","Cyan","Magenta","Yellow","Grey","Black"]
        line_color.value = "Black"

        #line_width parameter 13
        line_width = arcpy.Parameter(
            displayName="Line Width",
            name="line_width",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        line_width.value = 1

        # export_info_points 14
        export_info_points = arcpy.Parameter(
            displayName="Export Info Points",
            name="export_info_points",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        export_info_points.value = "False"

        # info_symbol parameter 15
        info_symbol = arcpy.Parameter(
            displayName="Info Symbol",
            name="info_symbol",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        info_symbol.filter.type = "ValueList"
        info_symbol.filter.list = ["Paddle","Pushpin","Info","P_Square","P_Circle","Dot","Triangle","Star","Square","Diamond","Polygon","Donut"]
        info_symbol.value = "Info"

        #info_scale parameter 16
        info_scale = arcpy.Parameter(
            displayName="Info Scale",
            name="info_scale",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        info_scale.value = 1

        #coordinate_precision parameter 17
        coordinate_precision = arcpy.Parameter(
            displayName="Coordinate precision - places after the decimal point",
            name="coordinate_precision",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")
        coordinate_precision.filter.type = 'Range'
        coordinate_precision.filter.list = [0,15]
        coordinate_precision.value = 6
                                 
        parameters = [in_dataset,out_file,kml_description,label_field,transparency,
                      z_source,z_field,z_constant,z_units,z_type,extrude_geometries,
                      fill_color,line_color,line_width,export_info_points,info_symbol,
                      info_scale,coordinate_precision]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[5].valueAsText == "None":
             parameters[6].enabled = False
             parameters[7].enabled = False
             parameters[8].enabled = False
             parameters[9].enabled = False
             parameters[10].enabled = False
        else:
             if parameters[5].valueAsText == "Field":
                  parameters[6].enabled = True
                  parameters[7].enabled = False
             elif parameters[5].valueAsText == "Constant":
                  parameters[6].enabled = False
                  parameters[7].enabled = True
             else:
                  parameters[6].enabled = False
                  parameters[7].enabled = False
             parameters[8].enabled = True
             parameters[9].enabled = True
             parameters[10].enabled = True           
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if parameters[5].valueAsText == "Field":
             if not parameters[6].valueAsText:
                  parameters[6].setWarningMessage("Z Field required if Source for Z values is FIELD")
        if parameters[5].valueAsText == "Constant":
             if not parameters[7].valueAsText:
                  parameters[7].setWarningMessage("Z Field required if Source for Z values is Constant")
                                 
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outFile  = parameters[1].valueAsText
        desc = parameters[2].valueAsText
        if not desc:
             desc = ""
        labF = parameters[3].valueAsText
        if not labF:
             labF = ""
        trans = parameters[4].valueAsText
        if not trans:
             trans = "0"
        ZSource = parameters[5].valueAsText
        if not ZSource:
             ZSource = "None"
        ZField = parameters[6].valueAsText
        if not ZField:
             ZField = ""
        ZConst = parameters[7].valueAsText
        if not ZConst:
             ZConst = "0"
        ZUnits = parameters[8].valueAsText
        if not ZUnits:
             ZUnits = "Meters"
        ZType = parameters[9].valueAsText
        if not ZType:
             ZType = "Absolute"
        bExtrude = parameters[10].valueAsText
        fillCol = parameters[11].valueAsText
        if not fillCol:
             fillCol = "Grey"
        lineCol = parameters[12].valueAsText
        if not lineCol:
             lineCol = "Grey"
        lineW = parameters[13].valueAsText
        if not lineW:
             lineW = "1"
        bInfo = parameters[14].valueAsText
        infoS = parameters[15].valueAsText
        if not infoS:
             infoS = "Info"
        infoScale = parameters[16].valueAsText
        if not infoScale:
             infoScale = 1
        prec = parameters[17].valueAsText
        if not prec:
             prec =  6
                              
        etFunction = "ExportToGoogle"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outFile,desc,labF,trans,
                                   ZSource,ZField,ZConst,ZUnits,ZType,bExtrude,fillCol,
                                   lineCol,lineW,bInfo,infoS,infoScale,prec],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ImportFromGoogle(object):
    def __init__(self):
        self.label       = "Import From Google"
        self.description = "Imports Google Earth (KML or KMZ)data. The attributes (if available in the KML/KMZ files) are imported with the geometries. The spatial reference of the resulting feature classes will be GCS_WGS_1984 which is the Google Earth native projection."
        self.category = "Import-Export"
        
    def getParameterInfo(self):
        #input_kml 
        input_kml = arcpy.Parameter(
            displayName="Input KML (KMZ) file",
            name="input_kml",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")

        # out_workspace parameter
        out_workspace = arcpy.Parameter(
            displayName="Output Workspace",
            name="out_workspace",
            datatype="DEWorkspace",
            parameterType="Required",
            direction="Input")
            
        parameters = [input_kml,out_workspace]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                                
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inKML  = parameters[0].valueAsText
        outWorkspace  = parameters[1].valueAsText
                                     
        etFunction = "ImportFromGoogle"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inKML,outWorkspace],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class Generate(object):
    def __init__(self):
        self.label       = "Generate (Import from text)"
        self.description = "Generates a shapefile or FileGDB feature class from an ArcInfo generate format text file."
        self.category = "Import-Export"
        
    def getParameterInfo(self):
        #input_text_file 
        input_text_file = arcpy.Parameter(
            displayName="Input Text File",
            name="input_text_file",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        out_dataset.schema.geometryTypeRule = "AsSpecified"

         # shape_type parameter
        shape_type = arcpy.Parameter(
            displayName="Shape Type",
            name="shape_type",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        shape_type.filter.type = "ValueList"
        shape_type.filter.list = ["Point", "Polyline","Polygon","Box","Line"]
        shape_type.value = "Point"

        # import_attributes
        import_attributes = arcpy.Parameter(
            displayName="Input Has Attributes",
            name="import_attributes",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        import_attributes.value = "False"

        # has_z
        has_z = arcpy.Parameter(
            displayName="Input has Z",
            name="has_z",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        has_z.value = "False"

        # has_m
        has_m = arcpy.Parameter(
            displayName="Input has M",
            name="has_m",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        has_m.value = "False"

         # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        reference_dataset.filter.list = [] 

        # force_closure
        force_closure = arcpy.Parameter(
            displayName="Force Closure",
            name="force_closure",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        force_closure.value = "False"      
            
        parameters = [input_text_file,out_dataset,shape_type,import_attributes,has_z,has_m,
                      reference_dataset,force_closure]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        shType = parameters[2].valueAsText
        if (shType == "Polyline") or (shType == "Polyline"):
            parameters[1].schema.geometryType = "Polyline"
            parameters[7].enabled = False
        elif shType == "Point":
            parameters[1].schema.geometryType = "Point"
            parameters[7].enabled = False
        else:
            parameters[1].schema.geometryType = "Polygon"
            if shType == "Box":
                parameters[7].enabled = False
            else:
                parameters[7].enabled = True                        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                      
        return

    def execute(self, parameters, messages):
        inText  = parameters[0].valueAsText
        outDataset  = parameters[1].valueAsText
        gType  = parameters[2].valueAsText
        bAtt = parameters[3].valueAsText
        bZ = parameters[4].valueAsText
        bM = parameters[5].valueAsText
        refD = parameters[6].valueAsText
        if refD:
             refDataset  = arcpy.Describe(parameters[6].value).catalogPath
        else:
             refDataset = ""
        bForce = parameters[7].valueAsText
                             
        etFunction = "Generate"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inText,outDataset,gType,bAtt,bZ,bM,refDataset,bForce],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class Ungenerate(object):
    def __init__(self):
        self.label       = "Ungenerate (Export to text)"
        self.description = "Exports a feature class to a standard ArcInfo generate format text file. The 'Export Attributes' option uses an extended file format - see User Guide for details."
        self.category = "Import-Export"
        
    def getParameterInfo(self):
        # Input Features parameter 0
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point","Polygon","Polyline"]
            
        # Output Features parameter 1
        out_file = arcpy.Parameter(
            displayName="Output text file",
            name="out_file",
            datatype="DEFile",
            parameterType="Required",
            direction="Output")

         # delimiter parameter
        delimiter = arcpy.Parameter(
            displayName="Delimiter",
            name="delimiter",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        delimiter.filter.type = "ValueList"
        delimiter.filter.list = ["Comma", "Space","Tab"]
        delimiter.value = "Comma"

        # export_attributes
        export_attributes = arcpy.Parameter(
            displayName="Expoprt Attributes",
            name="export_attributes",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        export_attributes.value = "False"

        # export_only_envelope
        export_only_envelope = arcpy.Parameter(
            displayName="Export only feature envelopes",
            name="export_only_envelope",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        export_only_envelope.value = "False"

        #coordinate_precision parameter 17
        coordinate_precision = arcpy.Parameter(
            displayName="Coordinate precision - places after the decimal point",
            name="coordinate_precision",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")
        coordinate_precision.filter.type = 'Range'
        coordinate_precision.filter.list = [0,15]
        coordinate_precision.value = 8    
            
        parameters = [in_dataset,out_file,delimiter,export_attributes,export_only_envelope,
                      coordinate_precision]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                              
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                      
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outText  = parameters[1].valueAsText
        sDelim  = parameters[2].valueAsText
        bAtt = parameters[3].valueAsText
        bEnv = parameters[4].valueAsText
        iPrec = parameters[5].valueAsText
        if not iPrec:
             iPrec = "8"
                                     
        etFunction = "Ungenerate"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outText,sDelim,bAtt,bEnv,iPrec],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SpatialJoin(object):
    def __init__(self):
        self.label       = "Spatial Join"
        self.description = "Joins the attributes of feature classes based on the spatial relationships of the features."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # target_dataset parameter
        target_dataset = arcpy.Parameter(
            displayName="Target Dataset",
            name="target_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        target_dataset.filter.list = ["Polygon","Polyline","Point"]

        # source_dataset parameter
        source_dataset = arcpy.Parameter(
            displayName="Source Dataset",
            name="source_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        source_dataset.filter.list = ["Polygon","Polyline","Point"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [target_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"

         # join_type parameter 3
        join_type = arcpy.Parameter(
            displayName="Join Type",
            name="join_type",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        join_type.filter.type = "ValueList"
        join_type.filter.list = ["OneToMany","ManyToMany"]
        join_type.value = "OneToMany"

         # search_tolerance parameter 4
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        search_tolerance.value = 0

        # unit 5
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units:",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # join_fields parameter 6
        join_fields = arcpy.Parameter(
            displayName="Join Fields",
            name="join_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        join_fields.parameterDependencies = [source_dataset.name]
        join_fields.columns = [["Field","Field"],["GPString", "Statistic Type"]]
        join_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
        join_fields.filters[1].type = "ValueList"
        join_fields.filters[1].list = ["SUM", "MAX", "MIN", "FIRST","LAST"]
                
        # keep_all 7
        keep_all = arcpy.Parameter(
            displayName="Keep All Target Features",
            name="keep_all",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        keep_all.value = "True"
        
        # calc_area_length_stats 8
        calc_area_length_stats = arcpy.Parameter(
            displayName="Calculate Area/Length Statistics",
            name="calc_area_length_stats",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        calc_area_length_stats.value = "False"
                         
        parameters = [target_dataset,source_dataset,out_dataset,join_type,search_tolerance,
                      unit,join_fields,keep_all, calc_area_length_stats]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
             try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[5].value =  inUnit    
             except:
                 parameters[5].value = ""

             try:
                 inGeom  = arcpy.Describe(parameters[0].value).shapeType
                 infList  = arcpy.Describe(parameters[0].value).fields
                 refGeom  = arcpy.Describe(parameters[1].value).shapeType
                 fList  = arcpy.Describe(parameters[1].value).fields
             except:
                 inGeom = ""
                 infList = []
                 refGeom = ""
                 fList = ""
             if parameters[3].valueAsText == "OneToMany":
                  fieldNames = ["ET_Joined"]
                  fieldTypes = ["Long"]
                  parameters[8].value = False
                  parameters[8].enabled = False
             else:
                  parameters[8].enabled = True
                  fieldNames = ["ET_Count","ET_CountIn"]
                  fieldTypes = ["Long","Long"]
                  if inGeom == "Polygon":
                       if refGeom == "Polygon":
                            if parameters[8].value:
                                 fieldNames.append("AreaIn")
                                 fieldTypes.append("Double")
                       elif refGeom == "Polyline":
                            if parameters[8].value:
                                 fieldNames.append("LengthIn")
                                 fieldTypes.append("Double")
                  elif refGeom == "Polygon":
                       if inGeom == "Polygon":
                            if parameters[8].value:
                                 fieldNames.append("AreaIn")
                                 fieldTypes.append("Double")
                       elif inGeom == "Polyline":
                            if parameters[8].value:
                                 fieldNames.append("LengthIn")
                                 fieldTypes.append("Double")
             if parameters[6].valueAsText:
                  
                  value_table = arcpy.ValueTable(2)
                  value_table.loadFromString(parameters[6].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       for f in fList:
                            if f.name == fld:
                                 if f.name not in infList:
                                      fieldNames.append(f.name)
                                      fieldTypes.append(f.type)
             else:
                  for f in fList:
                       if f.name not in infList:
                            fieldNames.append(f.name)
                            fieldTypes.append(f.type)
             addFields = []
             for fieldInd, fieldName in enumerate(fieldNames):
                  fieldType = fieldTypes[fieldInd]
                  newField = arcpy.Field()
                  newField.name = fieldName
                  newField.type = fieldType
                  addFields.append(newField) 
             parameters[2].schema.additionalFields = addFields
           
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        try:
             if parameters[1].altered:
                  fList  = arcpy.Describe(parameters[1].value).fields
                  fieldNames = []
                  for f in fList:
                       fieldNames.append(f.name)
                  value_table = arcpy.ValueTable(2)
                  value_table.loadFromString(parameters[6].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[6].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[6].clearMessage
        except:
             a=0       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        joinT  = parameters[3].valueAsText
        dTol = parameters[4].valueAsText
        sJoinF = parameters[6].valueAsText
        if not sJoinF:
             sJoinF = ""
        bKeep =  parameters[7].valueAsText
        bStat =  parameters[8].valueAsText                             
        etFunction = "SpatialJoin"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,joinT,dTol,sJoinF,bKeep,bStat],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class TransferPolylineAttributes(object):
    def __init__(self):
        self.label       = "Transfer Polyline Attributes"
        self.description = "Transfers the attributes from the source polyline dataset to the target polylines based on their spatial relations."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # target_dataset parameter
        target_dataset = arcpy.Parameter(
            displayName="Target Dataset",
            name="target_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        target_dataset.filter.list = ["Polyline"]

        # source_dataset parameter
        source_dataset = arcpy.Parameter(
            displayName="Source Dataset",
            name="source_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        source_dataset.filter.list = ["Polyline"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [target_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"

         # search_tolerance parameter 3
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit 4
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units:",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # transfer_fields parameter 5
        transfer_fields = arcpy.Parameter(
            displayName="Transfer Fields",
            name="transfer_fields",
            datatype="GPValueTable",
            parameterType="Optional",
            direction="Input")
        transfer_fields.parameterDependencies = [source_dataset.name]
        transfer_fields.columns = [["Field","Field"]]
        transfer_fields.filters[0].list = ["Double", "Float", "Short", "Long", "String", "Date","Text","Integer"]
                
        parameters = [target_dataset,source_dataset,out_dataset,search_tolerance,
                      unit,transfer_fields]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered or parameters[1].altered:
             try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[4].value =  inUnit    
             except:
                 parameters[4].value = ""

             try:
                 inGeom  = arcpy.Describe(parameters[0].value).shapeType
                 infList  = arcpy.Describe(parameters[0].value).fields
                 refGeom  = arcpy.Describe(parameters[1].value).shapeType
                 fList  = arcpy.Describe(parameters[1].value).fields
             except:
                 inGeom = ""
                 infList = []
                 refGeom = ""
                 fList = ""
             fieldNames = []
             fieldTypes = []
             if parameters[5].valueAsText:
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[5].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       for f in fList:
                            if f.name == fld:
                                 if f.name not in infList:
                                      fieldNames.append(f.name)
                                      fieldTypes.append(f.type)
             else:
                  for f in fList:
                       if f.name not in infList:
                            fieldNames.append(f.name)
                            fieldTypes.append(f.type)
             addFields = []
             for fieldInd, fieldName in enumerate(fieldNames):
                  fieldType = fieldTypes[fieldInd]
                  newField = arcpy.Field()
                  newField.name = fieldName
                  newField.type = fieldType
                  addFields.append(newField) 
             parameters[2].schema.additionalFields = addFields
           
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        try:
             if parameters[1].altered:
                  fList  = arcpy.Describe(parameters[1].value).fields
                  fieldNames = []
                  for f in fList:
                       fieldNames.append(f.name)
                  value_table = arcpy.ValueTable(1)
                  value_table.loadFromString(parameters[5].valueAsText)
                  for i in range(0, value_table.rowCount):
                       fld = value_table.getValue(i,0)
                       if fld not in fieldNames :     
                            parameters[5].setErrorMessage("Field does not exist!") 
                       else:
                            parameters[5].clearMessage
        except:
             a=0       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        sJoinF = parameters[5].valueAsText
        if not sJoinF:
             sJoinF = ""
                                   
        etFunction = "TransferPolylineAttributes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,dTol,sJoinF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CreateRoutes(object):
    def __init__(self):
        self.label       = "Create Routes"
        self.description = "Creates routes from existing polyline features. Input polylines that share a common identifier are merged to create a single route."
        self.category = "Linear Referencing"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_KEY"]
        fieldTypes = ["String"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # ID_field
        route_id_field = arcpy.Parameter(
            displayName="Route ID field",
            name="route_id_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        route_id_field.parameterDependencies = [in_dataset.name]
        route_id_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]
        
        # measure_from parameter 3
        measure_from = arcpy.Parameter(
            displayName="Get Measure From Option",
            name="measure_from",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        measure_from.filter.type = "ValueList"
        measure_from.filter.list = ["Length", "SingleField","TwoFields"]
        measure_from.value = "Length"
        
        # measure_field 4
        measure_field = arcpy.Parameter(
            displayName="Measure (Measure From) Field",
            name="measure_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        measure_field.parameterDependencies = [in_dataset.name]
        measure_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # measure_to_field 5
        measure_to_field = arcpy.Parameter(
            displayName="Measure To Field",
            name="measure_to_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        measure_to_field.parameterDependencies = [in_dataset.name]
        measure_to_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # coordinates_priority parameter 6
        coordinates_priority = arcpy.Parameter(
            displayName="Start Points of Routes",
            name="coordinates_priority",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        coordinates_priority.filter.type = "ValueList"
        coordinates_priority.filter.list = ["South-West", "South-East","North-West","North-East"]
        coordinates_priority.value = "South-West"

        # ignore_spatial_gaps 7
        ignore_spatial_gaps = arcpy.Parameter(
            displayName="Ignore Spatial Gaps",
            name="ignore_spatial_gaps",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        ignore_spatial_gaps.value = "True"
        
        parameters = [in_dataset,out_dataset,route_id_field,measure_from,
                      measure_field,measure_to_field,coordinates_priority,ignore_spatial_gaps]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[3].valueAsText == "Length":
             parameters[4].enabled = False
             parameters[5].enabled = False
             parameters[6].enabled = True
             parameters[7].enabled = True
        elif parameters[3].valueAsText == "SingleField":
             parameters[4].enabled = True
             parameters[5].enabled = False
             parameters[6].enabled = True
             parameters[7].enabled = True
        else:
             parameters[4].enabled = True
             parameters[5].enabled = True
             parameters[6].enabled = False
             parameters[7].enabled = False
        return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if parameters[3].valueAsText == "TwoFields":
             if not (parameters[4].valueAsText) or not (parameters[5].valueAsText):
                  parameters[4].setErrorMessage("From and To Measure Fields needed!")
             else:
                  parameters[4].clearMessage  
        elif parameters[3].valueAsText == "SingleField":
             if not (parameters[4].valueAsText):
                  parameters[4].setErrorMessage("Measure Field needed!")
             else:
                  parameters[4].clearMessage
        else:
              parameters[4].clearMessage  
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sID = parameters[2].valueAsText
        sOp = parameters[3].valueAsText
        sFromF = parameters[4].valueAsText
        if not sFromF:
             sFromF = ""
        sToF = parameters[5].valueAsText
        if not sToF:
             sToF = ""
        sCoord = parameters[6].valueAsText
        if not sCoord:
             sCoord = "ll"
        bIgnore = parameters[7].valueAsText                           
        etFunction = "CreateRoutes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sID,sOp,sFromF,sToF,sCoord,bIgnore],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CalibrateRoutes(object):
    def __init__(self):
        self.label       = "Calibrate Routes"
        self.description = "Calibrates existing routes using the measures of existing points. The measures to be used can be stored as M value of pointsM or in a field of the point attribute table."
        self.category = "Linear Referencing"
        
    def getParameterInfo(self):
        # route_dataset parameter 0
        route_dataset = arcpy.Parameter(
            displayName="Route Dataset",
            name="route_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        route_dataset.filter.list = ["Polyline"]

        # calibrate_dataset parameter 1
        calibrate_dataset = arcpy.Parameter(
            displayName="Calibrate Dataset",
            name="calibrate_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        calibrate_dataset.filter.list = ["Point"]
        
        # Output Features parameter 2
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [route_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
                
        # ID_field 3
        route_id_field = arcpy.Parameter(
            displayName="Route ID field",
            name="route_id_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        route_id_field.parameterDependencies = [route_dataset.name]
        route_id_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]

        # point_key_field 4
        point_key_field = arcpy.Parameter(
            displayName="Point Key Field",
            name="point_key_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        point_key_field.parameterDependencies = [calibrate_dataset.name]
        point_key_field.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]
        
        # calibrate_method parameter 5
        calibrate_method = arcpy.Parameter(
            displayName="Calibrate Method",
            name="calibrate_method",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        calibrate_method.filter.type = "ValueList"
        calibrate_method.filter.list = ["Distance", "Measure"]
        calibrate_method.value = "Distance"
        
         # search_tolerance parameter 6
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit 7
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # use_points_m 8
        use_points_m = arcpy.Parameter(
            displayName="Use Points M values",
            name="use_points_m",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        use_points_m.value = "False"     

        # point_m_field 9
        point_m_field = arcpy.Parameter(
            displayName="Point M Field",
            name="point_m_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        point_m_field.parameterDependencies = [calibrate_dataset.name]
        point_m_field.list = ["Double", "Float", "Short", "Long","Integer"]

        # extrapolate_before 10
        extrapolate_before = arcpy.Parameter(
            displayName="Extrapolate Before",
            name="extrapolate_before",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        extrapolate_before.value = "False"

        # interpolate_between 11
        interpolate_between = arcpy.Parameter(
            displayName="Interpolate Between",
            name="interpolate_between",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        interpolate_between.value = "True"

        # extrapolate_after 12
        extrapolate_after = arcpy.Parameter(
            displayName="Extrapolate After",
            name="extrapolate_after",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        extrapolate_after.value = "False"
        
        # ignore_spatial_gaps 13
        ignore_spatial_gaps = arcpy.Parameter(
            displayName="Ignore Spatial Gaps",
            name="ignore_spatial_gaps",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        ignore_spatial_gaps.value = "False"
        
        parameters = [route_dataset,calibrate_dataset,out_dataset,route_id_field,point_key_field,
                      calibrate_method,search_tolerance,unit,use_points_m,point_m_field,
                      extrapolate_before,interpolate_between,extrapolate_after,ignore_spatial_gaps]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[7].value =  inUnit    
            except:
                 parameters[7].value = ""
        if parameters[1].valueAsText:
            if not arcpy.Describe(parameters[1].value).hasM:
                parameters[8].value = "False"
                parameters[8].enabled = "False"
            else:
                parameters[8].enabled = "True"

        return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        try:     
            if parameters[0].valueAsText:
                if not arcpy.Describe(parameters[0].value).hasM:
                    parameters[0].setErrorMessage("The Route input has no M values!")
                else:
                    parameters[0].clearMessage
            if parameters[1].valueAsText:
                if not parameters[8].value:
                    if not parameters[9].valueAsText:
                        parameters[9].setErrorMessage("The Point M Field parameter required if the points don't have M!")
                    else:
                        parameters[9].clearMessage
            else:
                parameters[9].clearMessage
        except:
             a=0                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        pointDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        sIDF = parameters[3].valueAsText
        sPointKeyF = parameters[4].valueAsText
        sCalMethod = parameters[5].valueAsText
        dSearch = parameters[6].valueAsText
        bUseM = parameters[8].valueAsText
        sMF = parameters[9].valueAsText
        if not sMF:
             sMF = ""
        bBefore = parameters[10].valueAsText
        bBetween = parameters[11].valueAsText
        bAfter = parameters[12].valueAsText
        bIgnore = parameters[13].valueAsText                           
        etFunction = "CalibrateRoutes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,pointDataset,outDataset,sIDF,sPointKeyF,
                                  sCalMethod,dSearch,bUseM,sMF,bBefore,bBetween,bAfter,bIgnore],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class LocateFeaturesAlongRoutes(object):
    def __init__(self):
        self.label       = "Locate Features Along Routes"
        self.description = "Calculates route and measure information at the geometric intersection of polygon,polyline or point data and route data and creates a polyline event table or feature layer."
        self.category = "Linear Referencing"
        
    def getParameterInfo(self):
        # in_dataset parameter 0
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point","Polygon","Polyline"]

        # route_dataset parameter 1
        route_dataset = arcpy.Parameter(
            displayName="Route Dataset",
            name="route_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        route_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter 2
        out_dataset = arcpy.Parameter(
            displayName="Output Event Table",
            name="out_dataset",
            datatype="DETable",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        #out_dataset.parameterDependencies = [in_dataset.name]
        #out_dataset.schema.clone = True
                
        # ID_field 3
        route_id_field = arcpy.Parameter(
            displayName="Route ID field",
            name="route_id_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        route_id_field.parameterDependencies = [route_dataset.name]
        route_id_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]
        
        # search_tolerance parameter 4
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
        # unit 5
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # transfer_attributes 6
        transfer_attributes = arcpy.Parameter(
            displayName="Transfer Attributes",
            name="transfer_attributes",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        transfer_attributes.value = "True"
        
        parameters = [in_dataset,route_dataset,out_dataset,route_id_field,search_tolerance,
                      unit,transfer_attributes]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[1].altered:
            try:
                 inSR  = arcpy.Describe(parameters[1].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[5].value =  inUnit    
            except:
                 parameters[5].value = ""
        if parameters[0].valueAsText:
            try:
                if arcpy.Describe(parameters[0].value).shapeType == "Point":
                    fieldNames = ["ET_RouteID","ET_Measure"]
                    fieldTypes = ["String","Double"]
                else:
                    fieldNames = ["ET_RouteID","ET_FromM","ET_ToM"]
                    fieldTypes = ["String","Double","Double"]
                if parameters[6].value:
                    fList = arcpy.Describe(parameters[0].value).fields
                    for f in fList:
                        fieldNames.append(f.name)
                        fieldTypes.append(f.type)
                addFields = []
                for fieldInd, fieldName in enumerate(fieldNames):
                    fieldType = fieldTypes[fieldInd]
                    newField = arcpy.Field()
                    newField.name = fieldName
                    newField.type = fieldType
                    addFields.append(newField) 
                parameters[2].schema.additionalFields = addFields           
            except:
                a=0                        
            return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        try:     
            if parameters[1].valueAsText:
                if not arcpy.Describe(parameters[1].value).hasM:
                    parameters[1].setErrorMessage("The Route input has no M values!")
                else:
                    parameters[1].clearMessage
            if parameters[0].valueAsText:
                geomT = arcpy.Describe(parameters[0].value).shapeType
                if geomT == "Polygon":
                    parameters[4].clearMessage
                else:
                    if not parameters[4].valueAsText:
                        parameters[4].setErrorMessage("Search tolerance required for Point and Polyline input datasets!")
                    else:
                        parameters[4].clearMessage
        except:
             a=0        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        routeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        sIDF = parameters[3].valueAsText
        dSearch = parameters[4].valueAsText
        if not dSearch:
             dSearch = "0"
        bAttrib = parameters[6].valueAsText                           
        etFunction = "LocateFeaturesAlongRoutes"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,routeDataset,outDataset,sIDF,
                                  dSearch,"True",bAttrib],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class FeaturesFromRouteEvents(object):
    def __init__(self):
        self.label       = "Features From Route Events"
        self.description = "Creates a feature layer from a route dataset and an event table."
        self.category = "Linear Referencing"
        
    def getParameterInfo(self):
         # route_dataset parameter 0
        route_dataset = arcpy.Parameter(
            displayName="Route Dataset",
            name="route_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        route_dataset.filter.list = ["Polyline"]

        # events_table parameter 1
        events_table = arcpy.Parameter(
            displayName="Events Table",
            name="events_table",
            datatype="DETable",
            parameterType="Required",
            direction="Input")
    
        # Output Features parameter 2
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [events_table.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # ID_field 3
        route_id_field = arcpy.Parameter(
            displayName="Route ID field",
            name="route_id_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        route_id_field.parameterDependencies = [route_dataset.name]
        route_id_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]
        
       # event_type parameter 4
        event_type = arcpy.Parameter(
            displayName="Get Measure From Option",
            name="event_type",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        event_type.filter.type = "ValueList"
        event_type.filter.list = ["Point", "Line"]
        event_type.value = "Point"
        
         # event_key_field 5
        event_key_field = arcpy.Parameter(
            displayName="Event Key Field",
            name="event_key_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        event_key_field.parameterDependencies = [events_table.name]
        event_key_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]

        # from_measure_field 6
        from_measure_field = arcpy.Parameter(
            displayName="Measure/From Measure Field",
            name="from_measure_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        from_measure_field.parameterDependencies = [events_table.name]
        from_measure_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # to_measure_field 7
        to_measure_field = arcpy.Parameter(
            displayName="Measure/From Measure Field",
            name="to_measure_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        to_measure_field.parameterDependencies = [events_table.name]
        to_measure_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]
        
        parameters = [route_dataset,events_table,out_dataset,route_id_field,event_type,
                      event_key_field,from_measure_field,to_measure_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[4].valueAsText == "Point":
            parameters[2].schema.geometryType = "Point"
            parameters[7].enabled = "False"
        else:
            parameters[2].schema.geometryType = "Polyline" 
            parameters[7].enabled = "True"
        parameters[2].schema.geometryTypeRule = "AsSpecified"
          
        return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        if parameters[4].valueAsText == "Point":
            parameters[7].clearMessage
        else:
            if not parameters[7].valueAsText:
                  parameters[7].setErrorMessage("To Measure Field required for Line Events!")
            else:
                  parameters[7].clearMessage

        return

    def execute(self, parameters, messages):
        routeDataset  = arcpy.Describe(parameters[0].value).catalogPath
        eventTab  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        sIDF = parameters[3].valueAsText
        eventTyp = parameters[4].valueAsText
        eventKeyF = parameters[5].valueAsText
        eventFromF = parameters[6].valueAsText
        eventToF = parameters[7].valueAsText
        if not eventToF:
             eventToF = ""
                                  
        etFunction = "FeaturesFromRouteEvents"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,routeDataset,eventTab,outDataset,sIDF,
                                  eventTyp,eventKeyF,eventFromF,eventToF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class DissolveRouteEvents(object):
    def __init__(self):
        self.label       = "Dissolve Route Events"
        self.description = "Combines events that have overlapping measures and the same value in an attribute field."
        self.category = "Linear Referencing"
        
    def getParameterInfo(self):
        
        # events_table parameter 0
        events_table = arcpy.Parameter(
            displayName="Events Table",
            name="events_table",
            datatype="DETable",
            parameterType="Required",
            direction="Input")
    
         # Output Features parameter 1
        out_dataset = arcpy.Parameter(
            displayName="Output Event Table",
            name="out_dataset",
            datatype="DETable",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        #out_dataset.parameterDependencies = [in_dataset.name]
        #out_dataset.schema.clone = True
        
         # event_key_field 2
        event_key_field = arcpy.Parameter(
            displayName="Event Key Field",
            name="event_key_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        event_key_field.parameterDependencies = [events_table.name]
        event_key_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]

        # dissolve_field 3
        dissolve_field = arcpy.Parameter(
            displayName="Dissolve Field",
            name="dissolve_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        dissolve_field.parameterDependencies = [events_table.name]
        dissolve_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]

        # from_measure_field 4
        from_measure_field = arcpy.Parameter(
            displayName="Measure/From Measure Field",
            name="from_measure_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        from_measure_field.parameterDependencies = [events_table.name]
        from_measure_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # to_measure_field 5
        to_measure_field = arcpy.Parameter(
            displayName="Measure/From Measure Field",
            name="to_measure_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        to_measure_field.parameterDependencies = [events_table.name]
        to_measure_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]
        
        parameters = [events_table,out_dataset,event_key_field,dissolve_field,from_measure_field,to_measure_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                  
        return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        eventTab  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        eventKeyF = parameters[2].valueAsText
        disF = parameters[3].valueAsText
        eventFromF = parameters[4].valueAsText
        eventToF = parameters[5].valueAsText
                                         
        etFunction = "DissolveRouteEvents"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,eventTab,outDataset,eventKeyF,
                                  disF,eventFromF,eventToF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ConcatenateRouteEvents(object):
    def __init__(self):
        self.label       = "Concatenate Route Events"
        self.description = "Combines events if the TO measure of an event matches the FROM measure of the next and the two events have the same value in an attribute field."
        self.category = "Linear Referencing"
        
    def getParameterInfo(self):
        
        # events_table parameter 0
        events_table = arcpy.Parameter(
            displayName="Events Table",
            name="events_table",
            datatype="DETable",
            parameterType="Required",
            direction="Input")
    
         # Output Features parameter 1
        out_dataset = arcpy.Parameter(
            displayName="Output Event Table",
            name="out_dataset",
            datatype="DETable",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        #out_dataset.parameterDependencies = [in_dataset.name]
        #out_dataset.schema.clone = True
        
         # event_key_field 2
        event_key_field = arcpy.Parameter(
            displayName="Event Key Field",
            name="event_key_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        event_key_field.parameterDependencies = [events_table.name]
        event_key_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]

        # dissolve_field 3
        dissolve_field = arcpy.Parameter(
            displayName="Dissolve Field",
            name="dissolve_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        dissolve_field.parameterDependencies = [events_table.name]
        dissolve_field.filter.list = ["Double", "Float", "Short", "Long","String","Text","Integer"]

        # from_measure_field 4
        from_measure_field = arcpy.Parameter(
            displayName="Measure/From Measure Field",
            name="from_measure_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        from_measure_field.parameterDependencies = [events_table.name]
        from_measure_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]

        # to_measure_field 5
        to_measure_field = arcpy.Parameter(
            displayName="Measure/From Measure Field",
            name="to_measure_field",
            datatype="Field",
            parameterType="Required",
            direction="Input")
        to_measure_field.parameterDependencies = [events_table.name]
        to_measure_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]
        
        parameters = [events_table,out_dataset,event_key_field,dissolve_field,from_measure_field,to_measure_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                  
        return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        eventTab  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        eventKeyF = parameters[2].valueAsText
        disF = parameters[3].valueAsText
        eventFromF = parameters[4].valueAsText
        eventToF = parameters[5].valueAsText
                                         
        etFunction = "ConcatenateRouteEvents"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,eventTab,outDataset,eventKeyF,
                                  disF,eventFromF,eventToF],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CleanPolylines(object):
    def __init__(self):
        self.label       = "CleanPolylines"
        self.description = "Ensures topological correctness of a polyline feature data set."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # fuzzy_tolerance parameter
        fuzzy_tolerance = arcpy.Parameter(
            displayName="Fuzzy Tolerance",
            name="fuzzy_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # duplicates_dataset parameter
        duplicates_dataset = arcpy.Parameter(
            displayName="Duplicates Dataset",
            name="duplicates_dataset",
            datatype="DEFeatureClass",
            parameterType="Optional",
            direction="Output")
        # Copy definition from source
        duplicates_dataset.parameterDependencies = [in_dataset.name]
        duplicates_dataset.schema.clone = True
        duplicates_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        duplicates_dataset.schema.additionalFields = addFields
            
        parameters = [in_dataset, out_dataset,fuzzy_tolerance,unit, duplicates_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
        global inputVal
        if parameters[0].altered:
            inDataset  = parameters[0].valueAsText
            if not inDataset == inputVal:
                 try:
                      inputVal = inDataset
                      ext = arcpy.Describe(parameters[0].value).extent
                      w = abs(ext.XMax - ext.XMin)
                      h = abs(ext.YMax - ext.YMin)
                      parameters[2].value =  "{0:.8f}".format((w + h) / 2000000)
                 except:
                      parameters[2].value = "0"
        else:
            inputVal = ""
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        linkDataset = parameters[4].valueAsText
        if not linkDataset:
             linkDataset = ""
                       
        etFunction = "CleanPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,linkDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CleanDangles(object):
    def __init__(self):
        self.label       = "CleanDangles"
        self.description = "Cleans the dangling nodes from a polyline dataset using user specified dangling tolerance."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # dangle_tolerance parameter
        dangle_tolerance = arcpy.Parameter(
            displayName="Dangling Tolerance",
            name="dangle_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # snap_nearest 4
        snap_nearest = arcpy.Parameter(
            displayName="Snap To Nearest",
            name="snap_nearest",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        snap_nearest.value = "False"

        # fuzzy_tolerance parameter 5
        fuzzy_tolerance = arcpy.Parameter(
            displayName="Fuzzy Tolerance",
            name="fuzzy_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
            
        parameters = [in_dataset, out_dataset,dangle_tolerance,unit, snap_nearest,fuzzy_tolerance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
        global inputVal
        if parameters[0].altered:
            inDataset  = parameters[0].valueAsText
            if not inDataset == inputVal:
                 try:
                      inputVal = inDataset
                      ext = arcpy.Describe(parameters[0].value).extent
                      w = abs(ext.XMax - ext.XMin)
                      h = abs(ext.YMax - ext.YMin)
                      parameters[5].value =  "{0:.8f}".format((w + h) / 2000000)
                 except:
                      parameters[5].value = "0"
        else:
            inputVal = ""
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        bNearest = parameters[4].valueAsText
        dFuzzy = parameters[2].valueAsText
        if not dFuzzy:
             dFuzzy = "0"
       
        etFunction = "CleanDangles"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,bNearest,dFuzzy],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CleanPolygons(object):
    def __init__(self):
        self.label       = "CleanPolygons"
        self.description = "Ensures topological correctness of a polygon data set."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # fuzzy_tolerance parameter
        fuzzy_tolerance = arcpy.Parameter(
            displayName="Fuzzy Tolerance",
            name="fuzzy_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
            
        # Output Overlaps parameter
        out_overlaps = arcpy.Parameter(
            displayName="Output Overlaps",
            name="out_overlaps",
            datatype="DEFeatureClass",
            parameterType="Optional",
            direction="Output")
        # Copy definition from source
        out_overlaps.parameterDependencies = [in_dataset.name]
        out_overlaps.schema.clone = True
        out_overlaps.schema.fieldsRule = "All"
        out_overlaps.schema.geometryTypeRule = "AsSpecified"
        out_overlaps.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["OriginalID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_overlaps.schema.additionalFields = addFields
        
        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
                  
        parameters = [in_dataset,out_dataset,fuzzy_tolerance,out_overlaps,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[4].value =  inUnit   
            except:
                 parameters[4].value = ""
        global inputVal
        if parameters[0].altered:
            inDataset  = parameters[0].valueAsText
            if not inDataset == inputVal:
                 try:
                      inputVal = inDataset
                      ext = arcpy.Describe(parameters[0].value).extent
                      w = abs(ext.XMax - ext.XMin)
                      h = abs(ext.YMax - ext.YMin)
                      parameters[2].value =  "{0:.8f}".format((w + h) / 2000000)
                 except:
                      parameters[2].value = "0"
        else:
            inputVal = ""
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dFuzzy = parameters[2].valueAsText
        if not dFuzzy:
             dFuzzy = "0"
        outOver = parameters[3].valueAsText
        if not outOver:
             outOver = ""
                       
        etFunction = "CleanPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dFuzzy,outOver],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class BuildPolygons(object):
    def __init__(self):
        self.label       = "BuildPolygons"
        self.description = "Ensures topological correctness of a polygon data set."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # fuzzy_tolerance parameter
        fuzzy_tolerance = arcpy.Parameter(
            displayName="Fuzzy Tolerance",
            name="fuzzy_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # label_dataset parameter
        label_dataset = arcpy.Parameter(
            displayName="Point Label Dataset",
            name="label_dataset",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        label_dataset.filter.list = ["Point"]
                  
        parameters = [in_dataset,out_dataset,fuzzy_tolerance,unit,label_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
        global inputVal
        if parameters[0].altered:
            inDataset  = parameters[0].valueAsText
            if not inDataset == inputVal:
                 try:
                      inputVal = inDataset
                      ext = arcpy.Describe(parameters[0].value).extent
                      w = abs(ext.XMax - ext.XMin)
                      h = abs(ext.YMax - ext.YMin)
                      parameters[2].value =  "{0:.8f}".format((w + h) / 2000000)
                 except:
                      parameters[2].value = "0"
        else:
            inputVal = ""
        if parameters[4].altered:
            fieldNames = []
            fieldTypes = []
            try:
                 fList  = arcpy.Describe(parameters[4].value).fields
                 for f in fList:
                     fieldNames.append(f.name)
                     fieldTypes.append(f.type)   
            except:
                 a=0
            addFields = []
            for fieldInd, fieldName in enumerate(fieldNames):
                fieldType = fieldTypes[fieldInd]
                newField = arcpy.Field()
                newField.name = fieldName
                newField.type = fieldType
                addFields.append(newField) 
                parameters[1].schema.additionalFields = addFields
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dFuzzy = parameters[2].valueAsText
        if not dFuzzy:
             dFuzzy = "0"
        sLabels = parameters[4].valueAsText
        if not sLabels:
             sLabels = ""
        else:
             sLabels  = arcpy.Describe(parameters[4].value).catalogPath              
        etFunction = "BuildPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dFuzzy,sLabels],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CreateCenterlines(object):
    def __init__(self):
        self.label       = "CreateCenterlines"
        self.description = "Creates centerlines from polygon features. Two options are available depending on the type of the input dataset: 1. Inside: The centerlines will be created inside the polygons - suitable for rivers and streets. 2. Outside: The centerlines will be created in the gaps between polygons - suitable for cadastral data."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # centerlines_option parameter 2
        centerlines_option = arcpy.Parameter(
            displayName="Centerlines Option",
            name="centerlines_option",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        centerlines_option.filter.type = "ValueList"
        centerlines_option.filter.list = ["Inside", "Outside"]
        centerlines_option.value = "Inside"

        # maximum_width parameter 3
        maximum_width = arcpy.Parameter(
            displayName="Maximum Width",
            name="maximum_width",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # minimum_width parameter 4
        minimum_width = arcpy.Parameter(
            displayName="Minimum Width",
            name="minimum_width",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit 5
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        parameters = [in_dataset, out_dataset,centerlines_option,maximum_width,minimum_width,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[5].value =  inUnit   
            except:
                 parameters[5].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sOption = parameters[2].valueAsText
        dMax = parameters[3].valueAsText
        dMin = parameters[4].valueAsText
               
        etFunction = "CreateCenterlines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sOption,dMax,dMin],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class AggregatePolygons(object):
    def __init__(self):
        self.label       = "AggregatePolygons"
        self.description = "Combines the polygons that are within the user specified distance into new polygons. Can be used also to generalize buildings."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # aggregation_tolerance parameter 2
        aggregation_tolerance = arcpy.Parameter(
            displayName="Agregation Tolerance",
            name="aggregation_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # max_hole_area parameter 3
        max_hole_area = arcpy.Parameter(
            displayName="Max area of holes to be removed.",
            name="max_hole_area",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # unit 4
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        parameters = [in_dataset, out_dataset,aggregation_tolerance,max_hole_area,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[4].value =  inUnit   
            except:
                 parameters[4].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        dMaxArea = parameters[3].valueAsText
        if not dMaxArea:
             dMaxArea="0"       
        etFunction = "AggregatePolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,dMaxArea],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class GeneralizePolygons(object):
    def __init__(self):
        self.label       = "Generalize Polygons"
        self.description = "Generalizes ( reduces the number of vertices required to represent a polygon ) the features of a polygon layer using the Douglas-Poiker algorithm."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # generalize_tolerance parameter 2
        generalize_tolerance = arcpy.Parameter(
            displayName="Generalize Tolerance",
            name="generalize_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # stand_alone_only
        stand_alone_only = arcpy.Parameter(
            displayName="The input contains stand-alone polygons only",
            name="stand_alone_only",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        stand_alone_only.value = "False"

        # unit 4
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        parameters = [in_dataset, out_dataset,generalize_tolerance,stand_alone_only,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[4].value =  inUnit   
            except:
                 parameters[4].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        bStand = parameters[3].valueAsText
             
        etFunction = "GeneralizePolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,bStand],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class DensifyPolygons(object):
    def __init__(self):
        self.label       = "Densify Polygons"
        self.description = "Densifies ( adds vertices to polygon boundaries at a user-specified tolerance ) the features of a polygon dataset."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass", 
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # densify_tolerance parameter 2
        densify_tolerance = arcpy.Parameter(
            displayName="Densify Tolerance",
            name="densify_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # stand_alone_only
        stand_alone_only = arcpy.Parameter(
            displayName="The input contains stand-alone polygons only",
            name="stand_alone_only",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        stand_alone_only.value = "False"
        
        # unit 3
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        parameters = [in_dataset, out_dataset,densify_tolerance,stand_alone_only,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[4].value =  inUnit   
            except:
                 parameters[4].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        bStand = parameters[3].valueAsText
             
        etFunction = "DensifyPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,bStand],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SmoothPolygonsBSpline(object):
    def __init__(self):
        self.label       = "Smooth Polygons B Spline"
        self.description = "Smoothes the features of a polygon layer using B-Spline algorithm."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # smoothness parameter
        smoothness = arcpy.Parameter(
            displayName="Smoothness (2..20)",
            name="smoothness",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        smoothness.filter.type = 'Range'
        smoothness.filter.list = [2,20]
        smoothness.value = 3

      # freedom parameter
        freedom = arcpy.Parameter(
            displayName="Freedom (3..10)",
            name="freedom",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        freedom.filter.type = 'Range'
        freedom.filter.list = [3,10]
        freedom.value = 5

       # densify_tolerance parameter
        densify_tolerance = arcpy.Parameter(
            displayName="Densify Before Smoothing Tolerance",
            name="densify_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

       # generalize_tolerance parameter
        generalize_tolerance = arcpy.Parameter(
            displayName="Generalize After Smoothing Tolerance",
            name="generalize_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,smoothness,freedom,densify_tolerance,generalize_tolerance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        iSm = parameters[2].valueAsText
        iFr = parameters[3].valueAsText
        denT = parameters[4].valueAsText
        if not denT:
             denT = ""
        genT = parameters[5].valueAsText
        if not genT:
             genT = ""
                     
        etFunction = "SmoothPolygonsBSpline"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,iSm,iFr,denT,genT],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SmoothPolygonsTSpline(object):
    def __init__(self):
        self.label       = "Smooth Polygons T Spline"
        self.description = "Smoothes the features of a polygon layer using T-Spline algorithm."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # smoothness parameter
        smoothness = arcpy.Parameter(
            displayName="Smoothness (2..20)",
            name="smoothness",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        smoothness.filter.type = 'Range'
        smoothness.filter.list = [2,20]
        smoothness.value = 3

       # tension parameter
        tension = arcpy.Parameter(
            displayName="Tension (1..100)",
            name="tension",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        tension.filter.type = 'Range'
        tension.filter.list = [1,100]
        tension.value = 10

       # densify_tolerance parameter
        densify_tolerance = arcpy.Parameter(
            displayName="Densify Before Smoothing Tolerance",
            name="densify_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

       # generalize_tolerance parameter
        generalize_tolerance = arcpy.Parameter(
            displayName="Generalize After Smoothing Tolerance",
            name="generalize_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,smoothness,tension,densify_tolerance,generalize_tolerance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        iSm = parameters[2].valueAsText
        iFr = parameters[3].valueAsText
        denT = parameters[4].valueAsText
        if not denT:
             denT = ""
        genT = parameters[5].valueAsText
        if not genT:
             genT = ""
                     
        etFunction = "SmoothPolygonsTSpline"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,iSm,iFr,denT,genT],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SmoothPolygonsBezier(object):
    def __init__(self):
        self.label       = "Smooth Polygons Bezier"
        self.description = "Smoothes the features of a polygon layer using Bezier algorithm."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # smoothness parameter
        smoothness = arcpy.Parameter(
            displayName="Smoothness (2..20)",
            name="smoothness",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
        smoothness.filter.type = 'Range'
        smoothness.filter.list = [2,20]
        smoothness.value = 3

       # densify_tolerance parameter
        densify_tolerance = arcpy.Parameter(
            displayName="Densify Before Smoothing Tolerance",
            name="densify_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

       # generalize_tolerance parameter
        generalize_tolerance = arcpy.Parameter(
            displayName="Generalize After Smoothing Tolerance",
            name="generalize_tolerance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
                    
        parameters = [in_dataset, out_dataset,smoothness,densify_tolerance,generalize_tolerance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        iSm = parameters[2].valueAsText
        denT = parameters[3].valueAsText
        if not denT:
             denT = ""
        genT = parameters[4].valueAsText
        if not genT:
             genT = ""
                     
        etFunction = "SmoothPolygonsBezier"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,iSm,denT,genT],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolygonAdjacency(object):
    def __init__(self):
        self.label       = "PolygonAdjacency"
        self.description = "Determines for each polygon of the dataset the adjacent polygons and stores the result in the attribute table as a comma delimited string."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_Adj","ET_Count","ET_ID"]
        fieldTypes = ["String","LONG","LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # link_field
        link_field = arcpy.Parameter(
            displayName="Link Field",
            name="link_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        link_field.parameterDependencies = [in_dataset.name]
        link_field.filter.list = ["Double", "Float", "Short", "Long", "String","Text","Integer"]
                           
        parameters = [in_dataset, out_dataset,link_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
          
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sLink = parameters[2].valueAsText
        if not sLink:
            sLink = ""
                             
        etFunction = "PolygonAdjacency"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sLink],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PolygonsToPolylinesAdvanced(object):
    def __init__(self):
        self.label       = "PolygonsToPolylinesAdvanced"
        self.description = "Converts the polygon boundaries to polylines. Removes the duplicate boundaries. For each polyline the left and right polygon attributes are added. Optionally the labels of the polygons are exported as points. The point attribute table contains all original attributes."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Left","ET_Right"]
        fieldTypes = ["LONG","String","String"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

       # fuzzy_tolerance parameter
        fuzzy_tolerance = arcpy.Parameter(
            displayName="Fuzzy Tolerance",
            name="fuzzy_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit
        unit = arcpy.Parameter(
            displayName="Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # clean_dataset parameter
        clean_dataset = arcpy.Parameter(
            displayName="Clean Dataset",
            name="clean_dataset",
            datatype="DEFeatureClass",
            parameterType="Optional",
            direction="Output")
        # Copy definition from source
        clean_dataset.parameterDependencies = [in_dataset.name]
        clean_dataset.schema.clone = True
        clean_dataset.schema.fieldsRule = "All"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        clean_dataset.schema.additionalFields = addFields

        # label_dataset parameter
        label_dataset = arcpy.Parameter(
            displayName="Label Dataset",
            name="label_dataset",
            datatype="DEFeatureClass",
            parameterType="Optional",
            direction="Output")
        # Copy definition from source
        label_dataset.parameterDependencies = [in_dataset.name]
        label_dataset.schema.clone = True
        label_dataset.schema.fieldsRule = "All"
        label_dataset.schema.geometryTypeRule = "AsSpecified"
        label_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        label_dataset.schema.additionalFields = addFields

        # link_field
        link_field = arcpy.Parameter(
            displayName="Link Field",
            name="link_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        link_field.parameterDependencies = [in_dataset.name]
        link_field.filter.list = ["Double", "Float", "Short", "Long", "String","Text","Integer"]
            
        parameters = [in_dataset, out_dataset,fuzzy_tolerance,unit, clean_dataset,label_dataset,link_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
        global inputVal
        if parameters[0].altered:
            inDataset  = parameters[0].valueAsText
            if not inDataset == inputVal:
                 try:
                      inputVal = inDataset
                      ext = arcpy.Describe(parameters[0].value).extent
                      w = abs(ext.XMax - ext.XMin)
                      h = abs(ext.YMax - ext.YMin)
                      parameters[2].value =  "{0:.8f}".format((w + h) / 2000000)
                 except:
                      parameters[2].value = "0"
        else:
            inputVal = ""
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        cleanDataset = parameters[4].valueAsText
        if not cleanDataset:
             cleanDataset = ""
        
        labelDataset = parameters[5].valueAsText
        if not labelDataset:
             labelDataset = ""
        
        linkField = parameters[6].valueAsText
        if not linkField:
             linkField = ""
       
        etFunction = "PolygonsToPolylinesAdvanced"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,cleanDataset,labelDataset,linkField],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PartitionPolygonsWithPolylines(object):
    def __init__(self):
        self.label       = "PartitionPolygonsWithPolylines"
        self.description = "Partitions (splits) a polygon dataset with the polylines of a polyline dataset."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # split_dataset parameter
        split_dataset = arcpy.Parameter(
            displayName="Split Dataset",
            name="split_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        split_dataset.filter.list = ["Polyline"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
                         
        parameters = [in_dataset,split_dataset,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                   
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
                                      
        etFunction = "PartitionPolygonsWithPolylines"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SnapPolygons(object):
    def __init__(self):
        self.label       = "Snap Polygons"
        self.description = "Snaps the features of a polygon layer to another layer (Point, Polyline, Multipoint or Polygon)."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Reference Features parameter
        reference_dataset = arcpy.Parameter(
            displayName="Reference Dataset",
            name="reference_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        reference_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # unit
        unit = arcpy.Parameter(
            displayName="Search Tolerance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
    
        # snap_what parameter
        snap_what = arcpy.Parameter(
            displayName="Snap What",
            name="snap_what",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        snap_what.filter.type = "ValueList"
        snap_what.filter.list = ["Vertex", "Edge","All"]
        snap_what.value = "All"

        # snap_to_what parameter
        snap_to_what = arcpy.Parameter(
            displayName="Snap To What",
            name="snap_to_what",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        snap_to_what.filter.type = "ValueList"
        snap_to_what.filter.list = ["Vertex", "All"]
        snap_to_what.value = "All"

        # snap_to_z
        snap_to_z = arcpy.Parameter(
            displayName="Snap To Z",
            name="snap_to_z",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        snap_to_z.value = "False"
         
        parameters = [in_dataset,reference_dataset, out_dataset,search_tolerance,unit,snap_what,snap_to_what,snap_to_z]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[4].value =  inUnit 
            except:
                 parameters[4].value = ""
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        refDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        sWhat = parameters[5].valueAsText
        sToWhat = parameters[6].valueAsText
        bZ = parameters[7].valueAsText
                              
        etFunction = "SnapPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,refDataset,outDataset,dTol,sWhat,sToWhat,bZ],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class Eliminate(object):
    def __init__(self):
        self.label       = "Eliminate"
        self.description = "Snaps the features of a polygon layer to another layer (Point, Polyline, Multipoint or Polygon)."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # elimination_method parameter
        elimination_method = arcpy.Parameter(
            displayName="Elimination Mathod",
            name="elimination_method",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        elimination_method.filter.type = "ValueList"
        elimination_method.filter.list = ["Largest", "Longest","JoinField"]
        elimination_method.value = "Longest"

        # select_expression parameter
        select_expression = arcpy.Parameter(
            displayName="Select Expression",
            name="select_expression",
            datatype="GPSQLExpression",
            parameterType="Required",
            direction="Input")
        select_expression.parameterDependencies = [in_dataset.name]

       # join_field
        join_field = arcpy.Parameter(
            displayName="Join Field",
            name="join_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        join_field.parameterDependencies = [in_dataset.name]
        join_field.filter.list = ["Short", "Long", "String","Text","Integer"]
         
        parameters = [in_dataset,out_dataset,elimination_method,select_expression,join_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[2].valueAsText == "Largest" or parameters[2].valueAsText == "Longest":
            parameters[4].enabled = "False"
        else:
            parameters[4].enabled = "True"
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sElimMethod = parameters[2].valueAsText
        sExpression = parameters[3].valueAsText
        sJoinField = parameters[3].valueAsText
        if not sJoinField:
             sJoinField=""
                                  
        etFunction = "Eliminate"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,sElimMethod,sExpression,sJoinField],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class BuildThiessen(object):
    def __init__(self):
        self.label       = "Build Thiessen"
        self.description = "Builds Thiessen Polygons from a feature layer."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # buffer_distance parameter 2
        buffer_distance = arcpy.Parameter(
            displayName="Buffer Distance",
            name="buffer_distance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        # unit 3
        unit = arcpy.Parameter(
            displayName="Distance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        parameters = [in_dataset, out_dataset,buffer_distance,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        if not dTol:
             dTol = "0"     
        etFunction = "BuildThiessen"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CreateConcaveHull(object):
    def __init__(self):
        self.label       = "Concave Hull"
        self.description = "Creates concave hull polygon for the input points dataset based on distance threshold."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # distance_threshold parameter 2
        distance_threshold = arcpy.Parameter(
            displayName="Distance Threshold",
            name="distance_threshold",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit 3
        unit = arcpy.Parameter(
            displayName="Distance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        parameters = [in_dataset, out_dataset,distance_threshold,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        if not dTol:
             dTol = "0"     
        etFunction = "CreateConcaveHull"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ConvexHull(object):
    def __init__(self):
        self.label       = "Convex Hull"
        self.description = "Builds the Convex Hull of the features of a dataset."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        
        parameters = [in_dataset, out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
               
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
          
        etFunction = "ConvexHull"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class FindClosestPoint(object):
    def __init__(self):
        self.label       = "Find Closest Point"
        self.description = "Assigns for each point from a point feature class the ID of it closest neighbor and the distance to it."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_Closest","ET_Distance"]
        fieldTypes = ["LONG","LONG","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # cutoff_distance parameter 2
        cutoff_distance = arcpy.Parameter(
            displayName="Cut-Off Distance",
            name="cutoff_distance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit 3
        unit = arcpy.Parameter(
            displayName="Distance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        parameters = [in_dataset, out_dataset,cutoff_distance,unit]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        if not dTol:
             dTol = "0"     
        etFunction = "FindClosestPoint"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ConnectToClosestPoint(object):
    def __init__(self):
        self.label       = "Connect To Closest Point"
        self.description = "Connects each point from a point feature class to its closest neighbor."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","ET_From","ET_To","ET_Dist"]
        fieldTypes = ["LONG","LONG","LONG","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # cutoff_distance parameter 2
        cutoff_distance = arcpy.Parameter(
            displayName="Cut-Off Distance",
            name="cutoff_distance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit 3
        unit = arcpy.Parameter(
            displayName="Distance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # add_duplicates
        add_duplicates = arcpy.Parameter(
            displayName="Add Duplicates",
            name="add_duplicates",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        add_duplicates.value = "False"

        parameters = [in_dataset, out_dataset,cutoff_distance,unit,add_duplicates]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        if not dTol:
             dTol = "0"
        bDup =  parameters[4].valueAsText    
        etFunction = "ConnectToClosestPoint"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,bDup],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ConnectUnstructuredPoints(object):
    def __init__(self):
        self.label       = "Connect Unstructured Points"
        self.description = "Connects points representing linear features to create network. The input points do not need to have assigned IDs or order."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # cutoff_distance parameter 2
        cutoff_distance = arcpy.Parameter(
            displayName="Cut-Off Distance",
            name="cutoff_distance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit 3
        unit = arcpy.Parameter(
            displayName="Distance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # avoid_loops
        avoid_loops = arcpy.Parameter(
            displayName="Avoid Loops",
            name="avoid_loops",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        avoid_loops.value = "False"

        parameters = [in_dataset, out_dataset,cutoff_distance,unit,avoid_loops]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        if not dTol:
             dTol = "0"
        bLoops =  parameters[4].valueAsText  
  
        etFunction = "ConnectUnstructuredPoints"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,bLoops],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsToClusterPolygonsS(object):
    def __init__(self):
        self.label       = "Points To Cluster Polygons S"
        self.description = "Creates cluster polygons for the input point dataset based on cluster distance. Suitable for creating elongated clusters."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # cluster_tolerance parameter 2
        cluster_tolerance = arcpy.Parameter(
            displayName="cluster_tolerance",
            name="cluster_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit 3
        unit = arcpy.Parameter(
            displayName="Distance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # fill_holes
        fill_holes = arcpy.Parameter(
            displayName="Fill Holes",
            name="fill_holes",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        fill_holes.value = "False"

        parameters = [in_dataset, out_dataset,cluster_tolerance,unit,fill_holes]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        if not dTol:
             dTol = "0"
        bHoles =  parameters[4].valueAsText  
  
        etFunction = "PointsToClusterPolygonsS"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,bHoles],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class PointsToClusterPolygonsC(object):
    def __init__(self):
        self.label       = "Points To Cluster Polygons C"
        self.description = "Creates cluster polygons for the input point dataset based on cluster distance. First the centers of the clusters are defined and then the points belonging to each cluster are grouped and represented as polygons."
        self.category = "Spatial Relations"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # cluster_tolerance parameter 2
        cluster_tolerance = arcpy.Parameter(
            displayName="cluster_tolerance",
            name="cluster_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")

        # unit 3
        unit = arcpy.Parameter(
            displayName="Distance Units: ",
            name="unit",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")

        # polygon_type parameter
        polygon_type = arcpy.Parameter(
            displayName="Polygon Type",
            name="polygon_type",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        polygon_type.filter.type = "ValueList"
        polygon_type.filter.list = ["Convex", "ConcaveC","ConcaveA"]
        polygon_type.value = "Convex"

        parameters = [in_dataset, out_dataset,cluster_tolerance,unit,polygon_type]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[0].altered:
            try:
                 inSR  = arcpy.Describe(parameters[0].value).spatialReference
                 if inSR.name == "Unknown":
                     inUnit = "Unknown"
                 if inSR.type == "Projected":
                     inUnit = inSR.linearUnitName
                 else:
                     inUnit = inSR.GCS.angularUnitName
                 parameters[3].value =  inUnit   
            except:
                 parameters[3].value = ""
       
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        dTol = parameters[2].valueAsText
        if not dTol:
             dTol = "0"
        sType =  parameters[4].valueAsText  
  
        etFunction = "PointsToClusterPolygonsC"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,dTol,sType],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class FeaturesToConvexPolygons(object):
    def __init__(self):
        self.label       = "Features To Convex Polygons"
        self.description = "Creates a convex polygon from each feature in the input feature class. Attributes of the original features are transfered to the convex polygons."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline","Polygon","Multipoint"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        
        parameters = [in_dataset, out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
               
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
          
        etFunction = "FeaturesToConvexPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class CogoInverse(object):
    def __init__(self):
        self.label       = "Cogo Inverse"
        self.description = "Converts a polyline or a polygon data set to a shapefile containing only single segmented polylines. For each segment the COGO attributes are calculated and added to the resulting attribute table."
        self.category = "Miscellaneous"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline","Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID","Direction","Distance"]
        fieldTypes = ["LONG","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields

        # add_start_end_coords 2
        add_start_end_coords = arcpy.Parameter(
            displayName="Add Start/End Coordinates",
            name="add_start_end_coords",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        add_start_end_coords.value = "False"

        # add_ZM_attributes 3
        add_ZM_attributes = arcpy.Parameter(
            displayName="Add ZM Attributes",
            name="add_ZM_attributes",
            datatype="GPBoolean",
            parameterType="Required",
            direction="Input")
        add_ZM_attributes.value = "False"

        # direction_type parameter 4
        direction_type = arcpy.Parameter(
            displayName="Direction Type",
            name="direction_type",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        direction_type.filter.type = "ValueList"
        direction_type.filter.list = ["NorthAzimuth","SouthAzimuth","Polar","QuadrantBearing"]
        direction_type.value = "Polar"

        # direction_units parameter 5
        direction_units = arcpy.Parameter(
            displayName="Direction Units",
            name="direction_units",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        direction_units.filter.type = "ValueList"
        direction_units.filter.list = ["DecimalDegrees","DegreesMinutesSeconds","Radians","Gradians","Gons"]
        direction_units.value = "DecimalDegrees"

         #linear_precision parameter 6
        linear_precision = arcpy.Parameter(
            displayName="Linear precision - places after the decimal point",
            name="linear_precision",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")
        linear_precision.filter.type = 'Range'
        linear_precision.filter.list = [0,10]
        linear_precision.value = 4

         #angular_precision parameter 6
        angular_precision = arcpy.Parameter(
            displayName="Angular precision - places after the decimal point",
            name="angular_precision",
            datatype="GPLong",
            parameterType="Optional",
            direction="Input")
        angular_precision.filter.type = 'Range'
        angular_precision.filter.list = [0,10]
        angular_precision.value = 4
                                  
        parameters = [in_dataset,out_dataset,add_start_end_coords,add_ZM_attributes,direction_type,direction_units,linear_precision,angular_precision]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        if parameters[2].value:
             fieldNames = ["ET_ID","Direction","Distance","XStart","YStart","XEnd","YEnd"]
             fieldTypes = ["LONG","Double","Double","Double","Double","Double","Double"]
        else:
             fieldNames = ["ET_ID","Direction","Distance"]
             fieldTypes = ["LONG","Double","Double"]
        if parameters[3].value:
             if parameters[0].altered:
                  if arcpy.Describe(parameters[0].value).hasZ:
                       fieldNames.extend(["ZStart","ZEnd","Slope"])
                       fieldTypes.extend(["Double","Double","Double"])
                  if arcpy.Describe(parameters[0].value).hasM:
                       fieldNames.extend(["MStart","MEnd"])
                       fieldTypes.extend(["Double","Double"])
        addFields = []
        for fieldInd, fieldName in enumerate(fieldNames):
              fieldType = fieldTypes[fieldInd]
              newField = arcpy.Field()
              newField.name = fieldName
              newField.type = fieldType
              addFields.append(newField) 
        parameters[1].schema.additionalFields = addFields

        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        bCoords  = parameters[2].valueAsText
        bZ  = parameters[3].valueAsText
        dirType = parameters[4].valueAsText
        dirUnits = parameters[5].valueAsText
        linP = parameters[6].valueAsText
        if not linP:
             linP = "4"
        angP = parameters[7].valueAsText
        if not angP:
             angP = "4"

        etFunction = "CogoInverse"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,bCoords,bZ,dirType,dirUnits,linP,angP],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ImportFromMapInfo(object):
    def __init__(self):
        self.label       = "Import From MapInfo"
        self.description = "Converts a MapInfo MID or TAB files to ShapeFile or File GDB feature classes."
        self.category = "Import-Export"
        
    def getParameterInfo(self):
        
        #input_mapinfo_file
        input_mapinfo_file = arcpy.Parameter(
            displayName="Input MapInfo File",
            name="input_mapinfo_file",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        input_mapinfo_file.filter.list = ["mif","tab"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        
        parameters = [input_mapinfo_file,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                  
        return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inMI  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
                                                 
        etFunction = "ImportFromMapInfo"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inMI,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class ImportFromDXF(object):
    def __init__(self):
        self.label       = "Import From DXF"
        self.description = "Converts Autodesk DXF files to ShapeFile or File GDB feature classes."
        self.category = "Import-Export"
        
    def getParameterInfo(self):
        
        #input_dxf_file
        input_dxf_file = arcpy.Parameter(
            displayName="Input DXF File",
            name="input_dxf_file",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        input_dxf_file.filter.list = ["dxf","DXF"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        
        parameters = [input_dxf_file,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                  
        return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inMI  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
                                                 
        etFunction = "ImportFromDXF"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inMI,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class SelectAndExport(object):
    def __init__(self):
        self.label       = "Select And Export"
        self.description = "Selects the features from the input layer based on a SQL expressions and exports them to a new dataset."
        self.category = "Basic"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
         # select_expression parameter
        select_expression = arcpy.Parameter(
            displayName="Select Expression",
            name="select_expression",
            datatype="GPSQLExpression",
            parameterType="Required",
            direction="Input")
        select_expression.parameterDependencies = [in_dataset.name]
                         
        parameters = [in_dataset, out_dataset,select_expression]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                   
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        expression  = parameters[2].valueAsText
                                      
        etFunction = "SelectAndExport"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,expression],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
class IntersectPolygons(object):
    def __init__(self):
        self.label       = "IntersectPolygons"
        self.description = "Intersectss a polygon feature layer with the features of another polygon feature layer."
        self.category = "Overlay"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # intersect_dataset parameter
        intersect_dataset = arcpy.Parameter(
            displayName="Intersect Dataset",
            name="intersect_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        intersect_dataset.filter.list = ["Polygon"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # add_all_attributes
        add_all_attributes = arcpy.Parameter(
            displayName="Add all attributes",
            name="add_all_attributes",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        add_all_attributes.value = "False"
        
        # force_topology
        force_topology = arcpy.Parameter(
            displayName="Force Topology",
            name="force_topology",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        force_topology.value = "True"
                         
        parameters = [in_dataset,intersect_dataset,out_dataset,add_all_attributes,force_topology]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                   
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                       
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        mergeDataset  = arcpy.Describe(parameters[1].value).catalogPath
        outDataset  = parameters[2].valueAsText
        bAdd  = parameters[3].valueAsText
        bForce  = parameters[4].valueAsText
                                      
        etFunction = "IntersectPolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,mergeDataset,outDataset,bAdd,bForce],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class ReleaseLicense(object):
    def __init__(self):
        self.label       = "Release License"
        self.description = "Releases a concurrent license. "
        self.category = "System"

    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = []
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Derived",
            direction="Output")

        parameters = [in_dataset, out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        etFunction = "ReleaseLicense"
        
        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class ImportFromGeoJson(object):
    def __init__(self):
        self.label       = "Import From GeoJson"
        self.description = "Converts a GeoJson .json or .geojson files to ShapeFile or File GDB feature classes."
        self.category = "Import-Export"
        
    def getParameterInfo(self):
        
        #input_geojson_file
        input_geojson_file = arcpy.Parameter(
            displayName="Input GeoJson File",
            name="input_geojson_file",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        input_geojson_file.filter.list = ["json","geojson"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        
        # geometry_type parameter
        geometry_type = arcpy.Parameter(
            displayName="Geometry Type",
            name="geometry_type",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        geometry_type.filter.type = "ValueList"
        geometry_type.filter.list = ["Polygon", "Polyline","Point", "All"]
        geometry_type.value = "All"
        
        parameters = [input_geojson_file,out_dataset,geometry_type]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                  
        return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inGJ  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sType  = parameters[2].valueAsText
        if not sType:
             sType = "All"
                                                 
        etFunction = "ImportFromGeoJson"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inGJ,outDataset,sType],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class ImportFromOSM(object):
    def __init__(self):
        self.label       = "Import From Open Street Map"
        self.description = "Converts an Open Street Map .osm or .pbf files to ShapeFile or File GDB feature classes."
        self.category = "Import-Export"
        
    def getParameterInfo(self):
        
        #input_OSM_file
        input_OSM_file = arcpy.Parameter(
            displayName="Input Open Street Map File",
            name="input_OSM_file",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        input_OSM_file.filter.list = ["osm","pbf"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        
        # geometry_type parameter
        geometry_type = arcpy.Parameter(
            displayName="Geometry Type",
            name="geometry_type",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        geometry_type.filter.type = "ValueList"
        geometry_type.filter.list = ["Polygon", "Polyline","Point", "All"]
        geometry_type.value = "All"
        
        parameters = [input_OSM_file,out_dataset,geometry_type]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                  
        return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inOSM  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        sType  = parameters[2].valueAsText
        if not sType:
             sType = "All"
                                                 
        etFunction = "ImportFromOSM"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inOSM,outDataset,sType],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class ExportToGeoJson(object):
    def __init__(self):
        self.label       = "Export to GeoJson"
        self.description = "Exports a shapefile of FileGDB layer to a GeoJson file."
        self.category = "Import-Export"
        
    def getParameterInfo(self):
        # Input Features parameter 0
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Point","Polygon","Polyline"]
            
        # Output GeoJson file 1
        out_GeoJson_file = arcpy.Parameter(
            displayName="Output GeoJson file",
            name="out_file",
            datatype="DEFile",
            parameterType="Required",
            direction="Output")

                  
        parameters = [in_dataset,out_GeoJson_file]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                              
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                      
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outJson  = parameters[1].valueAsText
       
                                     
        etFunction = "ExportToGeoJson"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outJson],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return   
class ExportToGeoPackage(object):
    def __init__(self):
        self.label       = "Export To GeoPackage"
        self.description = "Exports Shapefiles and File GDB layers to GeoPackage format."
        self.category = "Import-Export"
        
    def getParameterInfo(self):

        # in_datasets parameter
        in_datasets = arcpy.Parameter(
            displayName="Datasets to Export",
            name="in_datasets",
            datatype="GPValueTable",
            parameterType="Required",
            direction="Input")
        in_datasets.columns = [["GPFeatureLayer","Datasets to Export"]]
        in_datasets.filters[0].list = []
      
        # Output Features parameter 1
        out_file = arcpy.Parameter(
            displayName="Output GeoPackage file",
            name="out_file",
            datatype="DEFile",
            parameterType="Required",
            direction="Output")

        parameters = [in_datasets,out_file]
        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                                
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        sIn = parameters[0].valueAsText
        inL = ""
        if sIn:
             value_table = arcpy.ValueTable(1)
             value_table.loadFromString(sIn)
             for i in range(0, value_table.rowCount):
                  f1 = value_table.getValue(i,0)
                  inDataset  = arcpy.Describe(f1).catalogPath
                  inL = inL+inDataset+";"
        
        outFile  = parameters[1].valueAsText
                                      
        etFunction = "ExportToGeoPackage"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inL,outFile],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
class ImportFromGeoPackage(object):
    def __init__(self):
        self.label       = "Import From GeoPackage"
        self.description = "Converts the contents of a GeoPackage file to ShapeFiles or File GDB feature classes."
        self.category = "Import-Export"
        
    def getParameterInfo(self):
        
        #input_geopackage_file
        input_geopackage_file = arcpy.Parameter(
            displayName="Geopackage File",
            name="input_geopackage_file",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        input_geopackage_file.filter.list = ["gpkg"]
      
        # out_workspace parameter
        out_workspace = arcpy.Parameter(
            displayName="Output Workspace",
            name="out_workspace",
            datatype="DEWorkspace",
            parameterType="Required",
            direction="Input")
        
        parameters = [input_geopackage_file,out_workspace]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                  
        return
         
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inGPKG  = arcpy.Describe(parameters[0].value).catalogPath
        out_workspace  = parameters[1].valueAsText
                                                 
        etFunction = "ImportFromGeoPackage"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inGPKG,out_workspace],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
class TriangulatePolygons(object):
    def __init__(self):
        self.label       = "Triangulate Polygons"
        self.description = "Converts each polygon of the input layer to a set of triangles."
        self.category = "Polygons"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polygon"]

        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
                                 
        parameters = [in_dataset,out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        
        etFunction = "TriangulatePolygons"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class BuildBidirectionalNetwork(object):
    def __init__(self):
        self.label       = "Build Bidirectional Network"
        self.description = "Creates a Biderectional network from a polyline layer."
        self.category = "Network"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Network parameter 1
        out_network = arcpy.Parameter(
            displayName="Output Network .ETN file",
            name="out_network",
            datatype="DEFile",
            parameterType="Required",
            direction="Output")

        # Direction_field
        direction_field = arcpy.Parameter(
            displayName="Direction field",
            name="direction_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        direction_field.parameterDependencies = [in_dataset.name]
        direction_field.filter.list = ["Text"]

        # from_level_field
        from_level_field = arcpy.Parameter(
            displayName="From Level Field",
            name="from_level_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        from_level_field.parameterDependencies = [in_dataset.name]
        from_level_field.filter.list = ["Short", "Long","Integer"]
        
        # to_level_field
        to_level_field = arcpy.Parameter(
            displayName="To Level Field",
            name="to_level_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        to_level_field.parameterDependencies = [in_dataset.name]
        to_level_field.filter.list = ["Short", "Long","Integer"]

        # from_to_cost_field
        from_to_cost_field = arcpy.Parameter(
            displayName="From-To Cost Field",
            name="from_to_cost_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        from_to_cost_field.parameterDependencies = [in_dataset.name]
        from_to_cost_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]
        
         # to_from_cost_field
        to_from_cost_field = arcpy.Parameter(
            displayName="To-From Cost Field",
            name="to_from_cost_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        to_from_cost_field.parameterDependencies = [in_dataset.name]
        to_from_cost_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]

        parameters = [in_dataset, out_network, direction_field,from_level_field, to_level_field, from_to_cost_field,to_from_cost_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outNetwork  = parameters[1].valueAsText
        dirField  = parameters[2].valueAsText
        fromLevelField  = parameters[3].valueAsText
        toLevelField  = parameters[4].valueAsText
        fromCostField  = parameters[5].valueAsText
        toCostField  = parameters[6].valueAsText
        if not dirField:
             dirField = ""
        if not fromLevelField:
             fromLevelField = ""
        if not toLevelField:
             toLevelField = ""
        if not fromCostField:
             fromCostField = ""
        if not toCostField:
             toCostField = ""
        
        etFunction = "BuildBidirectionalNetwork"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outNetwork,dirField,fromLevelField,toLevelField,fromCostField,toCostField],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class BuildSingleDirectionalNetwork(object):
    def __init__(self):
        self.label       = "Build Single Directional Network"
        self.description = "Creates a single directional network from a polyline layer."
        self.category = "Network"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
        
        # Output Network parameter 1
        out_network = arcpy.Parameter(
            displayName="Output Network .ETN file",
            name="out_network",
            datatype="DEFile",
            parameterType="Required",
            direction="Output")

        # Direction_field
        direction_field = arcpy.Parameter(
            displayName="Direction field",
            name="direction_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        direction_field.parameterDependencies = [in_dataset.name]
        direction_field.filter.list = ["Text"]

        # from_level_field
        from_level_field = arcpy.Parameter(
            displayName="From Level Field",
            name="from_level_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        from_level_field.parameterDependencies = [in_dataset.name]
        from_level_field.filter.list = ["Short", "Long","Integer"]
        
        # to_level_field
        to_level_field = arcpy.Parameter(
            displayName="To Level Field",
            name="to_level_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        to_level_field.parameterDependencies = [in_dataset.name]
        to_level_field.filter.list = ["Short", "Long","Integer"]

        # cost_field
        cost_field = arcpy.Parameter(
            displayName="Cost Field",
            name="cost_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        cost_field.parameterDependencies = [in_dataset.name]
        cost_field.filter.list = ["Geometry", "Double", "Float", "Short", "Long","Integer"]

        parameters = [in_dataset, out_network, direction_field,from_level_field, to_level_field, cost_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
             
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outNetwork  = parameters[1].valueAsText
        dirField  = parameters[2].valueAsText
        fromLevelField  = parameters[3].valueAsText
        toLevelField  = parameters[4].valueAsText
        costField  = parameters[5].valueAsText
        if not dirField:
             dirField = ""
        if not fromLevelField:
             fromLevelField = ""
        if not toLevelField:
             toLevelField = ""
        if not costField:
             costField = ""
                
        etFunction = "BuildSingleDirectionalNetwork"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outNetwork,dirField,fromLevelField,toLevelField,costField],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return    
class ShortestPath(object):
    def __init__(self):
        self.label       = "Shortest Path"
        self.description = "Produces a polyline layer representing the shortest/quickest route between the input points."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # Input Points parameter
        in_points = arcpy.Parameter(
            displayName="Input Point Layer",
            name="in_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_points.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_points.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_From","ET_To","ET_Dist","ET_Cost"]
        fieldTypes = ["LONG","LONG","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # Input Break Points parameter
        in_break_points = arcpy.Parameter(
            displayName="Input Barrier Points Layer",
            name="in_break_points",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        in_break_points.filter.list = ["Point"]
        
        # break_directions_field
        break_directions_field = arcpy.Parameter(
            displayName="Barrier Directions field",
            name="break_directions_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        break_directions_field.parameterDependencies = [in_break_points.name]
        break_directions_field.filter.list = ["Text"]
            
        # sort_field
        sort_field = arcpy.Parameter(
            displayName="Sort field",
            name="sort_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        sort_field.parameterDependencies = [in_points.name]
        sort_field.filter.list = ["Text","Double", "Float", "Short", "Long","Integer"]
        
        # sort_direction
        sort_direction = arcpy.Parameter(
            displayName="Convert Option",
            name="sort_direction",
            datatype="GPString",
            parameterType="Optional",
            direction="Input")
        sort_direction.filter.type = "ValueList"
        sort_direction.filter.list = ["ASC", "DESC"]

        parameters = [network_to_use, in_points, out_dataset, search_tolerance,in_break_points,break_directions_field, sort_field, sort_direction]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        pointDataset = arcpy.Describe(parameters[1].value).catalogPath
        outDataset = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        breakPointDataset = parameters[4].valueAsText
        if not breakPointDataset:
             breakPointDataset = ""
        else:
             breakPointDataset  = arcpy.Describe(parameters[4].value).catalogPath
             breakDirField = parameters[5].valueAsText
        breakDirField = parameters[5].valueAsText

        if not breakDirField:
             breakDirField = ""
        sortField = parameters[6].valueAsText
        sOption = parameters[7].valueAsText
        if not sortField:
             sortField = ""
        if not sOption:
             sOption = "ASC"

        etFunction = "ShortestPath"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,pointDataset,outDataset,dTol,breakPointDataset,breakDirField,sortField,sOption],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return   
class TravelingSalesman(object):
    def __init__(self):
        self.label       = "Traveling Salesman"
        self.description = "Produces a polyline layer representing the optimal route from Origin to all Destinations."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # Origin Points parameter
        origin_points = arcpy.Parameter(
            displayName="Origin Point Layer (first point is used only)",
            name="origin_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        origin_points.filter.list = ["Point"]
        
         # Destination Points parameter
        destinations_points = arcpy.Parameter(
            displayName="Destinations Point Layer",
            name="destinations_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        destinations_points.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [origin_points.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_From","ET_To","ET_Dist","ET_Cost"]
        fieldTypes = ["LONG","LONG","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
            
        # Input Break Points parameter
        in_break_points = arcpy.Parameter(
            displayName="Input Barrier Points Layer",
            name="in_break_points",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        in_break_points.filter.list = ["Point"]
        
        # break_directions_field
        break_directions_field = arcpy.Parameter(
            displayName="Barrier Directions field",
            name="break_directions_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        break_directions_field.parameterDependencies = [in_break_points.name]
        break_directions_field.filter.list = ["Text"]
            
        # straight lines result
        straight_lines_result = arcpy.Parameter(
            displayName="Result as straight lines",
            name="straight_lines_result",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        straight_lines_result.value = "False"
        
        # return to origin
        return_to_origin = arcpy.Parameter(
            displayName="Return to Origin",
            name="return_to_origin",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        return_to_origin.value = "True"

        parameters = [network_to_use, origin_points,destinations_points,out_dataset, search_tolerance,in_break_points,break_directions_field, straight_lines_result, return_to_origin]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        originDataset = arcpy.Describe(parameters[1].value).catalogPath
        destinationsDataset = arcpy.Describe(parameters[2].value).catalogPath
        outDataset = parameters[3].valueAsText
        dTol = parameters[4].valueAsText
        breakPointDataset = parameters[5].valueAsText
        if not breakPointDataset:
             breakPointDataset = ""
        else:
             breakPointDataset  = arcpy.Describe(parameters[5].value).catalogPath
             breakDirField = parameters[5].valueAsText
        breakDirField = parameters[6].valueAsText

        if not breakDirField:
             breakDirField = ""
        bStraight = parameters[7].valueAsText
        bReturn = parameters[8].valueAsText

        etFunction = "TravelingSalesman"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,originDataset,destinationsDataset,outDataset,dTol,breakPointDataset,breakDirField,bStraight,bReturn],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
            
class ODMatrix(object):
    def __init__(self):
        self.label       = "Origin Destination Matrix"
        self.description = "Produces a polyline layer representing the OD Matrix between 2 sets of points."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # Origin Points parameter
        origin_points = arcpy.Parameter(
            displayName="Origin Points Layer",
            name="origin_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        origin_points.filter.list = ["Point"]
        
         # Destination Points parameter
        destinations_points = arcpy.Parameter(
            displayName="Destinations Point Layer",
            name="destinations_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        destinations_points.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [origin_points.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_From","ET_To","ET_Dist","ET_Cost"]
        fieldTypes = ["LONG","LONG","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
            
        # Input Break Points parameter
        in_break_points = arcpy.Parameter(
            displayName="Input Barrier Points Layer",
            name="in_break_points",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        in_break_points.filter.list = ["Point"]
        
        # break_directions_field
        break_directions_field = arcpy.Parameter(
            displayName="Barrier Directions field",
            name="break_directions_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        break_directions_field.parameterDependencies = [in_break_points.name]
        break_directions_field.filter.list = ["Text"]
            
        # straight lines result
        straight_lines_result = arcpy.Parameter(
            displayName="Result as straight lines",
            name="straight_lines_result",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        straight_lines_result.value = "False"
        
        # cutoff_distanance parameter
        cutoff_distanance = arcpy.Parameter(
            displayName="Cutoff Distance",
            name="cutoff_distanance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        parameters = [network_to_use, origin_points,destinations_points,out_dataset, search_tolerance,in_break_points,break_directions_field, straight_lines_result, cutoff_distanance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        originDataset = arcpy.Describe(parameters[1].value).catalogPath
        destinationsDataset = arcpy.Describe(parameters[2].value).catalogPath
        outDataset = parameters[3].valueAsText
        dTol = parameters[4].valueAsText
        breakPointDataset = parameters[5].valueAsText
        if not breakPointDataset:
             breakPointDataset = ""
        else:
             breakPointDataset  = arcpy.Describe(parameters[5].value).catalogPath
             breakDirField = parameters[5].valueAsText
        breakDirField = parameters[6].valueAsText

        if not breakDirField:
             breakDirField = ""
        bStraight = parameters[7].valueAsText
        dCutOff = parameters[8].valueAsText
        if not dCutOff:
             dCutOff = "1000000000"

        etFunction = "ODMatrix"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,originDataset,destinationsDataset,outDataset,dTol,breakPointDataset,breakDirField,bStraight,dCutOff],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
           
class ClosestFacilities(object):
    def __init__(self):
        self.label       = "Closest Facilities"
        self.description = "Produces a polyline layer representing the routes from/to each customer to closest facilities."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # Origin Points parameter
        origin_points = arcpy.Parameter(
            displayName="Facilities Points Layer",
            name="origin_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        origin_points.filter.list = ["Point"]
        
         # Destination Points parameter
        destinations_points = arcpy.Parameter(
            displayName="Customers Point Layer",
            name="destinations_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        destinations_points.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [origin_points.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_From","ET_To","ET_Dist","ET_Cost"]
        fieldTypes = ["LONG","LONG","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
           
        # number_facilities parameter
        number_facilities = arcpy.Parameter(
            displayName="Number Facilities",
            name="number_facilities",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
            
        # travel to customer
        travel_to_customer = arcpy.Parameter(
            displayName="Travel TO Customer",
            name="travel_to_customer",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        travel_to_customer.value = "True"
        
        # Input Break Points parameter
        in_break_points = arcpy.Parameter(
            displayName="Input Barrier Points Layer",
            name="in_break_points",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        in_break_points.filter.list = ["Point"]
        
        # break_directions_field
        break_directions_field = arcpy.Parameter(
            displayName="Barrier Directions field",
            name="break_directions_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        break_directions_field.parameterDependencies = [in_break_points.name]
        break_directions_field.filter.list = ["Text"]

        # straight lines result
        straight_lines_result = arcpy.Parameter(
            displayName="Result as straight lines",
            name="straight_lines_result",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        straight_lines_result.value = "False"
        
        # cutoff_distanance parameter
        cutoff_distanance = arcpy.Parameter(
            displayName="Cutoff Distance",
            name="cutoff_distanance",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")

        parameters = [network_to_use, origin_points,destinations_points,out_dataset, search_tolerance,number_facilities,travel_to_customer,in_break_points,break_directions_field, straight_lines_result, cutoff_distanance]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        originDataset = arcpy.Describe(parameters[1].value).catalogPath
        destinationsDataset = arcpy.Describe(parameters[2].value).catalogPath
        outDataset = parameters[3].valueAsText
        dTol = parameters[4].valueAsText
        iNuberFac = parameters[5].valueAsText
        bTravelToCustomer = parameters[6].valueAsText
        breakPointDataset = parameters[7].valueAsText
        if not breakPointDataset:
             breakPointDataset = ""
        else:
             breakPointDataset  = arcpy.Describe(parameters[7].value).catalogPath
             breakDirField = parameters[5].valueAsText
        breakDirField = parameters[8].valueAsText

        if not breakDirField:
             breakDirField = ""
        bStraight = parameters[9].valueAsText
        dCutOff = parameters[10].valueAsText
        if not dCutOff:
             dCutOff = "1000000000"

        etFunction = "ClosestFacilities"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,originDataset,destinationsDataset,outDataset,dTol,iNuberFac,bTravelToCustomer,breakPointDataset,breakDirField,bStraight,dCutOff],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
           
class AllocateBasedOnNetwork(object):
    def __init__(self):
        self.label       = "AllocateBasedOnNetwork"
        self.description = "Allocates customers to facilities based on a Network"
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # facilities_dataset parameter
        facilities_dataset = arcpy.Parameter(
            displayName="Facilities Dataset",
            name="facilities_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        facilities_dataset.filter.list = ["Point"]

        # customers_dataset parameter
        customers_dataset = arcpy.Parameter(
            displayName="Customers Dataset",
            name="customers_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        customers_dataset.filter.list = ["Point"]
      
        # out_link_dataset parameter
        out_link_dataset = arcpy.Parameter(
            displayName="Output Link Dataset",
            name="out_link_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_link_dataset.parameterDependencies = [customers_dataset.name]
        out_link_dataset.schema.clone = True
        out_link_dataset.schema.fieldsRule = "None"
        out_link_dataset.schema.geometryTypeRule = "AsSpecified"
        out_link_dataset.schema.geometryType = "Polyline"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_Cost","Facility","Customer","FacilityID","CustomerID"]
        fieldTypes = ["Double","String","String","LONG","LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_link_dataset.schema.additionalFields = addFields

        # out_facilities_dataset parameter
        out_facilities_dataset = arcpy.Parameter(
            displayName="Output Facilities Dataset",
            name="out_facilities_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_facilities_dataset.parameterDependencies = [customers_dataset.name]
        out_facilities_dataset.schema.clone = True
        out_facilities_dataset.schema.fieldsRule = "None"
        out_facilities_dataset.schema.geometryTypeRule = "AsSpecified"
        out_facilities_dataset.schema.geometryType = "Point"
                
        # Add fields
        addFields = []
        fieldNames = ["Facility","FacilityID","Type","Num_Alloc","Max_Cost","Total_Cost"]
        fieldTypes = ["String","Long","String","LONG","Double","Double"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_facilities_dataset.schema.additionalFields = addFields

         # number_facilities parameter
        number_facilities = arcpy.Parameter(
            displayName="Number Facilities to Select",
            name="number_facilities",
            datatype="GPLong",
            parameterType="Required",
            direction="Input")
            
        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
            
        # Input Break Points parameter
        in_break_points = arcpy.Parameter(
            displayName="Input Barrier Points Layer",
            name="in_break_points",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        in_break_points.filter.list = ["Point"]
        
        # break_directions_field
        break_directions_field = arcpy.Parameter(
            displayName="Barrier Directions field",
            name="break_directions_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        break_directions_field.parameterDependencies = [in_break_points.name]
        break_directions_field.filter.list = ["Text"]

        # facilities_name_field
        facilities_name_field = arcpy.Parameter(
            displayName="Facilities Name Field",
            name="facilities_name_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        facilities_name_field.parameterDependencies = [facilities_dataset.name]
        facilities_name_field.filter.list = ["Short", "Long","Integer","String","Text"]

        # facilities_type_field
        facilities_type_field = arcpy.Parameter(
            displayName="Facilities Type Field",
            name="facilities_type_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        facilities_type_field.parameterDependencies = [facilities_dataset.name]
        facilities_type_field.filter.list = ["Short", "Long","Integer","String","Text"]

        # customers_name_field
        customers_name_field = arcpy.Parameter(
            displayName="Customers Name Field",
            name="customers_name_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        customers_name_field.parameterDependencies = [customers_dataset.name]
        customers_name_field.filter.list = ["Short", "Long","Integer","String","Text"]

        # cutoff_cost parameter
        cutoff_cost = arcpy.Parameter(
            displayName="Cutoff Distance",
            name="cutoff_cost",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
        
                        
        parameters = [network_to_use,facilities_dataset,customers_dataset,out_link_dataset,out_facilities_dataset,number_facilities,search_tolerance,in_break_points,break_directions_field,facilities_name_field,facilities_type_field,customers_name_field,cutoff_cost]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
        
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        facDataset = arcpy.Describe(parameters[1].value).catalogPath
        custDataset = arcpy.Describe(parameters[2].value).catalogPath
        outLinkDataset = parameters[3].valueAsText
        outFacDataset = parameters[4].valueAsText
        iNum = parameters[5].valueAsText
        dTol = parameters[6].valueAsText
        breakPointDataset = parameters[7].valueAsText
        if not breakPointDataset:
             breakPointDataset = ""
        else:
             breakPointDataset  = arcpy.Describe(parameters[7].value).catalogPath
             breakDirField = parameters[5].valueAsText
        breakDirField = parameters[8].valueAsText

        if not breakDirField:
             breakDirField = ""
        facN = parameters[9].valueAsText
        if not facN:
             facN = ""
        facT = parameters[10].valueAsText
        if not facT:
             facT = ""
        custN = parameters[11].valueAsText
        if not custN:
             custN = ""
        dCutOff = parameters[12].valueAsText
        if not dCutOff:
             dCutOff = "1000000000"
        

        etFunction = "AllocateBasedOnNetwork"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,facDataset,custDataset,outLinkDataset,outFacDataset,iNum,dTol,breakPointDataset,breakDirField,facN,facT,custN,dCutOff],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class PartitionNetwork(object):
    def __init__(self):
        self.label       = "Partition Network"
        self.description = "Partitions the network based on the input points. Each link of the network is assigned to the closest(least cost to reach) point."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # Input Points parameter
        in_points = arcpy.Parameter(
            displayName="Input Point Layer",
            name="in_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_points.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_points.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_Zone","ET_Dist","ET_Cost"]
        fieldTypes = ["LONG","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # Input Break Points parameter
        in_break_points = arcpy.Parameter(
            displayName="Input Barrier Points Layer",
            name="in_break_points",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        in_break_points.filter.list = ["Point"]
        
        # break_directions_field
        break_directions_field = arcpy.Parameter(
            displayName="Barrier Directions field",
            name="break_directions_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        break_directions_field.parameterDependencies = [in_break_points.name]
        break_directions_field.filter.list = ["Text"]
        
        # cutoff_cost parameter
        cutoff_cost = arcpy.Parameter(
            displayName="Cutoff Cost",
            name="cutoff_cost",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
            
        # cutoff_field
        cutoff_field = arcpy.Parameter(
            displayName="Cutoff Cost Field",
            name="cutoff_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        cutoff_field.parameterDependencies = [in_points.name]
        cutoff_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]
        
        # allow_overlaps
        allow_overlaps = arcpy.Parameter(
            displayName="Allow Overlaps",
            name="allow_overlaps",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        allow_overlaps.value = "False"

        parameters = [network_to_use, in_points, out_dataset, search_tolerance,in_break_points,break_directions_field, cutoff_cost, cutoff_field,allow_overlaps]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        pointDataset = arcpy.Describe(parameters[1].value).catalogPath
        outDataset = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        
        breakPointDataset = parameters[4].valueAsText
        if not breakPointDataset:
             breakPointDataset = ""
        else:
             breakPointDataset  = arcpy.Describe(parameters[4].value).catalogPath
        breakDirField = parameters[5].valueAsText
        
        if not breakDirField:
             breakDirField = ""
        dCut = parameters[6].valueAsText
        cutField = parameters[7].valueAsText
        bOver = parameters[8].valueAsText
        if not dCut:
             dCut = ""
        if not cutField:
             cutField = ""

        etFunction = "PartitionNetwork"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,pointDataset,outDataset,dTol,breakPointDataset,breakDirField,dCut,cutField,bOver],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class ServiceArea(object):
    def __init__(self):
        self.label       = "Service Area"
        self.description = "Produces polygons representing the Service Areas the input points."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # Input Points parameter
        in_points = arcpy.Parameter(
            displayName="Input Point Layer",
            name="in_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_points.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_points.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_Zone","TOT_Dist","TOT_Cost","MAX_Cost"]
        fieldTypes = ["LONG","DOUBLE","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # Input Break Points parameter
        in_break_points = arcpy.Parameter(
            displayName="Input Barrier Points Layer",
            name="in_break_points",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        in_break_points.filter.list = ["Point"]
        
        # break_directions_field
        break_directions_field = arcpy.Parameter(
            displayName="Barrier Directions field",
            name="break_directions_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        break_directions_field.parameterDependencies = [in_break_points.name]
        break_directions_field.filter.list = ["Text"]
        
        # cutoff_cost parameter
        cutoff_cost = arcpy.Parameter(
            displayName="Cutoff Cost",
            name="cutoff_cost",
            datatype="GPDouble",
            parameterType="Optional",
            direction="Input")
            
        # cutoff_field
        cutoff_field = arcpy.Parameter(
            displayName="Cutoff Cost Field",
            name="cutoff_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        cutoff_field.parameterDependencies = [in_points.name]
        cutoff_field.filter.list = ["Double", "Float", "Short", "Long","Integer"]
        
        # include_non_reachable_area
        include_non_reachable_area = arcpy.Parameter(
            displayName="Include non reachable area",
            name="include_non_reachable_area",
            datatype="GPBoolean",
            parameterType="Optional",
            direction="Input")
        include_non_reachable_area.value = "False"

        parameters = [network_to_use, in_points, out_dataset, search_tolerance,in_break_points,break_directions_field, cutoff_cost, cutoff_field,include_non_reachable_area]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        pointDataset = arcpy.Describe(parameters[1].value).catalogPath
        outDataset = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        
        breakPointDataset = parameters[4].valueAsText
        if not breakPointDataset:
             breakPointDataset = ""
        else:
             breakPointDataset  = arcpy.Describe(parameters[4].value).catalogPath
        breakDirField = parameters[5].valueAsText
        
        if not breakDirField:
             breakDirField = ""
        dCut = parameters[6].valueAsText
        cutField = parameters[7].valueAsText
        bNonReach = parameters[8].valueAsText
        if not dCut:
             dCut = ""
        if not cutField:
             cutField = ""

        etFunction = "ServiceArea"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,pointDataset,outDataset,dTol,breakPointDataset,breakDirField,dCut,cutField,bNonReach],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class IdentifyUnreachableLinks(object):
    def __init__(self):
        self.label       = "Identify Unreachable Links"
        self.description = "Finds the links of the Network that cannot be reached by the input points."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # Input Points parameter
        in_points = arcpy.Parameter(
            displayName="Input Point Layer",
            name="in_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_points.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_points.name]
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_Zone","ET_Dist","ET_Cost"]
        fieldTypes = ["LONG","DOUBLE","DOUBLE"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
        
        # Input Break Points parameter
        in_break_points = arcpy.Parameter(
            displayName="Input Barrier Points Layer",
            name="in_break_points",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        in_break_points.filter.list = ["Point"]
        
        # break_directions_field
        break_directions_field = arcpy.Parameter(
            displayName="Barrier Directions field",
            name="break_directions_field",
            datatype="Field",
            parameterType="Optional",
            direction="Input")
        break_directions_field.parameterDependencies = [in_break_points.name]
        break_directions_field.filter.list = ["Text"]
        
        parameters = [network_to_use, in_points, out_dataset, search_tolerance,in_break_points,break_directions_field]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        pointDataset = arcpy.Describe(parameters[1].value).catalogPath
        outDataset = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        
        breakPointDataset = parameters[4].valueAsText
        if not breakPointDataset:
             breakPointDataset = ""
        else:
             breakPointDataset  = arcpy.Describe(parameters[4].value).catalogPath
        breakDirField = parameters[5].valueAsText
        
        if not breakDirField:
             breakDirField = ""
       
        etFunction = "IdentifyUnreachableLinks"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,pointDataset,outDataset,dTol,breakPointDataset,breakDirField],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class SDNFindSinks(object):
    def __init__(self):
        self.label       = "Find Sinks on SDN"
        self.description = "Finds the Sinks (nodes with only incoming flow) on the Network."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_Level"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        parameters = [network_to_use, out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
               
        etFunction = "SDNFindSinks"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class SDNFindSources(object):
    def __init__(self):
        self.label       = "Find Sources on SDN"
        self.description = "Finds the Sources (nodes with only outgoing flow) on the Network."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_Level"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        parameters = [network_to_use, out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
               
        etFunction = "SDNFindSources"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class SDNCheckForLoops(object):
    def __init__(self):
        self.label       = "Check SDN for Loops"
        self.description = "Finds the Loops in a Single Direction Network."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_Level"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        parameters = [network_to_use, out_dataset]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
               
        etFunction = "SDNCheckForLoops"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,outDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class SDNDelineateCatchment(object):
    def __init__(self):
        self.label       = "Deliniate Catchments"
        self.description = "Identifies the Network links that contribute to each Sink point."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # Output Catchments parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Catchments",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polygon"
        # Add fields
        addFields = []
        fieldNames = ["ET_Zone"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # Output Sinks parameter
        out_sinks = arcpy.Parameter(
            displayName="Output Sinks",
            name="out_sinks",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_sinks.schema.clone = False
        out_sinks.schema.fieldsRule = "None"
        out_sinks.schema.geometryTypeRule = "AsSpecified"
        out_sinks.schema.geometryType = "Point"
        # Add fields
        addFields = []
        fieldNames = ["ET_ID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_sinks.schema.additionalFields = addFields

        # Input Break Points parameter
        in_break_points = arcpy.Parameter(
            displayName="Input Barrier Points Layer",
            name="in_break_points",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        in_break_points.filter.list = ["Point"]
        
        parameters = [network_to_use, out_dataset,out_sinks,in_break_points]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        sinkDataset = parameters[2].valueAsText
        
        breakPointDataset = parameters[3].valueAsText
        if not breakPointDataset:
             breakPointDataset = ""
        else:
             breakPointDataset  = arcpy.Describe(parameters[3].value).catalogPath
       
       
        etFunction = "SDNDelineateCatchment"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,outDataset,sinkDataset,breakPointDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class SDNTraverseNetwork(object):
    def __init__(self):
        self.label       = "Traverse Network"
        self.description = "Identifies the links contributing (Upstream) to or ."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # Input Points parameter
        in_points = arcpy.Parameter(
            displayName="Input Point Layer",
            name="in_points",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_points.filter.list = ["Point"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_OrgID"]
        fieldTypes = ["LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
        # search_tolerance parameter
        
        search_tolerance = arcpy.Parameter(
            displayName="Search Tolerance",
            name="search_tolerance",
            datatype="GPDouble",
            parameterType="Required",
            direction="Input")
            
        # direction
        direction = arcpy.Parameter(
            displayName="Direction",
            name="direction",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        direction.filter.type = "ValueList"
        direction.filter.list = ["Downstream", "Upstream"]
        direction.value = "Upstream"
        
        # Input Break Points parameter
        in_break_points = arcpy.Parameter(
            displayName="Input Barrier Points Layer",
            name="in_break_points",
            datatype="GPFeatureLayer",
            parameterType="Optional",
            direction="Input")
        in_break_points.filter.list = ["Point"]
        
        parameters = [network_to_use, in_points, out_dataset, search_tolerance,direction,in_break_points]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        pointDataset = arcpy.Describe(parameters[1].value).catalogPath
        outDataset = parameters[2].valueAsText
        dTol = parameters[3].valueAsText
        sDir = parameters[4].valueAsText
        
        breakPointDataset = parameters[5].valueAsText
        if not breakPointDataset:
             breakPointDataset = ""
        else:
             breakPointDataset  = arcpy.Describe(parameters[4].value).catalogPath
       
       
        etFunction = "SDNTraverseNetwork"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,pointDataset,outDataset,dTol,sDir,breakPointDataset],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return
        
class SDNClassifyStreams(object):
    def __init__(self):
        self.label       = "Classify Streams"
        self.description = "Classifies a stream network using Strahler or Shreve cassification method."
        self.category = "Network"
        
    def getParameterInfo(self):
    	  #network_to_use
        network_to_use = arcpy.Parameter(
            displayName="Network to use",
            name="network_to_use",
            datatype="DEFile",
            parameterType="Required",
            direction="Input")
        network_to_use.filter.list = ["etn"]
        
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source

        out_dataset.schema.clone = False
        out_dataset.schema.fieldsRule = "None"
        out_dataset.schema.geometryTypeRule = "AsSpecified"
        out_dataset.schema.geometryType = "Polyline"
        # Add fields
        addFields = []
        fieldNames = ["ET_Class","ET_OrgID"]
        fieldTypes = ["LONG","LONG"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
            
        # method
        method = arcpy.Parameter(
            displayName="Method",
            name="direction",
            datatype="GPString",
            parameterType="Required",
            direction="Input")
        method.filter.type = "ValueList"
        method.filter.list = ["Strahler", "Shreve"]
        method.value = "Strahler"
        
        parameters = [network_to_use, out_dataset, method]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                
        return

    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
        return

    def execute(self, parameters, messages):
        inNetwork = arcpy.Describe(parameters[0].value).catalogPath
        outDataset = parameters[1].valueAsText
        sMethod = parameters[4].valueAsText

        etFunction = "SDNClassifyStreams"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inNetwork,outDataset,sMethod],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return

class SelectAndFlip(object):
    def __init__(self):
        self.label       = "Select And Flip"
        self.description = "Selects the features from the input polyline layer based on a SQL expressions and flips the selected polylines."
        self.category = "Polylines"
        
    def getParameterInfo(self):
        # Input Features parameter
        in_dataset = arcpy.Parameter(
            displayName="Input Dataset",
            name="in_dataset",
            datatype="GPFeatureLayer",
            parameterType="Required",
            direction="Input")
        in_dataset.filter.list = ["Polyline"]
      
        # Output Features parameter
        out_dataset = arcpy.Parameter(
            displayName="Output Dataset",
            name="out_dataset",
            datatype="DEFeatureClass",
            parameterType="Required",
            direction="Output")
        # Copy definition from source
        out_dataset.parameterDependencies = [in_dataset.name]
        out_dataset.schema.clone = True
        out_dataset.schema.fieldsRule = "All"
                
        # Add fields
        addFields = []
        fieldNames = ["ET_Status"]
        fieldTypes = ["String"]
        for fieldInd, fieldName in enumerate(fieldNames):
            fieldType = fieldTypes[fieldInd]
            newField = arcpy.Field()
            newField.name = fieldName
            newField.type = fieldType
            addFields.append(newField)
        out_dataset.schema.additionalFields = addFields
        
         # select_expression parameter
        select_expression = arcpy.Parameter(
            displayName="Select Expression",
            name="select_expression",
            datatype="GPSQLExpression",
            parameterType="Required",
            direction="Input")
        select_expression.parameterDependencies = [in_dataset.name]
                         
        parameters = [in_dataset, out_dataset,select_expression]

        return parameters

    def isLicensed(self): #optional
        return True

    def updateParameters(self, parameters): #optional
                   
        return
    def updateMessages(self, parameters): #optional
        if not etFound()[0]:
             parameters[0].setErrorMessage("ET GeoWizards not installed!")
        else:
             parameters[0].clearMessage
             etgwPath = etFound()[1]
                                        
        return

    def execute(self, parameters, messages):
        inDataset  = arcpy.Describe(parameters[0].value).catalogPath
        outDataset  = parameters[1].valueAsText
        expression  = parameters[2].valueAsText
                                      
        etFunction = "SelectAndFlip"

        startupinfo = subprocess.STARTUPINFO() 
        startupinfo.dwFlags |= subprocess.STARTF_USESHOWWINDOW 
        retCode = subprocess.call([etgwPath,etFunction,inDataset,outDataset,expression],startupinfo=startupinfo)
        if retCode != 0:
            arcpy.AddError("An error "+str(retCode)+" ocurred! See ETGeoWizards.log file for details.")
        return